/*******************************************************************************
**
** The source file for the Jahshaka core model file
** The Jahshaka Project
** Copyright (C) 2000-2004 Visual Media, LLC.
** Released under the GNU General Public License
**
*******************************************************************************/

#include "coreobject.h"


void JahLayer::initVertexShader(int shader)
{

    static int 					count = 2;

    //debug(">><<initializing vertex shader");

    if (GLEW_NV_fragment_program && GLEW_NV_vertex_program)
    {
        //debug(">><<initialized vertex shader");

        unsigned char *data;
        float stage = 1.0;

        if (shader==1)
            data = loadshaderfile(JahBasePath+"jah/objectlibs/pixelshaders/program1.vp");
        if (shader==2)
            data = loadshaderfile(JahBasePath+"jah/objectlibs/pixelshaders/program2.vp");

        glGenProgramsNV(1,&program);
        glBindProgramNV(GL_VERTEX_PROGRAM_NV,program);
        glLoadProgramNV(GL_VERTEX_PROGRAM_NV,program, strlen((char*)data),data);

        glTrackMatrixNV(GL_VERTEX_PROGRAM_NV,0, GL_MODELVIEW_PROJECTION_NV,GL_IDENTITY_NV);

        glProgramParameter4fNV(GL_VERTEX_PROGRAM_NV,5,stage * 2, ((float)count / 3.0) - 0.50, count / 2, 16);

        delete data;

        count = (count == 16) ? 2 : count + 1;
    }
}

unsigned char * JahLayer::loadshaderfile(const char *name) {

    FILE*                       file; 
    int                         size;
    unsigned char*              data;

    file = fopen(name, "rb");

    if(!file) 
    { 
        fprintf(stderr, "JahLayer::loadshaderfile:: error loading %s file",name); 
        return NULL; 
    }

    fseek(file,0,SEEK_END);
    size = ftell(file);
    data = new unsigned char[size + 1];
    fseek(file,0,SEEK_SET);
    fread(data,1,size,file);
    data[size] = '\0';
    fclose(file);
    return data;
}



