/*******************************************************************************
**
** The header file for the Jahshaka render module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef RENDER_H
#define RENDER_H


#include <coreobject.h>
#include "interfaceheaders.h"
#include "jahpreferences.h"

#include "glew.h"

class JahLayer;

class JahRender {

public:
    JahRender(void);
    ~JahRender(void);

    MouseMode theToolMode;

    //object drawing routines
    void positionObject( motionNode * node );
    void drawLayer(JahLayer & layer);
    void drawNodes(JahLayer & layer);

    void makeObject( JahLayer & layer );
    void makeKey( JahLayer & layer );
    void makeLayerOutline( JahLayer & layer);

    //the current tool?
    void setToolMode(MouseMode);

};


#endif




