###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE    =   lib
CONFIG      +=  staticlib qt warn_on release opengl thread
HEADERS     =   glworld.h \
                glworldheaders.h \
                glworldlists.h \
                glworldeffects.h
SOURCES     =   glworld.cpp \
                glworldcontrols.cpp \
                glworldglcore.cpp \
                glworlddataio.cpp \
                glworlddataioutils.cpp \
                glworlddataload.cpp \
                glworlddatasave.cpp \
                glworldfeedback.cpp \
                glworldinterface.cpp \
                glworldlayer.cpp \
                glworldsliders.cpp \
                glworldlayerutils.cpp \
                glworldrender.cpp \
                glworldlists.cpp \
                glworldsort.cpp \
                glworldanimation.cpp \
                glworldeffect.cpp \
                glworldflags.cpp
TARGET = world
DEPENDPATH = $$JAHDEPENDPATH

###############################################################
#the project related includes
INCLUDEPATH =		. .. ../../Core/Objects ../../Core/Render ../../Core/World  \
			../../desktop
            
#files for spaceball on linux
contains( SPACEBALL,true ) {
INCLUDEPATH +=  ../../libraries/spaceball
}    

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
INCLUDEPATH +=  ../../encoders/mpegdec
}

#files for audiosupport
contains( JAHAUDIO,true ) {
INCLUDEPATH +=          ../../libraries/jahaudio
}

INCLUDEPATH +=          ../../Source \
                        ../../libraries \
                        ../../libraries/assetobject \
                        ../../libraries/GLCore \
                        ../../libraries/glew \
                        ../../libraries/imagelibs \
                        ../../libraries/jahkeyframes \
                        ../../libraries/jahpreferences \
                        ../../libraries/jahtranslate \
                        ../../libraries/jahtimer \
                        ../../libraries/jahtracer \
                        ../../libraries/mediaobject
                        
contains( SPACEBALL,true ) {
INCLUDEPATH     +=      ../../libraries/spaceball
}

INCLUDEPATH +=          ../../libraries/jahplugins \
                        ../../libraries/gpumathlib \
                        ../../libraries/jahdatabase \
                        ../../uiwidgets \
                        ../../uiwidgets/interfaceobjs \
                        ../../uiwidgets/jahcalc \
                        ../../uiwidgets/jahfileloader \
                        ../../uiwidgets/keyframes \
                        ../../uiwidgets/nodes \
                        ../../uiwidgets/timeline \
                        ../../objectlibs/FTGL \
                        ../../objectlibs/glmlib \
                        ../../objectlibs/l3ds \
                        ../../objectlibs/particle \
                        ../../objectlibs/blur \
                        ../../sqlite \
                        $$FREEDIR

contains( JAHOS,IRIX ) {
INCLUDEPATH += 		$$SGIDIR
}
			

