/*******************************************************************************
**
** The source file for the Jahshaka glworldcontrols.cpp file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"



////////////////////////////////////////////
// layer controls


//active layer controls here
void GLWorld::setXRotation( int degrees )
{ 
    static int lastdegree;

    if (activeLayer==0)
    {
        camera->node->rx = (GLfloat)(degrees);
    }
    else
    {
        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->rx += 5.0;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->rx -= 5.0;
            }
        }
        else
        {
        layerlist->at(activeLayer)->thelayer->node->rx = (GLfloat)(degrees );
        }

        lastdegree = degrees;
    }

    slidersHaveChanged = true;

    updateGL();
}

void GLWorld::setYRotation( int degrees )
{
    static int lastdegree;

    if (activeLayer==0)
    {
        camera->node->ry = (GLfloat)(degrees);
    }
    else
    {
        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->ry += 5.0;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->ry -= 5.0;
            }
        }
        else
        {
        layerlist->at(activeLayer)->thelayer->node->ry = (GLfloat)(degrees );
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();
}

void GLWorld::setZRotation( int degrees )
{
    static int lastdegree;

    if (activeLayer==0)
    {
        camera->node->rz = (GLfloat)(degrees);
    }
    else
    {
        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->rz += 5.0;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->rz -= 5.0;
            }
        }
        else
        {
        layerlist->at(activeLayer)->thelayer->node->rz = (GLfloat)(degrees );
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();
}



void GLWorld::setXTrans   ( int degrees )
{
    static int lastdegree;

    if (activeLayer==0)
    {
        camera->node->tx = (GLfloat)(degrees);
    }
    else
    {

        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->tx += 5.0;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->tx -= 5.0;
            }
        }
        else
        {
        layerlist->at(activeLayer)->thelayer->node->tx = (GLfloat)(degrees );
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();

}
void GLWorld::setYTrans   ( int degrees )
{
    static int lastdegree;

    if (activeLayer==0)
    {
        camera->node->ty = (GLfloat)(degrees);
    }
    else
    {

        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->ty += 5.0;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->ty -= 5.0;
            }
        }
        else
        {
        layerlist->at(activeLayer)->thelayer->node->ty = (GLfloat)(degrees );
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();
}
void GLWorld::setZTrans   ( int degrees )
{
    static int lastdegree;

    if (activeLayer==0)
    {
        camera->node->tz = (GLfloat)(degrees);
    }
    else
    {

        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->tz += 5.0;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->tz -= 5.0;
            }
        }
        else
        {
        layerlist->at(activeLayer)->thelayer->node->tz = (GLfloat)(degrees );
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();   
}

//default scale is 1 so things are different here
//as a value of 0 is no scaling...
float GLWorld::setScaleValue   ( int degree )
{
    float degrees = degree;

    GLfloat thescale;

    if (degree==0)
    {
        thescale=1;
    }
    else
    {
        thescale = 1.0 + (GLfloat)(degrees/100);
    }

    return thescale;

}

int GLWorld::getScaleValue   ( float degree )
{
    //still needs some debuging due to rounding errors...
    //QString rere;

    int theval;
    //debug("the val:"+rere.setNum(degree));
    if (degree==1)
    {
        theval = 0;
    }
    else
    {
        theval = -(int)((1-degree)*100);
        //debug("the val:"+rere.setNum(theval));

    }

    return theval;
}

void GLWorld::setXScale   ( int degrees )
{

    static int lastdegree;

    if (activeLayer==0)
    {
        //camera->node->tz = (GLfloat)(degrees);
    }
    else
    {
        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->sx += 0.1;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->sx -= 0.1;
            }
        }
        else
        {
            layerlist->at(activeLayer)->thelayer->node->sx = setScaleValue(degrees);
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();
}

void GLWorld::setYScale   ( int degrees )
{

    static int lastdegree;

    if (activeLayer==0)
    {
        //camera->node->tz = (GLfloat)(degrees);
    }
    else
    {

        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->sy += 0.1;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->sy -= 0.1;
            }
        }
        else
        {
            layerlist->at(activeLayer)->thelayer->node->sy = setScaleValue(degrees);
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();
}

void GLWorld::setZScale   ( int degrees )
{
    static int lastdegree;

    if (activeLayer==0)
    {
        //camera->node->tz = (GLfloat)(degrees);
    }
    else
    {
        if (multiSelect)
        {
            for (int x=0; x< activeLayers->getNumLayers(); x++)
            {
                int proclayer = activeLayers->getLayers(x);

                if (degrees>lastdegree) layerlist->at(proclayer)->thelayer->node->sz += 0.1;
                if (degrees<lastdegree) layerlist->at(proclayer)->thelayer->node->sz -= 0.1;
            }
        }
        else
        {
            layerlist->at(activeLayer)->thelayer->node->sz = setScaleValue(degrees);
        }

        lastdegree = degrees;
    }
    slidersHaveChanged = true;

    updateGL();


}

void GLWorld::setAlpha    ( int degrees )  
{ 
    layerlist->at(activeLayer)->thelayer->node->Alpha = (GLfloat)(degrees);

    slidersHaveChanged = true;

    updateGL();
}

void GLWorld::setZoom     ( int degrees )  
{ 
    camera->node->sc = (GLfloat)(degrees); updateGL();   
}


void GLWorld::setHBlur(int hb)
{
    updateEffect = true;

    layerlist->at(activeLayer)->thelayer->node->bx = (GLfloat)(hb);
    updateGL();
}

void GLWorld::setVBlur(int vb) 
{   
    updateEffect = true;

    layerlist->at(activeLayer)->thelayer->node->by = (GLfloat)(vb); 
    updateGL(); 
}    


//these were all layer 1 not activelayer...

void GLWorld::setExtrude  ( int degrees )  
{

    if (degrees<=0) degrees=0;

    layerlist->at(activeLayer)->thelayer->text->extrude = degrees;

    layerlist->at(activeLayer)->thelayer->makeText();

    updateGL(); 
}

void GLWorld::setKeyframeDrawStatus()
{

    if (activeLayer>0) layerlist->at(activeLayer)->thelayer->drawKeyframes =
        !layerlist->at(activeLayer)->thelayer->drawKeyframes;

    updateGL(); 
}

void GLWorld::setColor() 
{
    QColor newcolor;

    GLfloat redcolor, greencolor, bluecolor;

    QColor c = QColorDialog::getColor( newcolor, 0, 0 );

    QRgb thecolor=c.rgb();

    int r=qRed(thecolor);   
    if (r==0)  redcolor = 0.0;    else {  redcolor   = (r/255.0); }

    int g=qGreen(thecolor); 
    if (g==0)  greencolor = 0.0;  else {  greencolor = (g/255.0);  }

    int b=qBlue(thecolor);  
    if (b==0)  bluecolor  = 0.0;  else {  bluecolor  = (b/255.0);  }

    layerlist->at(activeLayer)->thelayer->Red = redcolor;
    layerlist->at(activeLayer)->thelayer->Blue = bluecolor;
    layerlist->at(activeLayer)->thelayer->Green = greencolor;

}


////////////////////////////////////////////
// layer video controls

//we need to add inframe and outframe or startslipframe and endslipframe

//if forceplay we update visuals here as well

void GLWorld::setinFrames      ( int frame )   
{

    layerlist->at(activeLayer)->thelayer->inframe    = frame;
    layerlist->at(activeLayer)->thelayer->outframe   = frame + layerlist->at(activeLayer)->thelayer->asset.getNumFrames();

    //is it possible to only update the layer and not the entire scene? no
    if (forceplay) { updateanimframe(controllerslider->value()); } else { updateGL();  }
    updateSliders();

}

void GLWorld::setoutFrames      ( int frame )   
{

    layerlist->at(activeLayer)->thelayer->outframe    = frame;
    layerlist->at(activeLayer)->thelayer->inframe     = frame - layerlist->at(activeLayer)->thelayer->asset.getNumFrames();

    if (forceplay) 
    { 
        updateanimframe(controllerslider->value()); 
    } 
    else 
    { 
        updateGL(); 
    }

    updateSliders();

}


///////////////////////////////////////
//change to key in and key out as well

void GLWorld::setinKeyFrames      ( int frame )   
{

    layerlist->at(activeLayer)->thelayer->keystartframe = frame;
    layerlist->at(activeLayer)->thelayer->keyendframe   = frame + layerlist->at(activeLayer)->thelayer->keyasset.getNumFrames();

    if (forceplay) updateanimframe(controllerslider->value()); else updateGL();
    updateSliders();

}

void GLWorld::setoutKeyFrames      ( int frame )   
{

    layerlist->at(activeLayer)->thelayer->keystartframe = frame;
    layerlist->at(activeLayer)->thelayer->keyendframe   = frame - layerlist->at(activeLayer)->thelayer->keyasset.getNumFrames();

    if (forceplay) 
    { 
        updateanimframe(controllerslider->value()); 
    } 
    else 
    { 
        updateGL(); 
    }
    updateSliders();

}











