/*******************************************************************************
**
** The source file for the Jahshaka glworld dataio code
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/


#include "glworld.h"
#include "qfile.h"
#include <qfiledialog.h>

#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qprinter.h>
//#include <qapplication.h>
#include <qaccel.h>

#include <qpainter.h>
#include <qpaintdevicemetrics.h>


void GLWorld::SaveAllData(QFile & f) 
{

    QString text;
    QTextStream t( &f );

    for (int i=0; i<=numberLayers; i++) 
    {

    if ( layerlist->at(i) )
    {  

        text = JahParse("Info for Layer:",i);   text += "\n"; t << text;
        text = JahParse("Stored layer name:",layerlist->at(i)->thelayer->layername);    text += "\n"; t << text;

        text = JahParse("Stored blend settings:",layerlist->at(i)->thelayer->blend);  text += "\n"; t << text;
        text = JahParse("Stored depth settings:",layerlist->at(i)->thelayer->depth);  text += "\n"; t << text;
        text = JahParse("Stored cull settings:",layerlist->at(i)->thelayer->cull);    text += "\n"; t << text;
        text = JahParse("Stored lighting settings:",layerlist->at(i)->thelayer->lighting);    text += "\n"; t << text;
        text = JahParse("Stored foreground settings:",layerlist->at(i)->thelayer->foreground);    text += "\n"; t << text;
        text = JahParse("Stored smooth settings:",layerlist->at(i)->thelayer->smooth);    text += "\n"; t << text;
        text = JahParse("Stored reflect settings:",layerlist->at(i)->thelayer->reflect);    text += "\n"; t << text;

        //used for layer effects
        text = JahParse("Stored layer effects:",layerlist->at(i)->thelayer->layerEffect);    text += "\n"; t << text;

        if (layerlist->at(i)->thelayer->layerEffect)
        {
            text = JahParse("Stored layer effect negative:",layerlist->at(i)->thelayer->negative);    text += "\n"; t << text;
            text = JahParse("Stored layer effect swap:",layerlist->at(i)->thelayer->swaprgb);    text += "\n"; t << text;
            text = JahParse("Stored layereffect mirror:",layerlist->at(i)->thelayer->mirror);    text += "\n"; t << text;    
            text = JahParse("Stored layer effect blur:",layerlist->at(i)->thelayer->blur);    text += "\n"; t << text;    
            text = JahParse("Stored layer effect blurx:",layerlist->at(i)->thelayer->blur);    text += "\n"; t << text;    
            text = JahParse("Stored layer effect blury:",layerlist->at(i)->thelayer->blur);    text += "\n"; t << text;    
        }

        //used for keys
        text = JahParse("Stored key invert:",layerlist->at(i)->thelayer->invertKey);    text += "\n"; t << text;
        text = JahParse("draw the key:",layerlist->at(i)->thelayer->drawtheKey);    text += "\n"; t << text;
        text = JahParse("key status:",layerlist->at(i)->thelayer->keyAssetStatus);    text += "\n"; t << text;

        //for layer activation
        text = JahParse("Stored layer is activated:",layerlist->at(i)->thelayer->layerStatus);  text += "\n"; t << text; //is it on or off...

        text = JahParse("LayerInfo:");   text += "\n"; t << text;

        text = JahParse("Stored layer type is:",layerlist->at(i)->thelayer->layertype);  text += "\n"; t << text;
        int LayerCode; LayerCode = (int)layerlist->at(i)->thelayer->layertype;
        text = JahParse("Stored layer code:",LayerCode);    text += "\n"; t << text;

        text = JahParse("Stored layer is a:",layerlist->at(i)->thelayer->objtype);  text += "\n"; t << text;
        int ObjCode; ObjCode = (int)layerlist->at(i)->thelayer->objtype;
        text = JahParse("Stored layer code:",ObjCode);    text += "\n"; t << text;


        //now write the objects information out
        switch ( LayerCode ) {

            case LAYER        :     {
                                        //break this out into its own subroutine like the others
                                        if (ObjCode==BACKDROP) {
                                            //need to save special options for backdrop such as gridstatus, selection status
                                            text = JahParse("Stored grid setting:",gridval);    text += "\n"; t << text;
                                            text = JahParse("Stored aliasing:",polySmooth);    text += "\n"; t << text;
                                            text = JahParse("Stored text safe:",textsafe->layerStatus);    text += "\n"; t << text;

                                            if (layerlist->at(i)->thelayer->layerAssetStatus)
                                            {  
                                                text = ":"; text += "\n";   
                                                t << text; 
                                                //SaveImageData(f,i); 
                                                SaveAsset(f,i); 
                                            }
                                            else { text = "&"; text += "\n";   t << text;  }

                                            SaveNodes(f,0);

                                        } 
                                        else 
                                        { //its any other object

                                        if (ModuleName=="Effects" || ModuleName=="Colorize")
                                        {
                                            //if (layerlist->at(i)->thelayer->layer)
                                            //{  
                                                if (i==1) 
                                                {
                                                    text = ":"; text += "\n";   t << text;
                                                    SaveAsset(f,i);
                                                }
                                                if (i>0)
                                                {
                                                    text = ":"; text += "\n";  t << text;
                                                    SaveNodes(f,i);
                                                    if (i>1)
                                                    {
                                                        text = ":"; text += "\n";  t << text; 
                                                        SaveEffect(f,i);
                                                    }
                                                }
                                            //}
                                        }
                                        else
                                        {
                                            if (layerlist->at(i)->thelayer->layerAssetStatus)
                                            {  
                                                text = ":"; text += "\n";   t << text; 
                                                SaveAsset(f,i); 
                                            }
                                            else 
                                            { 
                                                text = "&"; text += "\n";   t << text;  
                                            }
                                            //need to use a better flag here
                                            //ie is there a key?
                                            //if (layerlist->at(i)->thelayer->key)
                                            if (layerlist->at(i)->thelayer->keyAssetStatus)
                                            //if (layerlist->at(i)->thelayer->drawtheKey)
                                            { 
                                                text = ":"; text += "\n";   t << text;
                                                SaveKeyAsset(f,i); 
                                            }
                                            else 
                                            { 
                                                text = "&"; text += "\n";   t << text;  
                                            }

                                            SaveNodes(f,i);
                                            }
                                        }

                                    break; }

            case PARTICLE     :     {

                                        if (layerlist->at(i)->thelayer->layerAssetStatus)
                                        { 
                                        text = ":"; text += "\n";   t << text; 
                                        SaveAsset(f,i);   
                                        }
                                        else { text = "&"; text += "\n";   t << text;  }

                                        SaveParticleData(f,i);
                                        SaveNodes(f,i);


                                    break; }	

            case OBJECTS      :     {

                                        if (layerlist->at(i)->thelayer->layerAssetStatus)
                                        { 
                                        text = ":"; text += "\n";   t << text;   
                                        SaveAsset(f,i); 
                                        }
                                        else { text = "&"; text += "\n";   t << text;  }

                                        SaveObjectData(f,i);
                                        SaveNodes(f,i);

                                    break; }

            case FRAME        :     {   break;  }

            case TEXT         :     {

                                        if (layerlist->at(i)->thelayer->layerAssetStatus)
                                        { 
                                            text = ":"; text += "\n";   t << text;   
                                            SaveAsset(f,i); 
                                        }
                                        else { text = "&"; text += "\n";   t << text;  }

                                        SaveColor(f,i);
                                        SaveText(f,i);
                                        SaveNodes(f,i);

                                        break;
                                    }

            case GRID         :     {   break; }

            default           :     {   break; }

        }

        text = JahParse("------------------------------");  text += "\n"; t << text;
        }
    }

}  // save scene files to disk




///////////////////////////////////////////////////////////////
// file save routine
//needs to be working!

void GLWorld::SaveObjectData(QFile & file, int i) 
{
        QString text;  QTextStream os( &file );

        text=JahParse("Stored layer is object:");  text += "\n";   os << text; //is it on or off...
        text=JahParse("Stored layer object name:",layerlist->at(i)->thelayer->objfilename); text += "\n";   os << text;
        text=JahParse("Stored layer object extension:",layerlist->at(i)->thelayer->objextension);   text += "\n";   os << text;

} 

void GLWorld::SaveEffect(QFile & file, int i)
{
        QString text;  QTextStream os( &file );

        int fxtype = effects->at(i)->fxlayer->objtype;
        text=JahParse("Effect type is:",fxtype);  text += "\n";   os << text; //is it on or off...

        //to be fixed asap
        //if type==0 its a plugin...
        //but if its a plugin for loading
        //we cant go off the plugin 'number' incase the plugin list changes
        //we have to iterate the plugin list
        //and match the plugin name

        if (effects->at(i)->fxlayer->objtype==0)
        {
            int plugnum = effects->at(i)->fxlayer->pluginnumber;
            text=JahParse("Plugin number is:",plugnum);  text += "\n";   os << text; //is it on or off...
        }


        text=JahParse("Effect num  is:",effects->at(i)->fxlayer->effectnumber);  
        text += "\n";   os << text; 

        text=JahParse("Effect name is:",layerlist->at(i)->thelayer->layername);
        text += "\n";   os << text;

        text=JahParse("Effect is selected:",effects->at(i)->fxlayer->selected);  
        text += "\n";   os << text; 

        text=JahParse("Effect status is:",effects->at(i)->fxlayer->layerStatus);  
        text += "\n";   os << text;

        text=JahParse("Effect is on is:",effects->at(i)->fxlayer->isOn);
        text += "\n";   os << text; 

        //the effects options
        text=JahParse("Effect option1 is:",layerlist->at(i)->thelayer->option1);
        text += "\n";   os << text;
        text=JahParse("Effect option2 is:",layerlist->at(i)->thelayer->option2);
        text += "\n";   os << text;
        text=JahParse("Effect option3 is:",layerlist->at(i)->thelayer->option3);
        text += "\n";   os << text;
        text=JahParse("Effect option4 is:",layerlist->at(i)->thelayer->option4);
        text += "\n";   os << text;

        //currently a global on layer 1 for effects but soon to be a per effect option
        text=JahParse("gpueffects active is:",layerlist->at(1)->thelayer->usedagpu);
        text += "\n";   os << text;


}  





void GLWorld::SaveParticleData(QFile & file, int i) {
        QString text;  QTextStream os( &file );

        text=JahParse("Stored layer is particle:");  text += "\n";   os << text; //is it on or off...

        int parstyle; parstyle = (int)layerlist->at(i)->thelayer->ParticleStyle;
        text=JahParse("Stored layer particle type:",parstyle); text += "\n";   os << text;

        int pardraw; pardraw = (int)layerlist->at(i)->thelayer->ParticleDraw;
        text=JahParse("Stored layer particle type:",pardraw); text += "\n";   os << text;

        int parcolor; parcolor = (int)layerlist->at(i)->thelayer->ParticleColors;
        text=JahParse("Stored layer particle type:",parcolor); text += "\n";   os << text;

}  // save scene files to disk

void GLWorld::SaveImageData( QFile & file, int i) {}  // save scene files to disk

void GLWorld::SaveImageKeyData(QFile & file, int i) 
{
        QString text;  QTextStream os( &file );

        int thedata; 

        thedata = (int)layerlist->at(i)->thelayer->drawtheKey;
        text=JahParse("Key status:",thedata); text += "\n";   os << text;

        thedata = (int)layerlist->at(i)->thelayer->invertKey;
        text=JahParse("Key invert:",thedata); text += "\n";   os << text;

}  // save scene files to disk

//we are going to have to loop through these later on
//so we can restore multiple kekframes

void GLWorld::SaveNodes(QFile & file,int i) {

    //updateNodes(int currentFrame)


    QString text;  QTextStream os( &file );

if (i>0) {

    text=JahParse("Stored layer numnodes:",layerlist->at(i)->thelayer->layernodes->numnodes);  text += "\n";   os << text;

    if ( layerlist->at(i)->thelayer->layernodes->numnodes > 0 ) {
    //debug("layer");
        for (int x=0; x<layerlist->at(i)->thelayer->layernodes->numnodes; x++) {

    //QString key="0"; key.setNum(layerlist->at(i)->thelayer->nodes[x]->nodenum); text=JahParse("NN:"+key);  text += "\n";   os << text;
    QString key="0"; 
    key.setNum(layerlist->at(i)->thelayer->layernodes->nodelist->at(x)->nodenum); 
    text=JahParse("NN:"+key);  text += "\n";   os << text;

    layerlist->at(i)->thelayer->updateNodes(  layerlist->at(i)->thelayer->layernodes->nodelist->at(x)->nodenum  );

    QString nsx="0"; nsx.setNum(layerlist->at(i)->thelayer->node->sx);     text=JahParse("SX:"+nsx);  text += "\n";   os << text;
    QString nsy="0"; nsy.setNum(layerlist->at(i)->thelayer->node->sy);     text=JahParse("SY:"+nsy);  text += "\n";   os << text;
    QString nsz="0"; nsz.setNum(layerlist->at(i)->thelayer->node->sz);     text=JahParse("SZ:"+nsz);  text += "\n";   os << text;

    QString ntx="0"; ntx.setNum(layerlist->at(i)->thelayer->node->tx);     text=JahParse("TX:"+ntx);  text += "\n";   os << text;
    QString nty="0"; nty.setNum(layerlist->at(i)->thelayer->node->ty);     text=JahParse("TY:"+nty);  text += "\n";   os << text;
    QString ntz="0"; ntz.setNum(layerlist->at(i)->thelayer->node->tz);     text=JahParse("TZ:"+ntz);  text += "\n";   os << text;

    QString nrx="0"; nrx.setNum(layerlist->at(i)->thelayer->node->rx);     text=JahParse("RX:"+nrx);  text += "\n";   os << text;
    QString nry="0"; nry.setNum(layerlist->at(i)->thelayer->node->ry);     text=JahParse("RY:"+nry);  text += "\n";   os << text;
    QString nrz="0"; nrz.setNum(layerlist->at(i)->thelayer->node->rz);     text=JahParse("RZ:"+nrz);  text += "\n";   os << text;

    QString nra="0"; nra.setNum(layerlist->at(i)->thelayer->node->Alpha);  text=JahParse("AL:"+nra);  text += "\n";   os << text;

}

    } else {

//if (i>0) {
    //problem here if layer has no keyframes...
        QString key="0"; key.setNum(0); text=JahParse("NN:"+key);  text += "\n";   os << text;
        //QString key="0"; key.setNum(layerlist->at(i)->thelayer->nodes[0]->nodenum); text=JahParse("NN:"+key);  text += "\n";   os << text;
    //debug("backdrop");
        QString nsx="0"; nsx.setNum(layerlist->at(i)->thelayer->node->sx);     text=JahParse("SX:"+nsx);  text += "\n";   os << text;
        QString nsy="0"; nsy.setNum(layerlist->at(i)->thelayer->node->sy);     text=JahParse("SY:"+nsy);   text += "\n";   os << text;
        QString nsz="0"; nsz.setNum(layerlist->at(i)->thelayer->node->sz);     text=JahParse("SZ:"+nsz);    text += "\n";   os << text;

        QString ntx="0"; ntx.setNum(layerlist->at(i)->thelayer->node->tx);     text=JahParse("TX:"+ntx);  text += "\n";   os << text;
        QString nty="0"; nty.setNum(layerlist->at(i)->thelayer->node->ty);     text=JahParse("TY:"+nty);  text += "\n";   os << text;
        QString ntz="0"; ntz.setNum(layerlist->at(i)->thelayer->node->tz);     text=JahParse("TZ:"+ntz);  text += "\n";   os << text;

        QString nrx="0"; nrx.setNum(layerlist->at(i)->thelayer->node->rx);     text=JahParse("RX:"+nrx);  text += "\n";   os << text;
        QString nry="0"; nry.setNum(layerlist->at(i)->thelayer->node->ry);     text=JahParse("RY:"+nry);  text += "\n";   os << text;
        QString nrz="0"; nrz.setNum(layerlist->at(i)->thelayer->node->rz);     text=JahParse("RZ:"+nrz);  text += "\n";   os << text;

        QString nra="0"; nra.setNum(layerlist->at(i)->thelayer->node->Alpha);  text=JahParse("AL:"+nra);  text += "\n";   os << text;
}

}
//0 is the camera
else {

    text=JahParse("Stored layer numnodes:",camera->layernodes->numnodes);  text += "\n";   os << text;

    if ( camera->layernodes->numnodes > 0 ) {
    //debug("layer");
        for (int x=0; x<camera->layernodes->numnodes; x++) {

    QString key="0"; 
    key.setNum(camera->layernodes->nodelist->at(x)->nodenum); 
    text=JahParse("NN:"+key);  text += "\n";   os << text;

    camera->updateNodes(  camera->layernodes->nodelist->at(x)->nodenum  );

    QString nsx="0"; nsx.setNum(camera->node->sx);     text=JahParse("SX:"+nsx);  text += "\n";   os << text;
    QString nsy="0"; nsy.setNum(camera->node->sy);     text=JahParse("SY:"+nsy);  text += "\n";   os << text;
    QString nsz="0"; nsz.setNum(camera->node->sz);     text=JahParse("SZ:"+nsz);  text += "\n";   os << text;

    QString ntx="0"; ntx.setNum(camera->node->tx);     text=JahParse("TX:"+ntx);  text += "\n";   os << text;
    QString nty="0"; nty.setNum(camera->node->ty);     text=JahParse("TY:"+nty);  text += "\n";   os << text;
    QString ntz="0"; ntz.setNum(camera->node->tz);     text=JahParse("TZ:"+ntz);  text += "\n";   os << text;

    QString nrx="0"; nrx.setNum(camera->node->rx);     text=JahParse("RX:"+nrx);  text += "\n";   os << text;
    QString nry="0"; nry.setNum(camera->node->ry);     text=JahParse("RY:"+nry);  text += "\n";   os << text;
    QString nrz="0"; nrz.setNum(camera->node->rz);     text=JahParse("RZ:"+nrz);  text += "\n";   os << text;

    QString nra="0"; nra.setNum(camera->node->Alpha);  text=JahParse("AL:"+nra);  text += "\n";   os << text;

}

    } else {

//if (i>0) {
    //problem here if layer has no keyframes...
        QString key="0"; key.setNum(0); text=JahParse("NN:"+key);  text += "\n";   os << text;
        //QString key="0"; key.setNum(camera->nodes[0]->nodenum); text=JahParse("NN:"+key);  text += "\n";   os << text;
    //debug("backdrop");
        QString nsx="0"; nsx.setNum(camera->node->sx);     text=JahParse("SX:"+nsx);  text += "\n";   os << text;
        QString nsy="0"; nsy.setNum(camera->node->sy);     text=JahParse("SY:"+nsy);   text += "\n";   os << text;
        QString nsz="0"; nsz.setNum(camera->node->sz);     text=JahParse("SZ:"+nsz);    text += "\n";   os << text;

        QString ntx="0"; ntx.setNum(camera->node->tx);     text=JahParse("TX:"+ntx);  text += "\n";   os << text;
        QString nty="0"; nty.setNum(camera->node->ty);     text=JahParse("TY:"+nty);  text += "\n";   os << text;
        QString ntz="0"; ntz.setNum(camera->node->tz);     text=JahParse("TZ:"+ntz);  text += "\n";   os << text;

        QString nrx="0"; nrx.setNum(camera->node->rx);     text=JahParse("RX:"+nrx);  text += "\n";   os << text;
        QString nry="0"; nry.setNum(camera->node->ry);     text=JahParse("RY:"+nry);  text += "\n";   os << text;
        QString nrz="0"; nrz.setNum(camera->node->rz);     text=JahParse("RZ:"+nrz);  text += "\n";   os << text;

        QString nra="0"; nra.setNum(camera->node->Alpha);  text=JahParse("AL:"+nra);  text += "\n";   os << text;
}


}

}  // save scene files to disk



void GLWorld::SaveColor(QFile & file,int i) {
    QString text;  QTextStream os( &file );

    QString red; red.setNum(layerlist->at(i)->thelayer->Red);         text=JahParse("Red:"+red);  text += "\n";   os << text;
    QString green; green.setNum(layerlist->at(i)->thelayer->Green);   text=JahParse("Green:"+green);  text += "\n";   os << text;
    QString blue; blue.setNum(layerlist->at(i)->thelayer->Blue);      text=JahParse("Blue:"+blue);  text += "\n";   os << text;


}  // save scene files to disk


void GLWorld::SaveText(QFile & file,int i) {
    QString text;  QTextStream os( &file );

    text=JahParse("Stored text is:",layerlist->at(i)->thelayer->text->text);  text += "\n";   os << text;
    text=JahParse("Stored font is:",layerlist->at(i)->thelayer->text->font);  text += "\n";   os << text;
    text=JahParse("Stored font type is:",(int)layerlist->at(i)->thelayer->text->fontstyle);  text += "\n";   os << text;

    QString depth; depth.setNum(layerlist->at(i)->thelayer->text->extrude);
    text=JahParse("Extrude depth:",depth);                   text += "\n";   os << text;

}  // save scene files to disk

void GLWorld::SaveAsset(QFile & file,int i)
{
    QString text;  QTextStream t( &file );

    //save the asset data here
    text=JahParse("Stored layer status:",layerlist->at(i)->thelayer->layerAssetStatus);   text += "\n";   t << text;//is it on or off...


    text = JahParse("Asset category is:",layerlist->at(i)->thelayer->asset.theCategory);  text += "\n"; t << text;
    int LayerCode; LayerCode = (int)layerlist->at(i)->thelayer->asset.theCategory;
    text = JahParse("Stored asset code:",LayerCode);    text += "\n"; t << text;

    text = JahParse("Asset type is:",layerlist->at(i)->thelayer->asset.theType);  text += "\n"; t << text;
    int LayerType; LayerType = (int)layerlist->at(i)->thelayer->asset.theType;
    text = JahParse("Stored asset code:",LayerType);    text += "\n"; t << text;

    text = JahParse("Clipname is:",layerlist->at(i)->thelayer->asset.clipname);  text += "\n"; t << text;
    text = JahParse("clipnumber is:",layerlist->at(i)->thelayer->asset.clipnumber);  text += "\n"; t << text;
    text = JahParse("location is:",layerlist->at(i)->thelayer->asset.location);  text += "\n"; t << text;
    text = JahParse("filename is:",layerlist->at(i)->thelayer->asset.filename);  text += "\n"; t << text;

    text = JahParse("extension is:",layerlist->at(i)->thelayer->asset.extension);  text += "\n"; t << text;
    text = JahParse("startframe is:",layerlist->at(i)->thelayer->asset.startframe);  text += "\n"; t << text;
    text = JahParse("endframe is:",layerlist->at(i)->thelayer->asset.endframe);  text += "\n"; t << text;
    text = JahParse("videoext is:",layerlist->at(i)->thelayer->asset.videoext);  text += "\n"; t << text;

    //text = JahParse("videoextkey is:",layerlist->at(i)->thelayer->asset.videoextkey);  text += "\n"; t << text;
    text = JahParse("videotex is:",layerlist->at(i)->thelayer->asset.videotex);  text += "\n"; t << text;

    //this is not asset data here but is used for video slip and shold be stored in the asset
    if (layerlist->at(i)->thelayer->asset.videotex) 
    { 
        text = JahParse("Inframe:",layerlist->at(i)->thelayer->inframe);  text += "\n";   t << text;                  
        text = JahParse("Outframe:",layerlist->at(i)->thelayer->outframe);    text += "\n";   t << text;
        text = JahParse("toggleends:",layerlist->at(i)->thelayer->showEdges);    text += "\n";   t << text;

        text = JahParse("loop:",layerlist->at(i)->thelayer->loop);    text += "\n";   t << text;
        text = JahParse("ping:",layerlist->at(i)->thelayer->ping);    text += "\n";   t << text;
    }

    //this is not really needed as its only for the desktop
    //but we need to set it to 0...    
    text = JahParse("xpos is:",(int)layerlist->at(i)->thelayer->asset.xpos);  text += "\n"; t << text;
    text = JahParse("ypos is:",(int)layerlist->at(i)->thelayer->asset.ypos);  text += "\n"; t << text;


}  // save scene files to disk

void GLWorld::SaveKeyAsset(QFile & file,int i) 
{
    QString text;  QTextStream t( &file );

    //save the asset data here
    //text=JahParse("Stored layer status:",layerlist->at(i)->thelayer->layer);   text += "\n";   t << text;//is it on or off...


    text = JahParse("Asset category is:",layerlist->at(i)->thelayer->keyasset.theCategory);  text += "\n"; t << text;
    int LayerCode; LayerCode = (int)layerlist->at(i)->thelayer->keyasset.theCategory;
    text = JahParse("Stored asset code:",LayerCode);    text += "\n"; t << text;

    text = JahParse("Asset type is:",layerlist->at(i)->thelayer->keyasset.theType);  text += "\n"; t << text;
    int LayerType; LayerType = (int)layerlist->at(i)->thelayer->keyasset.theType;
    text = JahParse("Stored asset code:",LayerType);    text += "\n"; t << text;


    text = JahParse("Clipname is:",layerlist->at(i)->thelayer->keyasset.clipname);  text += "\n"; t << text;
    text = JahParse("clipnumber is:",layerlist->at(i)->thelayer->keyasset.clipnumber);  text += "\n"; t << text;
    text = JahParse("location is:",layerlist->at(i)->thelayer->keyasset.location);  text += "\n"; t << text;
    text = JahParse("filename is:",layerlist->at(i)->thelayer->keyasset.filename);  text += "\n"; t << text;

    text = JahParse("extension is:",layerlist->at(i)->thelayer->keyasset.extension);  text += "\n"; t << text;
    text = JahParse("startframe is:",layerlist->at(i)->thelayer->keyasset.startframe);  text += "\n"; t << text;
    text = JahParse("endframe is:",layerlist->at(i)->thelayer->keyasset.endframe);  text += "\n"; t << text;
    text = JahParse("videoext is:",layerlist->at(i)->thelayer->keyasset.videoext);  text += "\n"; t << text;

    text = JahParse("videotex is:",layerlist->at(i)->thelayer->keyasset.videotex);  text += "\n"; t << text;

    //this is not asset data here but is used for video slip and shold be stored in the asset
    if (layerlist->at(i)->thelayer->keyasset.videotex) 
    { 
    text = JahParse("Inframe:",layerlist->at(i)->thelayer->keyinframe);  text += "\n";   t << text;                  
    text = JahParse("Outframe:",layerlist->at(i)->thelayer->keyoutframe);    text += "\n";   t << text;
    }

    text = JahParse("xpos is:",(int)layerlist->at(i)->thelayer->keyasset.xpos);  text += "\n"; t << text;
    text = JahParse("ypos is:",(int)layerlist->at(i)->thelayer->keyasset.ypos);  text += "\n"; t << text;


}  // save scene files to disk


