/*******************************************************************************
**
** The header file for the Jahshaka glworld module 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef GLWORLDEFFECTS_H
#define GLWORLDEFFECTS_H

////////////////////////////////////////////////////////////
//the effect layer class

//can we move these into the effects routine?
enum FxCategory        { JAHPLUGIN, TRANSLATE, NOFX, NEGATIVE, GREY, EDGE, SELECTCOLORS, CONTRAST,
                         BRIGHTNESS, FISHEYE, MATRIXSHARPEN, MATRIXBLUR, MATRIXEMBOSS,
                        EARTHQUAKE_NV30_GPU, FIRE3D_NV30_GPU,CHARCOAL_NV30_GPU, LIGHTING_NV30_GPU,

#ifdef NVIDIA_GPGPU
                        FISHEYE_NV30_GPGPU, SWIRL_NV30_GPGPU,
#endif // NVIDIA_GPGPU

                        FISHEYERT, SWIRLRT, RIPPLERT, FLAGRT, CONTRASTRT, POLAR,
                        FLARES, GAUSSIANBLUR, BLUR, SHARPEN, COLORMATRIX, MIRROR, RADIALINES, 
                        SWAPRGB, RTCOLORS };

class effectLayer {

public:
    effectLayer(void)
    {
        objtype = NOFX;
    };
    ~effectLayer(void) {};

    int         effectnumber;
    QString     effectname;

    FxCategory  objtype;

    bool        selected;
    bool        layerStatus;
    bool        isOn;
    GLfloat     x,y,z;
    GLfloat     r;

    //added this for plugins
    int         pluginnumber;
};


#endif // GLWORLD_H




















































