/*******************************************************************************
**
** The source file for the Jahshaka glworldlayer.cpp module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"

////////////////////////////////////////////////////
// functions thats used bu the ui to set core flags


////////////////////////////////////////
// Toggle and Set routines

void GLWorld::nameLayer(void) 
{  
    namepopup->popup(NameButton); 
}

void GLWorld::setlayerName(QString name) 
{
    //cant rename the world mon
    if (activeLayer == 0) return;
    //check also if -1 means nothing is selected

    QListViewItem * rasta;
    rasta = lv->currentItem();

    rasta->setText ( 0,name);
    lv->repaint(rasta);

    layerlist->at(activeLayer)->thelayer->layername = name;

}

void GLWorld::setGrid()   
{ 
    //toggle the grid value
    gridval = !gridval; 
    
    updateGL(); 
}

void GLWorld::setSmooth()
{
    //we only toggle this on if the hardware supports it
    if (HWALIASING)
        hwaliasing = !hwaliasing;

    updateGL();
}

void GLWorld::setNegative() 
{   
    updateEffect = true;
    
    layerlist->at(activeLayer)->thelayer->negative =  !layerlist->at(activeLayer)->thelayer->negative; 
    
    if (layerlist->at(activeLayer)->thelayer->negative || layerlist->at(activeLayer)->thelayer->swaprgb || layerlist->at(activeLayer)->thelayer->mirror || layerlist->at(activeLayer)->thelayer->blur ) 
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=true;
    }
    else
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=false;
        buildLayerEffect(activeLayer);
                
        
    }
    
    //need to update texture before turning off...
    
    
    updateGL(); 
    //debug("set blur and updateGL");
}    //for motionblur not implemented yet...

void GLWorld::setRGB() 
{   
    updateEffect = true;
    
    layerlist->at(activeLayer)->thelayer->swaprgb =  !layerlist->at(activeLayer)->thelayer->swaprgb; 
    
    if (layerlist->at(activeLayer)->thelayer->negative || layerlist->at(activeLayer)->thelayer->swaprgb || layerlist->at(activeLayer)->thelayer->mirror || layerlist->at(activeLayer)->thelayer->blur ) 
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=true;
    }
    else
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=false;
    }
    
    updateGL(); 
    //debug("set blur and updateGL");
}    //for motionblur not implemented yet...

void GLWorld::setMirror() 
{   
    updateEffect = true;
    
    layerlist->at(activeLayer)->thelayer->mirror =  !layerlist->at(activeLayer)->thelayer->mirror; 
    
     if (layerlist->at(activeLayer)->thelayer->negative || layerlist->at(activeLayer)->thelayer->swaprgb || layerlist->at(activeLayer)->thelayer->mirror || layerlist->at(activeLayer)->thelayer->blur ) 
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=true;
    }
    else
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=false;
    }
    
    updateGL(); 
    //debug("set blur and updateGL");
}    //for motionblur not implemented yet...

void GLWorld::setBlur() 
{   
    updateEffect = true;

    layerlist->at(activeLayer)->thelayer->blur =  !layerlist->at(activeLayer)->thelayer->blur; 
    
    if (layerlist->at(activeLayer)->thelayer->negative || layerlist->at(activeLayer)->thelayer->swaprgb || layerlist->at(activeLayer)->thelayer->mirror || layerlist->at(activeLayer)->thelayer->blur ) 
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=true;
    }
    else
    { 
        layerlist->at(activeLayer)->thelayer->layerEffect=false;
    }
    
    updateGL(); 
    debug("set blur and updateGL");
}    //for motionblur not implemented yet...



void GLWorld::setTextSafe() 
{  
    textsafe->layerStatus =  !textsafe->layerStatus; 
    updateGL(); 
}

void GLWorld::toggleForegroundStatus() 
{  
    layerlist->at(activeLayer)->thelayer->foreground =  !layerlist->at(activeLayer)->thelayer->foreground; 
    updateGL(); 
}

void GLWorld::toggleDepthStatus() 
{  
    layerlist->at(activeLayer)->thelayer->depth =  !layerlist->at(activeLayer)->thelayer->depth; 
    updateGL(); 
}

void GLWorld::toggleLight(void)   
{ 
    layerlist->at(activeLayer)->thelayer->lighting = !layerlist->at(activeLayer)->thelayer->lighting; 
    updateGL(); 
}

void GLWorld::toggleMesh(void)    
{ 
    layerlist->at(activeLayer)->thelayer->ObjectDisplayMode = !layerlist->at(activeLayer)->thelayer->ObjectDisplayMode; 
    updateGL(); 
}

void GLWorld::toggleReflect(void) 
{ 
    layerlist->at(activeLayer)->thelayer->reflect = !layerlist->at(activeLayer)->thelayer->reflect; 
    updateGL(); 
}

void GLWorld::toggleSmooth(void) 
{ 
    layerlist->at(activeLayer)->thelayer->smooth = !layerlist->at(activeLayer)->thelayer->smooth; 
    updateGL(); 
}

void GLWorld::toggleShader1(void)
{
    layerlist->at(activeLayer)->thelayer->pixelshader = !layerlist->at(activeLayer)->thelayer->pixelshader;
    layerlist->at(activeLayer)->thelayer->initVertexShader(1);
    updateGL();

}

void GLWorld::toggleShader2(void)
{
    layerlist->at(activeLayer)->thelayer->pixelshader = !layerlist->at(activeLayer)->thelayer->pixelshader;
    layerlist->at(activeLayer)->thelayer->initVertexShader(2);
    updateGL();

}

void GLWorld::toggleExtendHeadTail(void) 
{    
    
    bool thestatus;
    
    thestatus = layerlist->at(activeLayer)->thelayer->showEdges;

    thestatus = !thestatus;
    
    layerlist->at(activeLayer)->thelayer->showEdges = thestatus;
    
    updateGL();
 
}

void GLWorld::toggleLoop(void) 
{    
    
    bool thestatus;
    
    thestatus = layerlist->at(activeLayer)->thelayer->loop;

    thestatus = !thestatus;
    
    layerlist->at(activeLayer)->thelayer->loop = thestatus;
    
    updateGL();
 
}

void GLWorld::togglePingPong(void) 
{    
    
    bool thestatus;
    
    thestatus = layerlist->at(activeLayer)->thelayer->ping;

    thestatus = !thestatus;
    
    layerlist->at(activeLayer)->thelayer->ping = thestatus;
    
    updateGL();
 
}

