/*******************************************************************************
**
** The source file for the Jahshaka glworld module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"
#include <qstylefactory.h>

void GLWorld::buildController( QHBox* controller) 
{
#ifndef JAHPLAYER

    Astartframe=1;  Aendframe=100;  Aanimframe=1;

    //we need to get rid of this variable now
    //but its tied to a a lot of ui slider values
    MaxFrames = 1000000;

	
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    Form1Layout = new QHBoxLayout( controller, 11, 6, "Form1Layout");

    maincontroller = new QFrame( controller, "maincontroller" );
    maincontroller->setMinimumSize( QSize( 0, 35 ) );
    maincontroller->setMaximumSize( QSize( 32767, 35 ) );
    maincontroller->setFrameShape( QFrame::Box );
    maincontroller->setFrameShadow( QFrame::Plain );
    maincontrollerLayout = new QHBoxLayout( maincontroller, 0, 0, "maincontrollerLayout");

    MainController = new QWidgetStack( maincontroller, "MainController" );

    page = new QWidget( MainController, "page" );
    pageLayout = new QHBoxLayout( page, 0, 0, "pageLayout");
    QSpacerItem* spacer = new QSpacerItem( 30, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer );

    forceplayframe = new QFrame( page, "forceplayframe" );
    forceplayframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, forceplayframe->sizePolicy().hasHeightForWidth() ) );
    forceplayframe->setMinimumSize( QSize( 90, 20 ) );
    forceplayframe->setMaximumSize( QSize( 90, 20 ) );
    forceplayframe->setFrameShape( QFrame::StyledPanel );
    forceplayframe->setFrameShadow( QFrame::Raised );

    forcedplay = new QCheckBox( forceplayframe, "forceplaycheckbox" );
    forcedplay->setGeometry( QRect( 0, 0, 91, 21 ) );
    forcedplay->setText(jt.tr("ForcePlay") );
    pageLayout->addWidget( forceplayframe );
    connect( forcedplay,  SIGNAL(clicked()), this, SLOT(toggleForcePlay())  );

    QSpacerItem* spacer_2 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_2 );
    QSpacerItem* spacer_3 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_3 );

    controllerframe = new QFrame( page, "controllerframe" );
    controllerframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, controllerframe->sizePolicy().hasHeightForWidth() ) );
    controllerframe->setMinimumSize( QSize( 170, 30 ) );
    controllerframe->setMaximumSize( QSize( 170, 30 ) );
    controllerframe->setFrameShape( QFrame::NoFrame );
    controllerframe->setFrameShadow( QFrame::Plain );


    //////////////////////////////////////////////////////////////////
    // set up the main playbar buttons

    scrubfirst = new JahToolButton( controllerframe, "controllerrewindbutton" );
    addJahPlayerButton( scrubfirst, 0, 1, 27, 29,   28, 30, JahBasePath+"Pixmaps/player/rewind_off.png", JahBasePath+"Pixmaps/player/rewind_on.png" );
    connect( scrubfirst,  SIGNAL(clicked()), SLOT(firstframeanimation())  );

    scrubprevious = new JahToolButton( controllerframe, "controllerpreviousbutton" );
    addJahPlayerButton( scrubprevious, 27, 1, 27, 29,  24, 28, JahBasePath+"Pixmaps/player/frewind_off.png", JahBasePath+"Pixmaps/player/frewind_on.png" );
    connect( scrubprevious,  SIGNAL(clicked()), SLOT(previousframeanimation())  );

    scrubstop = new JahToolButton( controllerframe, "controllerstopbutton" );
    addJahPlayerButton( scrubstop, 54, 1, 27, 29,    24, 28, JahBasePath+"Pixmaps/player/stop_off.png", JahBasePath+"Pixmaps/player/stop_on.png" );
    connect( scrubstop,  SIGNAL(clicked()), SLOT(stopanimation())  );

    scrubplay = new JahToolButton( controllerframe, "play" );
    addJahPlayerButton( scrubplay, 81, 1, 27, 29 ,    24, 28, JahBasePath+"Pixmaps/player/play_off.png", JahBasePath+"Pixmaps/player/play_on.png" );
    //scrubplay->setGeometry( QRect( 62, 2, 19, 30 ) );
    connect( scrubplay,  SIGNAL(clicked()), SLOT(startanimation())  );

    scrubnext = new JahToolButton( controllerframe, "controllernextbutton" );
    addJahPlayerButton( scrubnext, 108, 1, 27, 29,    24, 28, JahBasePath+"Pixmaps/player/ffoward_off.png", JahBasePath+"Pixmaps/player/ffoward_on.png" );
    //scrubnext->setGeometry( QRect( 120, 2, 30, 27 ) );
    connect( scrubnext,  SIGNAL(clicked()), SLOT(nextframeanimation())  );

    scrublast = new JahToolButton( controllerframe, "controllerffworardbutton" );
    addJahPlayerButton( scrublast, 135, 1, 27, 29,   24, 28, JahBasePath+"Pixmaps/player/foward_off.png",  JahBasePath+"Pixmaps/player/foward_on.png" );
    //scrublast->setGeometry( QRect( 150, 2, 30, 28 ) );
    connect( scrublast,  SIGNAL(clicked()), SLOT(lastframeanimation())  );

    pageLayout->addWidget( controllerframe );


    controllerslider = new QSlider( page, "controllerslider" );
    //make sure platinum is loaded
    QStyle *platinum=QStyleFactory::create("platinum");
    //if(platinum) qApp->setStyle(platinum);
    if(platinum) controllerslider->setStyle( platinum );
    controllerslider->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, 0, 0, controllerslider->sizePolicy().hasHeightForWidth() ) );
    controllerslider->setMinimumSize( QSize( 490, 0 ) );
    controllerslider->setMaximumSize( QSize( 500, 32767 ) );
    controllerslider->setOrientation( QSlider::Horizontal );
    controllerslider->setTickmarks( QSlider::Right );
    controllerslider->setMinValue( Astartframe );
    controllerslider->setMaxValue( Aendframe );
    controllerslider->setValue   ( Aanimframe );

    connect( controllerslider,   SIGNAL(sliderMoved(int)),    SLOT(updateanimframe(int)) );
    connect( controllerslider,   SIGNAL(sliderPressed()),     SLOT(sliderselected()) );
    connect( controllerslider,   SIGNAL(sliderReleased()),    SLOT(sliderreleased()) );

    connect(controllerslider, SIGNAL(valueChanged(int)), SLOT(sliderValueChanged(int)) );



    pageLayout->addWidget( controllerslider );

    timecodeframe = new QFrame( page, "timecodeframe" );
    timecodeframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, timecodeframe->sizePolicy().hasHeightForWidth() ) );
    timecodeframe->setMinimumSize( QSize( 125, 30 ) );
    timecodeframe->setMaximumSize( QSize( 125, 30 ) );
    timecodeframe->setFrameShape( QFrame::NoFrame );
    timecodeframe->setFrameShadow( QFrame::Raised );

    animframe = new InputLCD( timecodeframe, "timecodedisplay",9 );
    addSliderLcd(animframe, 5, 0, 90, 31, 100);
    animframe->setValue( 1 );
    connect( controllerslider,   SIGNAL(valueChanged(int)),   animframe, SLOT(setValue(int)) );
    connect( animframe, SIGNAL(valueChanged(int)),   SLOT(updateanimframe(int)) );

	
    scrubkey = new QPushButton( timecodeframe, "keyframebutton" );
    scrubkey->setGeometry( QRect( 95, 0, 25, 28 ) );
    scrubkey->setText( jt.tr( "key"  ) );
    scrubkey->setMinimumSize( QSize( 25, 0 ) );
    scrubkey->setMaximumSize( QSize( 25, 32767 ) );
    connect( scrubkey, SIGNAL(clicked()), SLOT(addKeyframe()) );

    pageLayout->addWidget( timecodeframe );

    QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_4 );

    imagingframe = new QFrame( page, "imagingframe" );
    imagingframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, imagingframe->sizePolicy().hasHeightForWidth() ) );
    imagingframe->setMinimumSize( QSize( 105, 20 ) );
    imagingframe->setMaximumSize( QSize( 105, 20 ) );
    imagingframe->setFrameShape( QFrame::NoFrame );
    imagingframe->setFrameShadow( QFrame::Raised );

    scrubrender = new QPushButton( imagingframe, "imagingphotobutton" );
    scrubrender->setGeometry( QRect( 0, 0, 50, 20 ) );
    scrubrender->setMinimumSize( QSize( 50, 20 ) );
    scrubrender->setMaximumSize( QSize( 50, 20 ) );
    scrubrender->setText( jt.tr( "Photo"  ) );
    connect( scrubrender, SIGNAL(clicked()), SLOT( Render()) );   //change this mon

    scrubrenderAll = new QPushButton( imagingframe, "imagingrenderbutton" );
    scrubrenderAll->setGeometry( QRect( 55, 0, 50, 20 ) );
    scrubrenderAll->setMinimumSize( QSize( 50, 20 ) );
    scrubrenderAll->setMaximumSize( QSize( 50, 20 ) );
    scrubrenderAll->setText( jt.tr( "Render"  ) );
    connect( scrubrenderAll, SIGNAL(clicked()), SLOT( RenderScene()) );   //change this mon

    pageLayout->addWidget( imagingframe );

    QSpacerItem* spacer_5 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_5 );

    MainController->addWidget( page, 0 );
    maincontrollerLayout->addWidget( MainController );
    Form1Layout->addWidget( maincontroller );
    MainController->raiseWidget(0);

#else

	//this is for JAHPLAYER

   Astartframe=1;  Aendframe=100;  Aanimframe=1; MaxFrames = 100000;

    Form1Layout = new QHBoxLayout( controller, 11, 6, "Form1Layout");

    maincontroller = new QFrame( controller, "maincontroller" );
    maincontroller->setMinimumSize( QSize( 0, 35 ) );
    maincontroller->setMaximumSize( QSize( 32767, 35 ) );
    maincontroller->setPaletteBackgroundColor( QColor( 100, 100, 100 ) );
    maincontroller->setFrameShape( QFrame::Box );
    maincontroller->setFrameShadow( QFrame::Plain );
    maincontrollerLayout = new QHBoxLayout( maincontroller, 0, 0, "maincontrollerLayout");

    MainController = new QWidgetStack( maincontroller, "MainController" );

    page = new QWidget( MainController, "page" );
    pageLayout = new QHBoxLayout( page, 0, 0, "pageLayout");
    QSpacerItem* spacer = new QSpacerItem( 30, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer );

    forceplayframe = new QFrame( page, "forceplayframe" );
    forceplayframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, forceplayframe->sizePolicy().hasHeightForWidth() ) );
    forceplayframe->setMinimumSize( QSize( 90, 20 ) );
    forceplayframe->setMaximumSize( QSize( 90, 20 ) );
    forceplayframe->setFrameShape( QFrame::StyledPanel );
    forceplayframe->setFrameShadow( QFrame::Raised );

    forcedplay = new QCheckBox( forceplayframe, "forceplaycheckbox" );
    forcedplay->setGeometry( QRect( 0, 0, 91, 21 ) );
    forcedplay->setText("ForcePlay" );
    pageLayout->addWidget( forceplayframe );
    connect( forcedplay,  SIGNAL(clicked()), this, SLOT(toggleForcePlay())  );

    QSpacerItem* spacer_2 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_2 );
    QSpacerItem* spacer_3 = new QSpacerItem( 16, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_3 );

    controllerframe = new QFrame( page, "controllerframe" );
    controllerframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, controllerframe->sizePolicy().hasHeightForWidth() ) );
    controllerframe->setMinimumSize( QSize( 170, 30 ) );
    controllerframe->setMaximumSize( QSize( 170, 30 ) );
    controllerframe->setFrameShape( QFrame::NoFrame );
    controllerframe->setFrameShadow( QFrame::Plain );

    //////////////////////////////////////////////////////////////////
    // set up the main playbar buttons

    scrubfirst = new JahToolButton( controllerframe, "controllerrewindbutton" );
    addJahPlayerButton( scrubfirst, 0, 1, 27, 29,   28, 30, JahBasePath+"Pixmaps/player/rewind_off.png", JahBasePath+"Pixmaps/player/rewind_on.png" );
    connect( scrubfirst,  SIGNAL(clicked()), this, SLOT(firstframeanimation())  );

    scrubprevious = new JahToolButton( controllerframe, "controllerpreviousbutton" );
    addJahPlayerButton( scrubprevious, 27, 1, 27, 29,  24, 28, JahBasePath+"Pixmaps/player/frewind_off.png", JahBasePath+"Pixmaps/player/frewind_on.png" );
    connect( scrubprevious,  SIGNAL(clicked()), SLOT(previousframeanimation())  );

    scrubstop = new JahToolButton( controllerframe, "controllerstopbutton" );
    addJahPlayerButton( scrubstop, 54, 1, 27, 29,    24, 28, JahBasePath+"Pixmaps/player/stop_off.png", JahBasePath+"Pixmaps/player/stop_on.png" );
    connect( scrubstop,  SIGNAL(clicked()), this, SLOT(stopanimation())  );

    scrubplay = new JahToolButton( controllerframe, "play" );
    addJahPlayerButton( scrubplay, 81, 1, 27, 29 ,    24, 28, JahBasePath+"Pixmaps/player/play_off.png", JahBasePath+"Pixmaps/player/play_on.png" );
    connect( scrubplay,  SIGNAL(clicked()), this, SLOT(startanimation())  );

    scrubnext = new JahToolButton( controllerframe, "controllernextbutton" );
    addJahPlayerButton( scrubnext, 108, 1, 27, 29,    24, 28, JahBasePath+"Pixmaps/player/ffoward_off.png", JahBasePath+"Pixmaps/player/ffoward_on.png" );
    connect( scrubnext,  SIGNAL(clicked()), SLOT(nextframeanimation())  );

    scrublast = new JahToolButton( controllerframe, "controllerffworardbutton" );
    addJahPlayerButton( scrublast,  135, 1, 27, 29,   24, 28, JahBasePath+"Pixmaps/player/foward_off.png",  JahBasePath+"Pixmaps/player/foward_on.png" );
    connect( scrublast,  SIGNAL(clicked()), this, SLOT(lastframeanimation())  );

    pageLayout->addWidget( controllerframe );

    controllerslider = new QSlider( page, "controllerslider" );
    //make sure platinum is loaded
    QStyle *platinum=QStyleFactory::create("platinum");
    //if(platinum) qApp->setStyle(platinum);
    if(platinum) controllerslider->setStyle( platinum );
    controllerslider->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, 0, 0, controllerslider->sizePolicy().hasHeightForWidth() ) );

    controllerslider->setMinimumSize( QSize( 20, 0 ) );

    controllerslider->setMaximumSize( QSize( 500, 32767 ) );
    controllerslider->setOrientation( QSlider::Horizontal );
    controllerslider->setTickmarks( QSlider::Right );


	QObject::connect(controllerslider, SIGNAL(sliderMoved(int)), this, SLOT(SetFrameNumber(int)) );
    QObject::connect(controllerslider, SIGNAL(sliderPressed()), this, SLOT(ScrollPressed()) );
	QObject::connect(controllerslider, SIGNAL(sliderReleased()), this, SLOT(JumpToFrame()) );

    QObject::connect(controllerslider, SIGNAL(valueChanged(int)), this, SLOT(sliderValueChanged(int)) );

    pageLayout->addWidget( controllerslider );

    timecodeframe = new QFrame( page, "timecodeframe" );
    timecodeframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0,
                                  timecodeframe->sizePolicy().hasHeightForWidth() ) );
    timecodeframe->setMinimumSize( QSize( 125, 30 ) );
    timecodeframe->setMaximumSize( QSize( 125, 30 ) );
    timecodeframe->setFrameShape( QFrame::NoFrame );
    timecodeframe->setFrameShadow( QFrame::Raised );

    animframe = new InputLCD( timecodeframe, "timecodedisplay",9 );
    addSliderLcd(animframe, 5, 0, 90, 31, 100);
    animframe->setValue( 1 );
    connect( controllerslider,   SIGNAL(valueChanged(int)),   animframe, SLOT(setValue(int)) );
    //connect( animframe, SIGNAL(valueChanged(int)),   SLOT(updateanimframe(int)) );

    pageLayout->addWidget( timecodeframe );

    QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_4 );

    imagingframe = new QFrame( page, "imagingframe" );
    imagingframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0,
                                 imagingframe->sizePolicy().hasHeightForWidth() ) );
    imagingframe->setMinimumSize( QSize( 105, 20 ) );
    imagingframe->setMaximumSize( QSize( 105, 20 ) );
    imagingframe->setFrameShape( QFrame::NoFrame );
    imagingframe->setFrameShadow( QFrame::Raised );

    scrubrender = new QPushButton( imagingframe, "imagingphotobutton" );
    scrubrender->setGeometry( QRect( 0, 0, 50, 20 ) );
    scrubrender->setMinimumSize( QSize( 50, 20 ) );
    scrubrender->setMaximumSize( QSize( 50, 20 ) );
    scrubrender->setText( tr( "FPS"  ) );
    //connect( scrubrender,  SIGNAL(clicked()), SLOT( switchModeFps())  );

    scrubrenderAll = new QPushButton( imagingframe, "imagingrenderbutton" );
    scrubrenderAll->setGeometry( QRect( 55, 0, 50, 20 ) );
    scrubrenderAll->setMinimumSize( QSize( 50, 20 ) );
    scrubrenderAll->setMaximumSize( QSize( 50, 20 ) );
    scrubrenderAll->setText( tr( "Step"  ) );
    //connect( scrubrenderAll,  SIGNAL(clicked()), SLOT( switchModeStep())  );

    pageLayout->addWidget( imagingframe );

    QSpacerItem* spacer_5 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_5 );

    MainController->addWidget( page, 0 );
    maincontrollerLayout->addWidget( MainController );
    Form1Layout->addWidget( maincontroller );
    MainController->raiseWidget(0);
#endif
}



void GLWorld::updatesliderStartframe( int startframe ) 
{
	
	controllerslider->setMinValue( startframe );
	controllerslider->setTickmarks(QSlider::Right);
}

void GLWorld::updatesliderEndframe( int endframe )     
{
	
	controllerslider->setMaxValue( endframe );
	maxFrame = endframe;
	controllerslider->setTickmarks(QSlider::Right);
}

/////////////////////////////////////////////////////////////////////////////
// These are interface building subrutines to save space
// in all module interface building code

void GLWorld::addJahPlayerButton( JahToolButton * button, int x1, int y1, int x2, int y2,
                                  int w, int h, QString icon ) 
{

    button->setToggleButton(false);
    button->setFixedSize(w,h);
    button->setUsesBigPixmap(true);
    button->setGeometry( QRect( x1, y1, x2, y2 ) );

    QIconSet *icoSet;
    icoSet = new QIconSet( QPixmap(icon) );
    icoSet->setPixmap    ( QPixmap(icon), QIconSet::Large, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(icon), QIconSet::Large, QIconSet::Disabled);
    icoSet->setPixmap    ( QPixmap(icon), QIconSet::Small, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(icon), QIconSet::Small, QIconSet::Disabled);
    button->setIconSet(*icoSet);
    //delete icoSet;

}

void GLWorld::addJahPlayerButton( JahToolButton * button, int x1, int y1, int x2, int y2,
                                  int w, int h, QString iconOff, QString iconOn ) 
{

    button->setToggleButton(false);
    //button->setFixedSize(w,h);
    button->setUsesBigPixmap(true);
    button->setGeometry( QRect( x1, y1, x2, y2 ) );

    QIconSet *icoSet;
    icoSet = new QIconSet( QPixmap(iconOff) );
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Large, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Large, QIconSet::Disabled);
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Small, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Small, QIconSet::Disabled);
    button->setIconSet(*icoSet);
    //delete icoSet;

}

void GLWorld::addButton( QPushButton * button, int x, int y, int w, int h, QString text ) {

    button->setGeometry( QRect( x, y, w, h ) );
    button->setText( tr( text  ) );

}

void GLWorld::addCheckButton( QCheckBox * button, int x, int y, int w, int h, QString text ) {

    button->setGeometry( QRect( x, y, w, h ) );
    button->setText( tr( text  ) );

}

void GLWorld::addIconButton( QPushButton * button, int x, int y, int w, int h, QString icon ) {

  button->setGeometry( QRect( x, y, w, h ) );
	button->setIconSet(QIconSet( QPixmap(icon), QPixmap(icon) ));
	
}

void GLWorld::addIconButton( QPushButton * button, int x, int y, int w, int h ) {

  button->setGeometry( QRect( x, y, w, h ) );
	//button->setIconSet(QIconSet( QPixmap(icon), QPixmap(icon) ));
	
}

void GLWorld::addToolButton( QToolButton * button, int x, int y, int w, int h, QString icon ) {

    button->setGeometry( QRect( x, y, w, h ) );

	button->setToggleButton(true);
	button->setIconSet(QIconSet( QPixmap(icon), QPixmap(icon) ));
	
}

void GLWorld::addToolButton( QToolButton * button, int x, int y, int w, int h ) {

    button->setGeometry( QRect( x, y, w, h ) );
	button->setToggleButton(true);
	button->setIconSet(QIconSet( QPixmap(), QPixmap() ));
	
}


void GLWorld::addLabel( QLabel * label, int x, int y, int w, int h, QString text, int size) {

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( text  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );
}

void GLWorld::addSlider( QSlider * slider, int x, int y, int w, int h, int range) {
    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

}



void GLWorld::addSliderLcd( InputLCD * lcd, int x, int y, int w, int h, int range) {

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x, y, w, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addRangeSlider( QSlider * slider, int x, int y, int w, int h, int rangemin, int rangemax) {
    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );

}


void GLWorld::addLcdLabel      ( QFrame * frame,
                                 InputLCD * lcd, int x, int y, int w, int h, int range,
                                 QString labeltext, int size ) {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+w+5, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addLabelLcd      ( QFrame * frame,
                                 InputLCD * lcd, int x, int y, int w, int h, int range,
                                 QString labeltext, int size ) {

   QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x+30, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );


}

void GLWorld::addSliderAndLcd( QSlider * slider, int x, int y, int w, int h, int range,
                               InputLCD * lcd ) {

    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x, y, w, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}

void GLWorld::addSliderAndLcd( QSlider * slider, int x, int y, int w, int h, int rangemin, int rangemax,
                               InputLCD * lcd ) 
{
                               
    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x, y, w, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+w, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );
    //lcd->setMinInt( 0 );
    //lcd->setMaxInt( 100 );

}


void GLWorld::addDialLcdLabel(   QFrame * frame,
                                 QDial  * dial, int x, int y, int w, int h, int range,
                                 InputLCD * lcd,
                                 QString labeltext, int size) 
{

    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) dial->setStyle(  platinum );
    dial->setGeometry( QRect( x+10, y, w+10, h+10 ) );
   // dial->setOrientation( QSlider::Horizontal );
    dial->setNotchesVisible ( true );
    dial->setMinValue( 0 );
    dial->setMaxValue( range );
    dial->setWrapping(true);
    
    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y+h+10, w/2, h/2 ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+(w/2)+5, y+h+15, w/2+10, h/3 ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setMinInt( 0 );
    lcd->setMaxInt( range );
    lcd->setValue( 0 );


}

void GLWorld::addJahSliderGroup(    QFrame * frame,
                                    QSlider  * slider, int x, int y, int w, int h, int range,
                                    InputLCD * lcd,
                                    QLabel * label, QString labeltext, int size)
                                    {

    //QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active,   QColorGroup::Foreground, QColor( 0, 255, 0 ) );
    p.setColor( QPalette::Disabled, QColorGroup::Foreground, QColor( 0, 255, 0 ) ); //Qt::green

    lcd->setGeometry( QRect( x+130, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}


//////////////////////////////////////////////////////////////////
//three overrides here!

void GLWorld::addSliderLcdLabel( QFrame * frame,
                                 QSlider  * slider, int x, int y, int w, int h, int range,
                                 InputLCD * lcd,
                                 QString labeltext, int size)
                                 {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( -(range) );
    slider->setMaxValue( range );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active,   QColorGroup::Foreground, QColor( 0, 255, 0 ) );
    p.setColor( QPalette::Disabled, QColorGroup::Foreground, QColor( 0, 255, 0 ) ); //Qt::green

    lcd->setGeometry( QRect( x+130, y, 30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( 0 );

}


void GLWorld::addSliderLcdLabel( QFrame * frame,
                                 QSlider  * slider, int x, int y, int w, int h,
                                 int rangemin, int rangemax,
                                 InputLCD * lcd,
                                 QString labeltext, int size)
                                 {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+130, y, w+30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( rangemin );

}

void GLWorld::addSliderLcdLabel( QFrame * frame,
                                 QSlider  * slider, int x, int y, int w, int h,
                                 int rangemin, int rangemax, int preset,
                                 InputLCD * lcd,
                                 QString labeltext, int size)
                                 {

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( x, y, w, h ) );
    label->setText( tr( labeltext  ) );
    label->setAlignment( int( QLabel::AlignCenter ) );
    QFont label_font(  label->font() );
    label_font.setPointSize( size );
    label->setFont( label_font );

    QStyle *platinum=QStyleFactory::create("platinum");
    if (platinum) slider->setStyle(  platinum );
    slider->setGeometry( QRect( x+10, y, w+100, h ) );
    slider->setOrientation( QSlider::Horizontal );
    slider->setMinValue( rangemin );
    slider->setMaxValue( rangemax );
    slider->setValue( preset );

    QPalette p( QColor( 0, 0, 0 ) );
    p.setColor( QPalette::Active, QColorGroup::Foreground, Qt::green );

    lcd->setGeometry( QRect( x+130, y, w+30, h ) );
    lcd->setPalette( p, TRUE );
    lcd->setLineWidth( 1 );
    lcd->setSegmentStyle( QLCDNumber::Flat );  lcd->setActive	( true);
    lcd->setValue( rangemin );

}












