/*******************************************************************************
**
** The source file for the Jahshaka glworldcontrols.cpp module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"


////////////////////////////////////////////
//adds the current layer to the listbox and selects it

//headtail is weath we append or prepend the new item
//default is to prepend, you have to specify if you want to append it on the bottom
void GLWorld::addSelection(bool status, bool headtail)
{
	#ifndef JAHPLAYER
	//clear all current selections
	lv->clearSelection();

	//create the new listview item, currently all are checkbox style
	QCheckListItem * rasta;

	
	//by default we add items at the top of the stack
	//this lets us add them at the bototm of the stack

	//bool headtail = true;

	if (headtail)
	{
		
		rasta = new QCheckListItem( lv, lv->lastItem(), layerlist->at(numberLayers)->thelayer->layername, 
								  QCheckListItem::CheckBox );
	}
	else
	{
		rasta = new QCheckListItem( lv, layerlist->at(numberLayers)->thelayer->layername, 
								  QCheckListItem::CheckBox );
	}
	
	rasta->setOn(status);
	
	rasta->setText ( 0, layerlist->at(numberLayers)->thelayer->layername);

	lv->setSelected ( rasta, status );


	//set the layer to visible, need to 'check' the checkbox
	changeSelection(numberLayers);
	#endif

	setLayerVisible(numberLayers,status);

}

void GLWorld::changeSelection(int layer) 
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    //jtrace.debug("GLWorld::","Call to changeSelection");

    layerlist->at(activeLayer)->thelayer->selected=FALSE;
    activeLayer = layer;
    layerlist->at(layer)->thelayer->selected=TRUE;
  
}

void GLWorld::setLayerVisible( int layer, bool status ) 
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();

    QString data;
    jtrace.debug("GLWorld::","Setting layer: "+data.setNum(layer)+" visibility to:",status);

    if (layerlist->at(layer))
    {
        layerlist->at(layer)->thelayer->layerStatus = status;
    }
    
    updateGL(); 
}


void GLWorld::delLayer(void)
{
    //debug("deleting");
    //cant delete background
    if (activeLayer == 0) return;

    QListViewItem *ras; 
    //ras = lv->selectedItem();
    ras = lv->currentItem();
     
    //nothing selected
    if (ras==0)  return;

    //debug("got it");

    lv->takeItem(ras);
    //layerlist->at(activeLayer)->thelayer->layerStatus=FALSE; 
    
    //we can actually erase it from the qptr list now :)
    if ( layerlist->at(activeLayer) ) 
    {
        //delete layerlist->at(activeLayer);  
        //delete newworldorder->at(activeLayer);
        
        //problem is now... heh
        layerlist->remove(activeLayer);  
        newworldorder->remove(activeLayer); 
        
        //if we are in effects we have to do this as well
        if (ModuleName=="Effects") effects->remove(activeLayer); 
        
        //now we need to update numberLayers
        numberLayers -= 1;
    }    
    
    //set it to the world
    activeLayer = 0;
    
    changeSelection(0);
    //setLayerVisible(0, TRUE); 
    //need to set activeLayer to the one befoer or after?
    updateGL(); 
    
    //debug("deleted");
}


void GLWorld::objectMenu(int layer)
{           
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug("GLWorld::", "objectMenu raising the menu for layer", layer);
    
    if ( layerlist->at(layer) )
    {

    LayerCategory layertype;	layertype = layerlist->at(layer)->thelayer->layertype;
    ObjectCategory object;		object    = layerlist->at(layer)->thelayer->objtype;

    switch ( layertype ) {

        case LAYER        :     {       switch ( object ) {
                                        case BACKDROP     : { objectControlStack->raiseWidget(2); break; }
                                        case JAHLAYER     : { objectControlStack->raiseWidget(0); break; }
                                        default           : { objectControlStack->raiseWidget(0); break; }
                                        }

                                break; }


        case PARTICLE     :     {   objectControlStack->raiseWidget(4); break; }	

        case OBJECTS      :     {   if (object==OBJOBJECTS )   { objectControlStack->raiseWidget(5); }
                                    if (object==MAXOBJECTS )   { objectControlStack->raiseWidget(6); }
                                    break; }

        case FRAME        :     {   break; }

        case TEXT         :     {   if ( object==JAHTEXT )     { objectControlStack->raiseWidget(1); }
                                    break; }

        case GRID         :     {   break; }
        
        case LIGHT        :     {   if (object==JAHLIGHT )     { objectControlStack->raiseWidget(0); }
                                    break; }

        default           :     {    jtrace.error ("unknown layer type, unable to select menus"); break; }

    }

    changeSelection(layer);
    }
}





/*
void GLWorld::spaceButtonEvent  ( int button )  {
	
  //we will use buttons 6/5/4 to lock on x/y/z axes any other button releases
      switch(button) {

        case 4    : { debug("spaced PLAYER"); break;  }
        case 5    : { debug("spaced LIBRARY"); break; }
        case 6    : { debug("spaced PAINT"); break;   }

        default   : {  xloxk = true; ylock; }

      }

}
*/

void GLWorld::spaceEvent  ( double x, double y, double z, double a, double b, double c )  
{
    //user should be able to tune sensitivity
    int sensitivty = 70;

    if (activeLayer>0)// thelayer=0;
    {
        layerlist->at(activeLayer)->thelayer->node->rx += (GLfloat)(a/sensitivty);
        layerlist->at(activeLayer)->thelayer->node->ry += (GLfloat)(b/sensitivty);
        layerlist->at(activeLayer)->thelayer->node->tx += (GLfloat)(c/sensitivty);

        layerlist->at(activeLayer)->thelayer->node->tx += (GLfloat)(x/sensitivty);
        layerlist->at(activeLayer)->thelayer->node->ty += (GLfloat)(y/sensitivty);
        layerlist->at(activeLayer)->thelayer->node->tz += (GLfloat)(-z/sensitivty);

        updateGL(); 
    }
    else if (activeLayer==0)
    {
        camera->node->rx += (GLfloat)(a/sensitivty);
        camera->node->ry += (GLfloat)(b/sensitivty);
        camera->node->tx += (GLfloat)(c/sensitivty);

        camera->node->tx += (GLfloat)(x/sensitivty);
        camera->node->ty += (GLfloat)(y/sensitivty);
        camera->node->tz += (GLfloat)(-z/sensitivty);  
        
        updateGL();       
    }
}





////////////////////////////////////////////////
// 3d object loaders

//////////////////////////////////////////////////////////////
// popup object loaders

//need to move the load routines out of object code into core
//can pass the object over...

void GLWorld::loadObjObject(void) 
{

    QString format;
	QString     objfilename,objextension;

    QString filename = QFileDialog::getOpenFileName( JahMediaPath+"/models",  "*.obj *.OBJ"  );
    
    if ( !filename.isEmpty() ) 
    {
		if ( QFile::exists(filename) )
		{
			//do another check to see if it exists here
			QString temp; int i; temp = filename;
			i = temp.length();	i -= 4;   //get rid of 4 char extension

			objfilename = temp.left(i);
        
			//now get extension
			format = temp.right(3);
			objextension = "."+format;

			layerlist->at(activeLayer)->thelayer->objfilename = objfilename;
			layerlist->at(activeLayer)->thelayer->objextension = objextension;

			layerlist->at(activeLayer)->thelayer->loadOBJ(objfilename+objextension);  
		}
    }

}

void GLWorld::loadMaxObject(void) 
{

    QString format;
	QString     objfilename,objextension;

    QString filename = QFileDialog::getOpenFileName( JahMediaPath+"/models",  "*.3ds *.3DS"  );
    
    if ( !filename.isEmpty() ) 
    {
		if ( QFile::exists(filename) )
		{
			QString temp; int i; temp = filename;
			i = temp.length();	i -= 4;   //get rid of 4 char extension

			objfilename = temp.left(i);
        
			format = temp.right(3);
        
			objextension = "."+format;

			layerlist->at(activeLayer)->thelayer->objfilename = objfilename;
			layerlist->at(activeLayer)->thelayer->objextension = objextension;

			layerlist->at(activeLayer)->thelayer->loadMaxOBJ(objfilename+objextension);
		}//backdrop  was ships
    }

}


