/*******************************************************************************
**
** The header file for the Jahshaka glworld module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworldlists.h"

///////////////////////////////////////////
// linked list to store selected layers
// updated frequently
// its a mess because we store layer numbers in reverse according 
// to the position in the list
// ie layer 4 is the 4th layer etc
// but qt stores it the other way so 4 = 0 if there are 4 layers


    ActiveLayerList::ActiveLayerList(  )
    { 
        numLayers   = 0;
        totalLayers = 0;

        ///////////////////////////////////////////////
        // the linked list is here
        activelayerlist = new QPtrList<int>;
        activelayerlist->setAutoDelete( TRUE );     // delete items when they are removed

    }

    int             ActiveLayerList::getNumLayers()                      { return numLayers;  }

    void            ActiveLayerList::setTotalLayers( int lay)                 { totalLayers = lay;  }

    int ActiveLayerList::getFinalSelection(void)
    { 
        int layer = numLayers -1;
        int lay;

        if (activelayerlist->at(layer))
        {
        lay = *activelayerlist->at(layer);
        return  ( totalLayers - lay )-1;
        }
        else
        {
            return 0;
        }
    }

    int ActiveLayerList::getLayers(int layer)
    {
        int lay;
        lay = *activelayerlist->at(layer);
        return  ( totalLayers - lay )-1;
    }

    void ActiveLayerList::addLayer(int layer)
    {
        activelayerlist->append( new int(layer));
        numLayers +=1;
    }

    void ActiveLayerList::clearList(void)
    {
        if (numLayers>0)
        {
            activelayerlist->clear();
            numLayers=0;
        }
    }

    void ActiveLayerList::printInfo(void)
    {
        QString conv;
        int lay;

        debug("-activelayer object---------");
        debug("number layers:"+conv.setNum(numLayers));
        debug("----------------------------");

        for ( uint i = 0; i <= activelayerlist->count(); ++i )
        {
        if ( activelayerlist->at(i) )
            {
                lay = *activelayerlist->at(i);
                debug("layers:"+conv.setNum(( totalLayers - lay )-1 ));
            }
        }
        debug("----------------------------");
    }




















































