/*******************************************************************************
**
** The header file for the Jahshaka glworld module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef GLWORLDLISTS_H
#define GLWORLDLISTS_H

#include <qptrlist.h>
#include <qstring.h>

///////////////////////////////////////////
// linked list to store selected layers
// updated frequently
// its a mess because we store layer numbers in reverse according 
// to the position in the list
// ie layer 4 is the 4th layer etc
// but qt stores it the other way so 4 = 0 if there are 4 layers

class ActiveLayerList
{
public:
    ActiveLayerList();


    int             getNumLayers();
    void            setTotalLayers( int lay);

    int getFinalSelection(void);

    int getLayers(int layer);
    void addLayer(int layer);

    void clearList(void);

    void printInfo(void);


private:

    int             numLayers;          //number of selected layers
    int             totalLayers;        //number of layers in listview
    QPtrList<int>   *activelayerlist;   //for the linked list for dynamic object layers

};


#endif // GLWORLDHEADERS_H




















































