//look into using QImage QGLWidget::grabFrameBuffer ( bool withAlpha = FALSE ) [virtual]
//and then cropping for grab with alpha!
//may also be better supported over
//    mymap = QPixmap::grabWindow(this->winId(),xloffset,ytoffset,
//                                xres,yres); //where canvas is this

#include "glworld.h"

#include "jahtimer.h"


void GLWorld::checkRenderQuality() 
{
    if (renderquality<0) 
	{ 
		renderquality=1; 
	}

    if (renderquality>3) 
	{ 
		renderquality=1; 
	}

    switch (renderquality) {

    case 0  : { renderext=".jpg"; renderformat="JPEG"; break; }
    case 1  : { renderext=".png"; renderformat="PNG";  break; }
    case 2  : { renderext=".bmp"; renderformat="BMP";  break; }
    case 3  : { renderext=".ppm"; renderformat="PPM";  break; } 

    default : { renderext=".png"; renderformat="PNG";  break; }

    }
}

void GLWorld::checkJahRenderer()
{
    //initalize the global vars from the prefs
    JahPrefs& jprefs = JahPrefs::getInstance();

    JahRenderer  = jprefs.getRenderer();

    if (JahRenderer<0)
    {
        JahRenderer = 0;
    }

    if (JahRenderer>3)
    {
        JahRenderer = 0;
    }
}

///////////////////////////////////////////////
// default is bmp

void GLWorld::setRenderQuality(int quality) 
{
    if ( quality<0)
    {
        renderquality=1;
    }
    else if ( quality>3)
    {
        renderquality=1;
    }
    else
    {
        renderquality = quality;
    }
}

///////////////////////////////////////////////////
// used for render size overrides in effect module

void GLWorld::SetVideoRender()
{
    core->useimagesize = !core->useimagesize;
}

//this one takes a single frame photo of where we are
void GLWorld::Render(void)
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( ">>Taking photo");

    //clipnumber++;
    videoData thedata;

    checkRenderQuality();

    checkJahRenderer();

    QString moduleinfo = ModuleName+"Image";
    QString temp;

    thedata.theCategory = IMAGE;
    thedata.theType     = SEQUENCE;

    thedata.clipname    = moduleinfo;

    int clipnum = *clipnumber;  clipnum++;

    thedata.clipnumber  = clipnum;   //needs to be globalclipnumber!

    //set the render path here
    QString jahrenderpath = renderpath;

    thedata.location    = jahrenderpath+"images/";
    thedata.filename    = moduleinfo + temp.setNum(clipnum);
    thedata.extension   = renderext;
    thedata.startframe  = 1;
    thedata.endframe    = 1;

    //paint module has no layers at the moment
    if (ModuleName!="Paint")
    {
        layerlist->at(activeLayer)->thelayer->selected=FALSE;
    }

    titlesafe->renderStatus=true;
    updateGL();

    QImage shot = Photo(thedata);

    if (ModuleName!="Paint")
    {
        layerlist->at(activeLayer)->thelayer->selected=TRUE;
    }

    titlesafe->renderStatus=false;

    emit updateDesktop(  thedata );

    //update widgets
    updateGL();

    *clipnumber = clipnum;

}



void GLWorld::RenderScene(void)
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "Rendering Scene");

    renderStatus = !renderStatus;

    checkRenderQuality();
    checkJahRenderer();

    //we override rendering of scenes for paint until that module is fixed
    if ( (renderStatus) && (ModuleName!="Paint") ) 
    {

        changeZoom(0);
        timer->stop(  );

        int startFrame = controllerslider->value();
        QString temp;
        QString moduleinfo = ModuleName+"Clip";
        videoData thedata;

        int clipnum = *clipnumber;
        clipnum++;

        //set the render path here
        QString jahrenderpath = renderpath;

        //set up the clip's data
        thedata.theCategory = CLIP;
        thedata.theType	    = SEQUENCE;
        thedata.clipname    = moduleinfo;      //need to know this
        thedata.clipnumber  = clipnum;

        QString destDir;
        destDir             = jahrenderpath+moduleinfo + temp.setNum(clipnum);

        jtrace.debug("rendering to:"+destDir);

        //cleans folders up and returns new location
        thedata.location = checkandcleandir(destDir,clipnum);

        thedata.filename    = moduleinfo + temp.setNum(clipnum)+"_";
        thedata.extension   = renderext;
        thedata.startframe  = 1;
        thedata.endframe    = ((maxFrame-startFrame))+1;   //is default length of animation
        thedata.videotex   = true;

        //this is where we figure out the video extension for the numbering sequence
        QString theblankframe;  theblankframe.setNum(maxFrame);
        int     blanklength = theblankframe.length();

        //this creates the blankstring for videoext
        QString theblank;
        for (int i=0; i<blanklength; i++) 
        {
            theblank +="0";
        }

        thedata.videoext    = theblank+"1";

        //deselect the active layer
        layerlist->at(activeLayer)->thelayer->selected=FALSE;

        titlesafe->renderStatus = true;
        updateGL();

        //render out the sequence
        //debug("rendering all");
        QImage shot = RenderAll(thedata,startFrame,maxFrame);

        //did it end where it was supposed to or was it cancelled early
        int endFrame = controllerslider->value();

        if (renderStatus==FALSE)
        {
            thedata.endframe = (endFrame - startFrame) +1;
        } //+1 ?

        //reselect the activelayer
        layerlist->at(activeLayer)->thelayer->selected=TRUE;
        titlesafe->renderStatus = false;

        //add clip to the desktop now
        emit updateDesktop(  thedata );

        //update widgets
        updateGL();

        //and then incremnent global clipnumber
        *clipnumber = clipnum;

    }
}

//////////////////////////////////////////////////////////////////
//added for video head support
//still need a quicker way to do this

QString GLWorld::checkandcleandir(QString destDir, int clipnum)
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();

    QString newlocation;
    QString jahrenderpath = renderpath;
    QString moduleinfo = ModuleName+"Clip";


    //here we make the dir if it doesnt exist
    QDir d( destDir );                        // "./example"

    if (d.exists() )
    {
        jtrace.debug("directory exists we are cleaning up:"+destDir);

        const QFileInfoList *list = d.entryInfoList();
        QFileInfoListIterator it( *list );
        QFileInfo *fi;

        QString thaname,delname;

        while ( (fi = it.current()) != 0 )
        {
            thaname = fi->fileName().latin1() ;
            delname = destDir+"/"+thaname;

            QFile f( delname );

            if (f.exists())
            {
                f.remove();
            }
            ++it;
        }
    }

    QString temp;

    if ( !d.exists() )
    {
        jtrace.debug( "Cannot find existing render directory - good" );
        if (d.mkdir( destDir ))
        {
            jtrace.debug("created directory",destDir );
            //thedata.location    = jahrenderpath+moduleinfo + temp.setNum(clipnum) + "/";
            newlocation    = jahrenderpath+moduleinfo + temp.setNum(clipnum) + "/";
        }
        else
        {
            jtrace.error("couldnt create directory - filesystem error",destDir );
            newlocation    = jahrenderpath;
        }
    }
    else
    {
        //the render folder already existed amd we couldnt erase it
        //what do we do?
        //just write into it...
        newlocation    = jahrenderpath+moduleinfo + temp.setNum(clipnum) + "/";

    }

    return newlocation;

}
//////////////////////////////////////////////////////////////////
//added for video head support
//still need a quicker way to do this

void GLWorld::SoftRender()
{
    checkRenderQuality();

    if (ModuleName!="Paint")
    layerlist->at(activeLayer)->thelayer->selected=FALSE;

    QImage softImage=SoftPhoto();

    if (ModuleName!="Paint")
    layerlist->at(activeLayer)->thelayer->selected=TRUE;

    emit updatePlayer (  softImage );

}

/////////////////////////////////////////////////////////////////////////////
//the soft photo is identical to the one below
// but it returns a image instead of saving the data out to disk
// and always does full screen shots
// as it is used to drive the videohead

QImage GLWorld::SoftPhoto()
{

    QImage thephoto;

    if (ModuleName=="Paint")
    {
        thephoto = screenShot(currentFrame, 0, 0, 0, 0, X_RESOLUTION, Y_RESOLUTION );
    }

    //////////////////////////////////////////////////////////
    // use the default render mode

    int theheight = (core->renderheight/2)-243;   //700/2   - y = 107
    int thewidth  = (core->renderwidth/2)-360;    //1210/2  - x = 245

    thephoto = screenShot(currentFrame, thewidth, thewidth, theheight, theheight, X_RESOLUTION, Y_RESOLUTION );

    return thephoto; // send straight to desktop when controls are local
}

QImage GLWorld::Photo(videoData theclip) 
{
    QString writefile = theclip.location+theclip.filename+theclip.extension;

    QImage thephoto;

    //////////////////////////////////////////////////////////
    //if in paint the paint size is XREs by YREs starting at 0,0
    if (ModuleName=="Paint")
    {
        thephoto = screenShot(currentFrame, 0, 0, 0, 0, X_RESOLUTION, Y_RESOLUTION );
    }

    //////////////////////////////////////////////////////////
    //if in effects we need to take the image size into consideration
    //if useimagesize is true
    else if ((ModuleName=="Effects" || ModuleName=="Colorize") && core->useimagesize )
    {
        ///////////////////////////////////////////////////////////////////
        //make sure we do this only 1 time for renders... and optimize it
        ////////////////////////////////////////////////////////////////////
		
        //this gives us onscreen 720x486 cords...
        int theheight = (core->renderheight/2)-243;   //700/2   - y = 107
        int thewidth  = (core->renderwidth/2)-360;    //1210/2  - x = 245

        if (core->imagewidth>720) 
        {
            thewidth  = thewidth  -(((core->imagewidth)-720) /2);
        } 
        else if (core->imagewidth<720) 
        {
            thewidth  = thewidth  +((720-(core->imagewidth)) /2);
        }
        else {}

        if (core->imageheight>486) 
        {
            theheight = theheight -(((core->imageheight)-486)/2);
        } 
        else if (core->imageheight<486)
        {
            theheight = theheight +((486-(core->imageheight))/2);
        }
        else {}

        thephoto = screenShot(currentFrame, thewidth, thewidth, theheight, theheight, 
                            core->imagewidth, core->imageheight );

    }
    // use the default render mode for all other modules
    else 

    //////////////////////////////////////////////////////////
    // use the default render mode   
    {
		//////////////////////////////////////////////////////////////////
		//all our math used to be based on a base of 720x486 so we haev to clean this all up

		//renderwidth and renderheight are the size of the opengl window
        int theheight = (core->renderheight/2)-243;   //700/2   - y = 107
        int thewidth  = (core->renderwidth/2)-360;    //1210/2  - x = 245

        //now we have image cords... apply offests
		//imagewidth and imageheight are the size of the image


        if (X_RESOLUTION>720) 
        {
            thewidth  = thewidth  -(((X_RESOLUTION)-720) /2);
        } 
        else if (X_RESOLUTION<720) 
        {
            thewidth  = thewidth  +((720-(X_RESOLUTION)) /2);
        }
        else {}

        if (Y_RESOLUTION>486) 
        {
            theheight = theheight -(((Y_RESOLUTION)-486)/2);
        } 
        else if (Y_RESOLUTION<486)
        {
            theheight = theheight +((486-(Y_RESOLUTION))/2);
        }
        else {}

        thephoto = screenShot(currentFrame, thewidth, thewidth, theheight, theheight, 
                            X_RESOLUTION, Y_RESOLUTION );

    }

    QImageIO iio; iio.setImage(thephoto);
    iio.setFileName(writefile);
    iio.setFormat(renderformat);
    iio.write();

    return thephoto; // send straight to desktop when controls are local
}



QImage GLWorld::RenderAll(videoData theclip, int startframe, int endframe ) 
{
    QImage returnshot;
    QString filename = theclip.location+theclip.filename;
    QString writefile,blank,extension;

    //supposed to stop the timer so renders are FAST!
    animation = false;
    timer->stop();     

    //make sure we are current
    //makeCurrent();          

    //we loop through everything now
    int frameval = 0;
    QString currentframe;
    int length;
    int blanklength;

    for (int i = startframe; i<=endframe; i++) 
    {
        //this is the clip counter for saved frames
        frameval++;

        //we need to check our interupts here to kill render..
        qApp->processEvents();
        if (renderStatus==FALSE) break;

        // This is where we create the extension for the sequence

        //first figure out length of current frame
        currentframe.setNum(frameval);
        length = currentframe.length();  //was theblankframe

        //then remove it from the blank template for the clip
        QString blank(theclip.videoext);
        blank = blank.remove(0, length);

        //now we need to build the blank from scratch to account 
        //for sequences begining with 0001 etc
        blanklength = blank.length();
        QString theblank;
        for (int ii=0; ii<blanklength; ii++) 
		{
            theblank +="0";
        }

        blank = theblank+currentframe;

        writefile = filename + blank + theclip.extension;


        //////////////////////////////////////////////////////////
        //now we must take the photo

        QImage thephoto;

		//////////////////////////////////////////////////////////
		//if in effects we need to take the image size into consideration
		//if useimagesize is true
		if ((ModuleName=="Effects" || ModuleName=="Colorize") && core->useimagesize )
		{
			///////////////////////////////////////////////////////////////////
			//make sure we do this only 1 time for renders... and optimize it
			////////////////////////////////////////////////////////////////////
			
			//this gives us onscreen 720x486 cords...
			int theheight = (core->renderheight/2)-243;   //700/2   - y = 107
			int thewidth  = (core->renderwidth/2)-360;    //1210/2  - x = 245

			if (core->imagewidth>720) 
			{
				thewidth  = thewidth  -(((core->imagewidth)-720) /2);
			} 
			else if (core->imagewidth<720) 
			{
				thewidth  = thewidth  +((720-(core->imagewidth)) /2);
			}
			else {}

			if (core->imageheight>486) 
			{
				theheight = theheight -(((core->imageheight)-486)/2);
			} 
			else if (core->imageheight<486)
			{
				theheight = theheight +((486-(core->imageheight))/2);
			}
			else {}

			thephoto = screenShot(i, thewidth, thewidth, theheight, theheight, 
								core->imagewidth, core->imageheight );

		}
		// use the default render mode for all other modules
		else 
		//////////////////////////////////////////////////////////
		// use the default render mode   
		{
			//////////////////////////////////////////////////////////////////
			//all our math used to be based on a base of 720x486 so we haev to clean this all up

			//renderwidth and renderheight are the size of the opengl window
			int theheight = (core->renderheight/2)-243;   //700/2   - y = 107
			int thewidth  = (core->renderwidth/2)-360;    //1210/2  - x = 245

			//now we have image cords... apply offests
			//imagewidth and imageheight are the size of the image


			if (X_RESOLUTION>720) 
			{
				thewidth  = thewidth  -(((X_RESOLUTION)-720) /2);
			} 
			else if (X_RESOLUTION<720) 
			{
				thewidth  = thewidth  +((720-(X_RESOLUTION)) /2);
			}

			if (Y_RESOLUTION>486) 
			{
				theheight = theheight -(((Y_RESOLUTION)-486)/2);
			} 
			else if (Y_RESOLUTION<486)
			{
				theheight = theheight +((486-(Y_RESOLUTION))/2);
			}

			thephoto = screenShot(i, thewidth, thewidth, theheight, theheight, 
								X_RESOLUTION, Y_RESOLUTION );

		}


        //finished taking photo now we must write file to disk     
        QImageIO iio; 
        iio.setImage(thephoto);
        iio.setFileName(writefile);
        iio.setFormat(renderformat);
        iio.write();

        if (i==startframe) 
        { 
            returnshot = thephoto; 
        }

    }

    renderStatus=FALSE;

    timer->start( redrawWait, TRUE );        //supposed to reactivate the timer
    return returnshot;
}



//there are three different routines that can be used here
//the Qt renderer, a hardrenderer and a soft renderer
QImage GLWorld::screenShot(int Frame, int xloffset,int xroffset,int ytoffset,int yboffset,
                        int xres, int yres) 
{

	///////////////////////////////////////////////////////////////////
	// first update settings - make sure this hasnt already been done 
	// and we are duplicating it

    if (ModuleName!="Paint")
    {
        //update visuals    -- follow these commands for debugging here
        updateSlider(Frame);    // used for visual feedback
        updateanimframe(Frame); // draw the hires scene


    }
    else
    {
        paintGL();             // update the paint hires scene
    }

    if (JahRenderer==0)
    {

        ////////////////////////////////////////////////////////////
        //the default renderer now seems to work well

        QImage img;

        img = core->grabFrameBuffer (FALSE); //false or true flags alpha grabs!!!

        return img.copy(xloffset,ytoffset, xres,yres, FALSE);

        ////////////////////////////////////////////////////////////

    }


    if (JahRenderer==1)
    {
        //this is a hard render routine thats almost as fast as Qt's grabWindow but
        //it gives less trouble
        QImage img;

        static int                                    texture_width;
        static int                                    texture_height;

        int                                           row;
        int                                           image_row;
        int                                           column;

        static int                                    previous_image_width = 0;
        static int                                    previous_image_height = 0;

        static unsigned char*                         image_buffer;
        static unsigned char*                         pixel_buffer;
        static QImage*                                mymap;
        static GLuint                                 texture_id;

        if (previous_image_width != xres || previous_image_height != yres)
        {
            if (previous_image_width != 0)
            {
                delete image_buffer;
                delete pixel_buffer;
                delete mymap;
                glDeleteTextures(1, &texture_id);
            }

            image_buffer = new unsigned char[xres * yres * 4];
            mymap = new QImage(image_buffer, xres, yres, 32, 0, 0, QImage::IgnoreEndian);

            if (xres <= 128) { texture_width = 128; }
            else if (xres <= 256) { texture_width = 256; }
            else if (xres <= 512) { texture_width = 512; }
            else if (xres <= 1024) { texture_width = 1024; }

            if (yres <= 128) { texture_height = 128; }
            else if (yres <= 256) { texture_height = 256; }
            else if (yres <= 512) { texture_height = 512; }
            else if (yres <= 1024) { texture_height = 1024; }

            pixel_buffer = new unsigned char[texture_width * texture_height * 4];

            glGenTextures(1, &texture_id);
            glBindTexture(GL_TEXTURE_2D, texture_id);
            glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texture_width, texture_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);

        }

        glBindTexture(GL_TEXTURE_2D, texture_id);
        glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, xloffset, yboffset, xres, yres);
        glGetTexImage(GL_TEXTURE_2D, 0, GL_RGBA, GL_UNSIGNED_BYTE, (void*)pixel_buffer);


        for (row = 0; row < yres; row++)
        {
            image_row = (yres - 1) - row;

            for (column = 0; column < (xres * 4); column += 4)
            {
                image_buffer[(image_row * xres * 4) + column + 0] = 
                                pixel_buffer[(row * texture_width * 4) + column + 2];  // blue

                image_buffer[(image_row * xres * 4) + column + 1] = 
                                pixel_buffer[(row * texture_width * 4) + column + 1];  // green

                image_buffer[(image_row * xres * 4) + column + 2] = 
                                pixel_buffer[(row * texture_width * 4) + column + 0];  // red

                image_buffer[(image_row * xres * 4) + column + 3] = 
                                pixel_buffer[(row * texture_width * 4) + column + 3];  // alpha
            }
        }

        previous_image_width = xres;
        previous_image_height = yres;

        qApp->processEvents();

        return *mymap;

    }

    if (JahRenderer==2)
    {

        //this routine is a last effort routine if no other render is working
        //it grabs pixels from the viewport and is real, real slow
        //though it could be optimized ie by not destructing the variables as above to be faster
        GLint viewport[4];
        glGetIntegerv(GL_VIEWPORT,viewport);

        QImage img(viewport[2]-(xloffset+xroffset),(viewport[3]-(ytoffset+yboffset)),32);
        // QImage img(720,486,32);
        GLfloat *r=new GLfloat[viewport[2]];
        GLfloat *g=new GLfloat[viewport[2]];
        GLfloat *b=new GLfloat[viewport[2]];

        for(int y=0;y<(viewport[3]-(ytoffset+yboffset));y++) {
            glReadPixels(viewport[0],y+ytoffset,viewport[2],1,GL_RED,GL_FLOAT,(void *) r);
            glReadPixels(viewport[0],y+ytoffset,viewport[2],1,GL_GREEN,GL_FLOAT,(void *) g);
            glReadPixels(viewport[0],y+ytoffset,viewport[2],1,GL_BLUE,GL_FLOAT,(void *) b);

            for(int x=0;x<(viewport[2]-(xloffset+xroffset));x++) {
                uint *p = (uint *)img.scanLine(viewport[3]-1-y-(ytoffset+yboffset) )+x;
                *p = qRgb((uint) (r[x+xloffset]*255),
                        (uint) (g[x+xloffset]*255),
                        (uint) (b[x+xloffset]*255));
            }
        }

        delete[] r;    delete[] g;    delete[] b;

        return img; 



    }

    if (JahRenderer==3)
    {
        ////////////////////////////////////////////////////////////
        //the initial way
        //needed to sync up image

        QImage img;
        QPixmap mymap;  //move this out of the loop

        mymap = QPixmap::grabWindow(core->winId(),xloffset,ytoffset, xres,yres); 

        img = mymap;   //convert QPixmap to a QImage

        return img;

        ////////////////////////////////////////////////////////////
    }

        
		////////////////////////////////////////////////////////////
        //the older routine now defunct

        QPixmap mymap;  //move this out of the loop
        mymap = QPixmap::grabWindow(core->winId(),xloffset,ytoffset, xres,yres);
        QImage img;
		img= mymap;   //convert QPixmap to a QImage
        return img;
        
	
}

// we are aliasing in hardware so this routine should no longer be called
// but it can be used for heavy software rendering later on
// ie for 200x aliasing 
void GLWorld::renderGL() 
{  

if (polySmooth) 
{   
    int i;

    GLfloat jitter[4][2] = {   { -0.20,  0.35 },       {  0.20, -0.35 },
                            { -0.30, -0.15 },       {  0.30,  0.15 }   };

    for (i=0; i<4; i++)
        {

        // the world object is 0 we position it here
        layerlist->at(0)->thelayer->node->tx += (jitter[i][0] * 100.5);
        layerlist->at(0)->thelayer->node->ty += (jitter[i][1] * 100.5);

        paintGL();

        layerlist->at(0)->thelayer->node->tx -= (jitter[i][0] * 100.5);
        layerlist->at(0)->thelayer->node->ty -= (jitter[i][1] * 100.5);

        if (i == 0)
        glAccum(GL_LOAD, 0.25);
        else
        glAccum(GL_ACCUM, 0.25);
        }

        glAccum(GL_RETURN, 1.0);
    }

else { paintGL(); }

}

