/*******************************************************************************
**
** The source code for the Jahshaka glworldsliders.cpp file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"

//////////////////////////////////////////////////////
//first the headings group headings

void GLWorld::hideAllHeadings( )
{
    for (int i=0; i<=2; i++)
    {
        JahModuleLabel[i]->hide();
    }

}

void GLWorld::showAllHeadings( )
{
    for (int i=0; i<=2; i++)
    {
        JahModuleLabel[i]->show();
    }
}

void GLWorld::showHeadings(int ns )
{
    for (int i=0; i<ns; i++)
    {
        JahModuleLabel[i]->show();
    }
}


void GLWorld::setHeadingValue(int heading, QString value)
{
    JahModuleLabel[heading]->setText( tr( value  ) );
/*
    if (hasHeadings)
    {
        JahModuleLabel[heading]->setValue(value);
    }
*/
}

void GLWorld::setDefaultHeadings(void)
{
    JahModuleLabel[0]->setText( tr( JahModuleLabelText[0]  ) );
    JahModuleLabel[1]->setText( tr( JahModuleLabelText[1]  ) );
    JahModuleLabel[2]->setText( tr( JahModuleLabelText[2]  ) );
/*
    if (hasHeadings)
    {
        JahModuleLabel[heading]->setValue(value);
    }
*/
}


//////////////////////////////////////////////////////
//then the sliders and their labels

void GLWorld::hideAllSliders( )
{
    for (int i=0; i<=8; i++)
    {
        JahSliders[i]->hide();
        JahSlidersLCD[i]->hide();
        JahSlidersLabel[i]->hide();
    }

}

void GLWorld::showAllSliders( )
{
    for (int i=0; i<=8; i++)
    {
        JahSliders[i]->show();
        JahSlidersLCD[i]->show();
        JahSlidersLabel[i]->show();
    }
}

void GLWorld::showSliders(int ns )
{
    for (int i=0; i<ns; i++)
    {
        JahSliders[i]->show();
        JahSlidersLCD[i]->show();
        JahSlidersLabel[i]->show();
    }
}

void GLWorld::setSliderValue(int slider, int value)
{
    if (hasSliders)
    {
        JahSliders[slider]->setValue(value);
        JahSlidersLCD[slider]->setValue(value);
    }
}

void GLWorld::setSliderLabelValue(int slider, QString value)
{
   
    if (hasSliders)
    {
        //debug("setting slider label value");
        //debug(value);

        JahSlidersLabel[slider]->setText( tr( value) );
    }
}

void GLWorld::setDefaultSliderText(void)
{
    //we can make this a loop

    JahSlidersLabel[0]->setText( tr( JahSlidersLabelText[0]  ) );
    JahSlidersLabel[1]->setText( tr( JahSlidersLabelText[1]  ) );
    JahSlidersLabel[2]->setText( tr( JahSlidersLabelText[2]  ) );
    JahSlidersLabel[3]->setText( tr( JahSlidersLabelText[3]  ) );
    JahSlidersLabel[4]->setText( tr( JahSlidersLabelText[4]  ) );
    JahSlidersLabel[5]->setText( tr( JahSlidersLabelText[5]  ) );
    JahSlidersLabel[6]->setText( tr( JahSlidersLabelText[6]  ) );
    JahSlidersLabel[7]->setText( tr( JahSlidersLabelText[7]  ) );
    JahSlidersLabel[8]->setText( tr( JahSlidersLabelText[8]  ) );

}



//////////////////////////////////////////////////////
//now the slider checkbox options

// IMPORTANT
//we need to loop thorugh 'num options'
//since all options in the array may not be defined

void GLWorld::hideAllOptions( )
{

    for (int i=0; i<=8; i++)
    {
        JahModuleOption[i]->hide();
    }

}

void GLWorld::showAllOptions( )
{
    for (int i=0; i<=8; i++)
    {
        JahModuleOption[i]->show();
    }
}

void GLWorld::showOptions(int ns )
{
    for (int i=0; i<=ns; i++)
    {
        JahModuleOption[i]->show();
    }
}

void GLWorld::hideOptions(int ns )
{
    //debug("hiding");
    for (int i=0; i<=ns; i++)
    {
        JahModuleOption[i]->hide();
    }
}


void GLWorld::setOptionValue(int option, bool value)
{
    JahModuleOption[option]->setChecked(value);

}

//////////////////////////////////////////////
// Slider related

void GLWorld::updateUiOptions()       { /* this is overridden */   }

void GLWorld::updateUiSettings()       { /* this is overridden */   }


void GLWorld::updateSliders()
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "GLWorld","updating slider display");
    //jtrace.debug( "activelayer",activeLayer);

    if (!multiSelect)
    {
        hideAllSliders();
        hideAllHeadings();

        /////////////////////////////////////////////////////////////////////////////
        //basic values here
        if (activeLayer>0)
        {
            showAllSliders();
            showAllHeadings();
        }
        else
        {
            //its the world
            showSliders(6);
            showHeadings(2);
        }

        ///////////////////////////////////////////
        // update the rest of the ui
        updateSliderValues();

        updateUiOptions();

        updateUiSettings();

    }
}

//void GLWorld::updateSliderValues()  { /* this is overridden */   }


//updates all the sliders
void GLWorld::updateSliderValues()
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "GLWorld","updating slider values");
    //jtrace.debug( "activelayer",activeLayer);

    if (!multiSelect)
    {
        /////////////////////////////////////////////////////////////////////////////
        //basic values here
        if (activeLayer>0)
        {
            setSliderValue( 0, (int)layerlist->at(activeLayer)->thelayer->node->rx );
            setSliderValue( 1, (int)layerlist->at(activeLayer)->thelayer->node->ry );
            setSliderValue( 2, (int)layerlist->at(activeLayer)->thelayer->node->rz );

            setSliderValue( 3, (int)layerlist->at(activeLayer)->thelayer->node->tx );
            setSliderValue( 4, (int)layerlist->at(activeLayer)->thelayer->node->ty );
            setSliderValue( 5, (int)layerlist->at(activeLayer)->thelayer->node->tz );

            setSliderValue( 6, getScaleValue(layerlist->at(activeLayer)->thelayer->node->sx)  );
            setSliderValue( 7, getScaleValue(layerlist->at(activeLayer)->thelayer->node->sy)  );
            setSliderValue( 8, getScaleValue(layerlist->at(activeLayer)->thelayer->node->sz)  );

        }
        else
        {
            //its the camera
            setSliderValue( 0, (int)camera->node->rx );
            setSliderValue( 1, (int)camera->node->ry );
            setSliderValue( 2, (int)camera->node->rz );

            setSliderValue( 3, (int)camera->node->tx );
            setSliderValue( 4, (int)camera->node->ty );
            setSliderValue( 5, (int)camera->node->tz );
        }
    }
}

