/*******************************************************************************
**
** The header file for the Jahshaka glworld module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glworld.h"
#include "glworldheaders.h"

///////////////////////////////////////////////////////////////////////
//the new way of sorting using a linked list
//this needs to be as fast as possible, Qt has a built in sort we should 
//check it out

//we also need to be able to do reverse sorting for view behind the camera

//need to make newswap faster using  worldSort operator= operations 
void GLWorld::newswap(int x, int y)
{
    worldSort temp;

    temp.laynum = newworldorder->at(x)->laynum;
    temp.depth  = newworldorder->at(x)->depth;
    
    newworldorder->at(x)->laynum = newworldorder->at(y)->laynum; 
    newworldorder->at(x)->depth  = newworldorder->at(y)->depth; 
    
    newworldorder->at(y)->laynum = temp.laynum; 
    newworldorder->at(y)->depth  = temp.depth; 
}

//now we need to sort against the camera ie if the camera moves behind the scene
void GLWorld::newsortLayers(void) 
{
    if (numberLayers<1) 
        return;

    //for (int x=1; x<=numberLayers; x++) 
    int count=0;
    
    for ( uint x = 1; x <= layerlist->count(); ++x )
    {
        if ( layerlist->at(x) ) 
        {
            count +=1;
            
			if (newworldorder->at(x-1))
			{
				newworldorder->at(x-1)->laynum = x;
				//debug("re");
				newworldorder->at(x-1)->depth = layerlist->at(x)->thelayer->node->tz;
				//debug("ra");
			}
        }
    }
    

    // This is where we do the sorting
    for (int i = 0; i < (count-1); i++)
    {
        int minIndex = i;

        // Find the index of the minimum element
        for (int j = i + 1; j < count; j++)
        {
			if (newworldorder->at(j) && newworldorder->at(minIndex))
			{
				if (newworldorder->at(j)->depth < newworldorder->at(minIndex)->depth) 
				{ 
					minIndex = j; 
				}
			}
        }

        // Swap if i-th element not already smallest
        if (minIndex > i) { newswap(i, minIndex); }
    }

}

///////////////////////////////////////////////////////
// the old way of sorting uisng a pointer array

void GLWorld::swap(worldSort &x, worldSort &y)
{
    worldSort temp;

    temp = x;
    x = y;
    y = temp;
}


//now we need to sort against the camera ie if the camera moves behind the scene
void GLWorld::sortLayers(void) {

}





