/*******************************************************************************
**
** The source file for the Jahshaka animation selections module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/



#include "anime.h"

void GLAnime::addLayer(void)
{
//add a new layer
//issues when adding over a deleted layer -> need to reset the layer before a add is done...
bool added = TRUE;


//add on demand layers...
QPopupMenu *menu = new QPopupMenu( 0 );

//maxobjects are crashing on sgi build
#ifndef __sgi
    menu->insertItem( "MaxObject",0,0 );
#endif
    menu->insertItem( "Object",1,0 );
    menu->insertItem( "Particle",2,0 );
    menu->insertItem( "Light",3,0 );
    menu->insertItem( "3D Text",4,0 );
    menu->insertItem( "Layer",5,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );

    if ( id != -1 ) {

    numberLayers+=1;

    switch(id) {

        case 0   : {
                    layerlist->append( new NewLayerList(numberLayers, "MaxObject") );
                    layerlist->at(numberLayers)->thelayer->blend    = TRUE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->lighting = TRUE;
                    //layerlist->at(numberLayers)->thelayer->node->sx = layerlist->at(numberLayers)->thelayer->node->sy = layerlist->at(numberLayers)->thelayer->node->sz =100.0;
                    layerlist->at(numberLayers)->thelayer->objfilename = JahBasePath+"Pixmaps/face"; 
                    layerlist->at(numberLayers)->thelayer->objextension = ".3DS";
                    //debug(layerlist->at(numberLayers)->thelayer->objfilename);
                    buildLayer(numberLayers,"MaxObject", OBJECTS, MAXOBJECTS );
                    break; }

        case 1   : {
                    layerlist->append( new NewLayerList(numberLayers, "Object") );
                    layerlist->at(numberLayers)->thelayer->blend    = TRUE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->lighting = TRUE;
                    //layerlist->at(numberLayers)->thelayer->node->sx = layerlist->at(numberLayers)->thelayer->node->sy = layerlist->at(numberLayers)->thelayer->node->sz =100.0;
                    layerlist->at(numberLayers)->thelayer->objfilename = JahBasePath+"Pixmaps/f-16"; 
                    layerlist->at(numberLayers)->thelayer->objextension = ".obj";
                    //debug(layerlist->at(numberLayers)->thelayer->objfilename);
                    buildLayer(numberLayers,"Object", OBJECTS, OBJOBJECTS );
                    break; }

        case 2  : { layerlist->append( new NewLayerList(numberLayers, "Particle") );
                    layerlist->at(numberLayers)->thelayer->ParticleStyle = SWIRL;
                    layerlist->at(numberLayers)->thelayer->blend    = TRUE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->lighting = FALSE;
                    buildLayer( numberLayers, "Particle", PARTICLE, JAHPARTICLE );
                    break; }

        case 3  : { layerlist->append( new NewLayerList(numberLayers, "Light") );
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    buildLayer(numberLayers,"Light", LIGHT, JAHLIGHT );
                    break; }

        case 4  : { 
                    layerlist->append( new NewLayerList(numberLayers, "3DText") );
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->extrude = 20.0;
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FEXTRUDE; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->lighting = TRUE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->reflect = FALSE;
                    buildLayer(numberLayers,"3DText", TEXT, JAHTEXT);
                    break; }

        case 5  : { layerlist->append( new NewLayerList(numberLayers, "Layer") );
                    layerlist->at(numberLayers)->thelayer->blend          = TRUE;           
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->asset.filename = JahBasePath+"Pixmaps/jahlayer"; 
                    layerlist->at(numberLayers)->thelayer->asset.extension = ".bmp";
                    buildLayer(numberLayers,"Layer", LAYER, JAHLAYER );
                    break; }


        default  :  {  break; }

    }
    } else { added = FALSE;}

    delete menu;


if (added) 
{
        //not sure if we need this for all assets
        layerlist->at(numberLayers)->thelayer->layerAssetStatus = TRUE;

        lv->clearSelection();
        addSelection(TRUE); 
        objectMenu(numberLayers); 
        updateSliders(); 
    }

}


void GLAnime::changeParticle() {

    ParticleCategory cat;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Atom",1,0 );
    menu->insertItem( "JetSpray",2,0 );
    menu->insertItem( "Rocket",3,0 );
    menu->insertItem( "Explosion",4,0 );
    menu->insertItem( "Swirl",5,0 );
    menu->insertItem( "Balloons",6,0 );
    menu->insertItem( "Shape",7,0 );
    menu->insertItem( "FireFlies",8,0 );
    menu->insertItem( "Fountain",9,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( loadimage_3->mapToGlobal( QPoint( 0, loadimage_3->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  :  cat = ATOMIC;    break;
                case 2  :  cat = JETSPRAY;  break;
                case 3  :  cat = ROCKET;    break;
                case 4  :  cat = EXPLOSION; break;
                case 5  :  cat = SWIRL;     break;
                case 6  :  cat = BALLOONS;  break;
                case 7  :  cat = SHAPE;     break;
                case 8  :  cat = FIREFLIES; break;
                case 9  :  cat = FOUNTAIN;  break;

    }

    layerlist->at(activeLayer)->thelayer->ParticleStyle=cat;
    layerlist->at(activeLayer)->thelayer->ParticleFirsttime=TRUE;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLAnime::changeParticleDraw() {

    ParticleDrawstyle cat;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Point",1,0 );
    menu->insertItem( "Line",2,0 );
    menu->insertItem( "Texture",3,0 );
    menu->insertItem( "Clip",4,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( loadimage_3->mapToGlobal( QPoint( 0, loadimage_3->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  :  cat = PARPOINT;   break;
                case 2  :  cat = PARLINE;    break;
                case 3  :  cat = PARGAUSS;   break;
                case 4  :  cat = PARTEXTURE; break;
                default :                    break;

    }

    layerlist->at(activeLayer)->thelayer->ParticleDraw=cat;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLAnime::changeFontDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Textured",  6,0 );
    menu->insertItem( "3d Extrude",5,0 );
    menu->insertItem( "Polygon",   4,0 );
    menu->insertItem( "Outline",   3,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( textDraw->mapToGlobal( QPoint( 0, textDraw->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 3  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FOUTLINE;    break;
                case 4  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FPOLYGON;    break;
                case 5  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FEXTRUDE;    break;
                case 6  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FTEXTURE;    break;
                default :                                                    break;
    }
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLAnime::changeObjectDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Plain",1,0 );
    menu->insertItem( "Color",2,0 );
    menu->insertItem( "Material",3,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( objectstyle->mapToGlobal( QPoint( 0, objectstyle->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  :  layerlist->at(activeLayer)->thelayer->material_mode = 0; break;
                case 2  :  layerlist->at(activeLayer)->thelayer->material_mode = 1; break;
                case 3  :  layerlist->at(activeLayer)->thelayer->material_mode = 2; break;
                default :                                          break;
    }
    }

    delete menu;
    updateGL();  //redraw scene
}


void GLAnime::keyCliplayer() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_DST_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_COLOR",4,0 );
    menu->insertItem( "GL_SRC_ALPHA",5,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  : {  blendmode = GL_ZERO; break; }
                case 2  : {  blendmode = GL_ONE; break; }
                case 3  : {  blendmode = GL_DST_COLOR; break; }
                case 4  : {  blendmode = GL_ONE_MINUS_DST_COLOR; break; }
                case 5  : {  blendmode = GL_SRC_ALPHA; break; }

    }
    layerlist->at(activeLayer)->thelayer->blendmode1=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLAnime::keyClipkey() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_SRC_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_COLOR",4,0 );
    menu->insertItem( "GL_SRC_ALPHA",5,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_ALPHA",6,0 );
    menu->insertItem( "GL_DST_ALPHA",7,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_ALPHA",8,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  : { blendmode = GL_ZERO; break; }
                case 2  : { blendmode = GL_ONE; break; }
                case 3  : { blendmode = GL_SRC_COLOR; break; }
                case 4  : { blendmode = GL_ONE_MINUS_SRC_COLOR; break; }
                case 5  : { blendmode = GL_SRC_ALPHA; break; }
                case 6  : { blendmode = GL_ONE_MINUS_SRC_ALPHA; break; }
                case 7  : { blendmode = GL_DST_ALPHA; break; }
                case 8  : { blendmode = GL_ONE_MINUS_DST_ALPHA; break; }
    }
    layerlist->at(activeLayer)->thelayer->blendmode2=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene

}

















