/*******************************************************************************
**
** The source file for the Jahshaka effects objects module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "colorize.h"

void GLColorize::callEffect( FxCategory thefx,  int i, QImage& newimage ) 
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "GLColorize::","building effect#",i);

    effectobj = i;

    switch ( thefx ) {

      case RTCOLORS                   : {  doRtColors(i);                      break; }
      case COLORMATRIX                : {  doColorMatrix(i);                      break; }
      case NEGATIVE                   : {  doNegative(newimage);                  break; }
      case SWAPRGB                    : {  doSwapRGB(newimage);                   break; }
      default                 : {  break; }

    }
}


