/*******************************************************************************
**
** The source file for the Jahshaka animation selections module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/



#include "colorize.h"


void GLColorize::addLayer(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...

   //add on demand layers...
   bool added = TRUE;

   QPopupMenu *menu = new QPopupMenu( 0 );

    //qt based image processing
    menu->insertItem( "SwapRGB",SWAPRGB,0 );
    menu->insertItem( "Negative",NEGATIVE,0 );

    //opengl based realtime opps
    menu->insertItem( "RGB2Luminance",COLORMATRIX,0 );
    menu->insertItem( "RtColors",RTCOLORS,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );
    QString layNum,temp;
    QString title;

    if ( id != -1 && initialized ) {

      numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {

         case SWAPRGB  : {  
                      title="SwapRGB";
                      layerlist->append( new NewLayerList(numberLayers, title) );             
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = SWAPRGB;
                      break; }

        case NEGATIVE  : {  
                      title = "Negative";
                      layerlist->append( new NewLayerList(numberLayers, title) );             
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = NEGATIVE;
                      break; }
                      
       case COLORMATRIX  : {  
                      title = "RGB2luminance";
                      layerlist->append( new NewLayerList(numberLayers, title) );             
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = COLORMATRIX;
                      break; }
                      
       case RTCOLORS  : {  
                      title = "Colorize";
                      layerlist->append( new NewLayerList(numberLayers, title) );             
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = RTCOLORS;
                      break; }
                      
         default : { break; }
      }
    }  else { added = FALSE; }

    delete menu;

    if (added)
    {  
        effects->at(numberLayers)->fxlayer->effectnumber = numberLayers;
        layerlist->at(numberLayers)->thelayer->layertype = LAYER; 
        
        layerlist->at(1)->thelayer->objtype = MESHLAYER;

        addSelection(TRUE); 
        objectMenu(numberLayers); 
        updateSliders();
        
    }               

}




















