/*******************************************************************************
**
** The source file for the Jahshaka editing selections module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/


#include "edit.h"

void GLEdit::addLayer(void)
{
//add a new layer
//issues when adding over a deleted layer -> need to reset the layer before a add is done...
    bool added = TRUE;
    bool isvideo = FALSE;

//add on demand layers...
QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Graphic",7,0 );
    menu->insertItem( "Text",4,0 );
    menu->insertItem( "VidLayer",1,0 );
//menu->insertItem( "Desktop",8,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) {

    numberLayers+=1; //layNum.setNum(numberLayers);

    switch(id) {
        case 1  : {

                    //only add where we need to grab the clip from the desktop first...
                    //unless on dual head then we need to implement drag and drop

                    layerlist->append( new NewLayerList(numberLayers, "VidLayer") );
                    layerlist->at(numberLayers)->thelayer->blend          = TRUE;           
                    layerlist->at(numberLayers)->thelayer->depth = FALSE;
                    layerlist->at(numberLayers)->thelayer->asset.filename = JahBasePath+"Pixmaps/jahlayer"; 
                    layerlist->at(numberLayers)->thelayer->asset.extension = ".bmp";
                    buildLayer(numberLayers,"VidLayer", LAYER, JAHLAYER );

                    layerlist->at(numberLayers)->thelayer->showEdges = false;
                    layerlist->at(numberLayers)->thelayer->foreground = true;

                    isvideo = TRUE;

                    //addDesktop();

                    break; }

        case 4  : { layerlist->append( new NewLayerList(numberLayers, "3DText") );
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->extrude = 20.0;
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FEXTRUDE; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->node->sx = layerlist->at(numberLayers)->thelayer->node->sy = layerlist->at(numberLayers)->thelayer->node->sz = 5.0;
                    layerlist->at(numberLayers)->thelayer->lighting = TRUE; layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->reflect = FALSE;
                    buildLayer(numberLayers,"3DText", TEXT, JAHTEXT);

                    break; }

        case 7  : { layerlist->append( new NewLayerList(numberLayers, "Layer") );
                    layerlist->at(numberLayers)->thelayer->blend          = TRUE;           
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->asset.filename = JahBasePath+"Pixmaps/jahlayer"; 
                    layerlist->at(numberLayers)->thelayer->asset.extension = ".bmp";
                    buildLayer(numberLayers,"Layer", LAYER, JAHLAYER );

                    break; }

        default  :  {  break; }
        //not functional yet, switches to desktop for a clip selection and returns
        //case 7  : { debug("Desktop");  break; }
    }
    } 
    else 
    { 
        added = FALSE;
    }

    delete menu;

    if (added) 
    {
        layerlist->at(numberLayers)->thelayer->layerAssetStatus = TRUE;
        addSelection(TRUE,TRUE); 
        objectMenu(numberLayers); 
        updateSliders();

    //The is where we need to add a bar to editinterface
    //only do this for graphics and text ok, need a flag...
    //ie bool isvideo;


        if (!isvideo) 
        {
            debug("in the selection");
            theeditdesktop->addEditLayer( numberLayers,
                                        layerlist->at(numberLayers)->thelayer->asset.videotex,
                                        layerlist->at(numberLayers)->thelayer->asset.startframe,
                                        layerlist->at(numberLayers)->thelayer->asset.endframe
                                        );
        }
        else
        {
            addDesktop();
        }
}

}

//cool now a layer is created and we have the videodata for it...
void GLEdit::addClipEdit(videoData newclip) 
{

    //extract video data before moving ahead!
    debug("in addClipEdit");

    //first add the clip to the layer itself
    addClip(newclip);

    //now add the clip to the timeline
    theeditdesktop->addEditLayer(numberLayers, newclip );


}






void GLEdit::changeParticle() {


    ParticleCategory cat;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Atom",1,0 );
    menu->insertItem( "JetSpray",2,0 );
    menu->insertItem( "Waterfall",3,0 );
    menu->insertItem( "Rocket",4,0 );
    menu->insertItem( "Explosion",5,0 );
    menu->insertItem( "Swirl",6,0 );
    menu->insertItem( "Balloons",7,0 );
    menu->insertItem( "Shape",8,0 );
    menu->insertItem( "FireFlies",9,0 );
    menu->insertItem( "Shower",10,0 );
    menu->insertItem( "Fountain",11,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( loadimage_3->mapToGlobal( QPoint( 0, loadimage_3->height() + 1 ) ) );

    if ( id != -1 ) 
    {
        switch(id) 
        {
                case 1  :  cat = ATOMIC; break;
                case 2  :  cat = JETSPRAY; break;
                case 3  :  cat = WATERFALL; break;
                case 4  :  cat = ROCKET; break;
                case 5  :  cat = EXPLOSION; break;
                case 6  :  cat = SWIRL; break;
                case 7  :  cat = BALLOONS; break;
                case 8  :  cat = SHAPE; break;
                case 9  :  cat = FIREFLIES; break;
                case 10 :  cat = SHOWER; break;
                case 11 :  cat = FOUNTAIN; break;
        }

        layerlist->at(activeLayer)->thelayer->ParticleStyle=cat;
        layerlist->at(activeLayer)->thelayer->ParticleFirsttime=TRUE;

    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEdit::changeFontDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Solid",1,0 );
    menu->insertItem( "Outline",2,0 );
    menu->insertItem( "3D",3,0 );
    //menu->insertItem( "Textured",4,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( textDraw->mapToGlobal( QPoint( 0, textDraw->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FPOLYGON;    break;
                case 2  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FOUTLINE;    break;
                case 3  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FEXTRUDE;    break;
            //   case 4  :  layers[activeLayer].text->fontstyle = FTEXTURED; break;
                default :                                                    break;
    }
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEdit::changeObjectDraw() {

    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Plain",1,0 );
    menu->insertItem( "Color",2,0 );
    menu->insertItem( "Material",3,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( objectstyle->mapToGlobal( QPoint( 0, objectstyle->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  :  layerlist->at(activeLayer)->thelayer->material_mode = 0; break;
                case 2  :  layerlist->at(activeLayer)->thelayer->material_mode = 1; break;
                case 3  :  layerlist->at(activeLayer)->thelayer->material_mode = 2; break;
                default :                                          break;
    }
    }

    delete menu;
    updateGL();  //redraw scene
}


void GLEdit::keyCliplayer() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_DST_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_COLOR",4,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  : { debug("clip: GL_ZERO"); blendmode = GL_ZERO; break; }
                case 2  : { debug("clip: GL_ONE"); blendmode = GL_ONE; break; }
                case 3  : { debug("clip: GL_DST_COLOR"); blendmode = GL_DST_COLOR; break; }
                case 4  : { debug("clip: GL_ONE_MINUS_DST_COLOR"); blendmode = GL_ONE_MINUS_DST_COLOR; break; }

    }

    layerlist->at(activeLayer)->thelayer->blendmode1=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene
}

void GLEdit::keyClipkey() {

    GLenum blendmode;
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "GL_ZERO",1,0 );
    menu->insertItem( "GL_ONE",2,0 );
    menu->insertItem( "GL_SRC_COLOR",3,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_COLOR",4,0 );
    menu->insertItem( "GL_SRC_ALPHA",5,0 );
    menu->insertItem( "GL_ONE_MINUS_SRC_ALPHA",6,0 );
    menu->insertItem( "GL_DST_ALPHA",7,0 );
    menu->insertItem( "GL_ONE_MINUS_DST_ALPHA",8,0 );


    menu->setMouseTracking( TRUE );
    int id = menu->exec( keyimage_2->mapToGlobal( QPoint( 0, keyimage_2->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 1  : { debug("key: GL_ZERO"); blendmode = GL_ZERO; break; }
                case 2  : { debug("key: GL_ONE"); blendmode = GL_ONE; break; }
                case 3  : { debug("key: GL_SRC_COLOR"); blendmode = GL_SRC_COLOR; break; }
                case 4  : { debug("key: GL_ONE_MINUS_SRC_COLOR"); blendmode = GL_ONE_MINUS_SRC_COLOR; break; }
                case 5  : { debug("key: GL_SRC_ALPHA"); blendmode = GL_SRC_ALPHA; break; }
                case 6  : { debug("key: GL_ONE_MINUS_SRC_ALPHA"); blendmode = GL_ONE_MINUS_SRC_ALPHA; break; }
                case 7  : { debug("key: GL_DST_ALPHA"); blendmode = GL_DST_ALPHA; break; }
                case 8  : { debug("key: GL_ONE_MINUS_DST_ALPHA"); blendmode = GL_ONE_MINUS_DST_ALPHA; break; }
    }

    layerlist->at(activeLayer)->thelayer->blendmode2=blendmode;
    }

    delete menu;
    updateGL();  //redraw scene

}












