###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE    =           lib
CONFIG      +=          staticlib qt warn_on release opengl thread
HEADERS     =           effect.h

SOURCES     =           effect.cpp \
                        effectglcore.cpp \
                        effectinterface.cpp \
                        effectobjects.cpp \
                        effectobjectsrt.cpp \
                        effectselections.cpp \
                        effectobjectsproc.cpp \
                        effectobjectsGpu.cpp \
                        effectobjectsPlugins.cpp

contains( NVIDIA_GPGPU,true ) {
SOURCES     +=          effectobjectsGpgpu.cpp
}

TARGET      =           effect
DEPENDPATH  =           $$JAHDEPENDPATH

###############################################################
#the project related includes
INCLUDEPATH =           . .. \
                        ../../Source \
                        ../../Core/Objects \
                        ../../Core/Render \
                        ../../Core/World  \
                        ../../desktop

contains( JAHOS,LINUX ) {
INCLUDEPATH +=          ../../encoders/mpegdec
}

#files for audiosupport
contains( JAHAUDIO,true ) {
INCLUDEPATH +=          ../../libraries/jahaudio
}

INCLUDEPATH +=          ../../Modules/effect \
                        ../../libraries \
                        ../../libraries/assetobject \
                        ../../libraries/GLCore \
                        ../../libraries/glew \
                        ../../libraries/imagelibs \
                        ../../libraries/jahkeyframes \
                        ../../libraries/jahpreferences \
                        ../../libraries/jahtranslate \
                        ../../libraries/jahtimer \
                        ../../libraries/jahtracer \
                        ../../libraries/mediaobject
                        
contains( SPACEBALL,true ) {
INCLUDEPATH     +=      ../../libraries/spaceball
}

INCLUDEPATH +=          ../../libraries/jahplugins \
                        ../../libraries/gpumathlib \
                        ../../uiwidgets \
                        ../../uiwidgets/interfaceobjs \
                        ../../uiwidgets/jahcalc \
                        ../../uiwidgets/jahfileloader \
                        ../../uiwidgets/keyframes \
                        ../../uiwidgets/nodes \
                        ../../uiwidgets/timeline \
                        ../../sqlite \
                        ../../objectlibs/FTGL \
                        ../../objectlibs/glmlib \
                        ../../objectlibs/l3ds \
                        ../../objectlibs/particle \
                        ../../objectlibs/blur \
                        ../../sqlite \
                        $$FREEDIR


contains( JAHOS,IRIX ) {
INCLUDEPATH +=      $$SGIDIR
}


