/*******************************************************************************
**
** The source file for the Jahshaka effects selections module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "effect.h"

////////////////////////////////////////////////////////////////////////////
// for cpu based effects
//need to rename the routine to be addLayerCPU or something more relevant

void GLEffect::addLayer(void)
{

   //add on demand layers...
   bool added = TRUE;
   QPopupMenu *menu = new QPopupMenu( 0 );

    int existingitems = 0;

    //math based functions
    menu->insertItem( "Grey",existingitems,0 );                     existingitems+=1;
    menu->insertItem( "Edge Detection",existingitems,0 );           existingitems+=1;
    menu->insertItem( "Select Colors",existingitems,0 );            existingitems+=1;
    menu->insertItem( "Contrast",existingitems,0 );                 existingitems+=1;
    menu->insertItem( "Brightness",existingitems,0 );               existingitems+=1;
    menu->insertItem( "Sharpen",existingitems,0 );                  existingitems+=1;
    menu->insertItem( "Blur",existingitems,0 );                     existingitems+=1;
    menu->insertItem( "Emboss",existingitems,0 );                   existingitems+=1;
    menu->insertItem( "Gaussian Blur",existingitems,0 );            existingitems+=1;
    menu->insertItem( "Mirror",existingitems,0 );                   existingitems+=1;
    menu->insertItem( "SwapRGB",existingitems,0 );                  existingitems+=1;
    menu->insertItem( "Negative",existingitems,0 );                 existingitems+=1;

   //////////////////////////////////////////////////////////////////////////////////
   //check for plugins now - make this a subroutine please and just pass what we need to pass

   //the class of plugin
    int usingclass = 1;

    int totalitems  = existingitems -1;

    if (jplugin->vfxPluginsCounter>0)
    {
        totalitems = addPluginsToMenu(usingclass, existingitems, menu);
    }

	//if the gpu is active you cant see/use cpu effects...
    if (gpuactive)
    {
        for (int i=0; i<=totalitems; i++)
            menu->setItemEnabled(i,false);
    }

    ////////////////////////////////////////////////////////////////////////////////

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );

    QString rere;
    //debug("the id is:"+rere.setNum(id));

    QString layNum,temp;
    QString title;

    if ( id != -1 && initialized )
    {

      numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {

         case 0  : {  title = "Grey";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = GREY;
                      break; }

         case 1  : {  title = "Edge Detect";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = EDGE;
                      break; }

         case 2  : {  title = "Select Colors";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = SELECTCOLORS;
                      break; }

         case 3 : {   title="Contrast";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = CONTRAST;
                      break; }

         case 4 : {   title="Brightness";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = BRIGHTNESS;
                      break; }

         case 5 : {   title="Sharpen";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = MATRIXSHARPEN;
                      break; }

         case 6 : {   title="Blur";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = MATRIXBLUR;
                      break; }

         case 7   : {   title="Emboss";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = MATRIXEMBOSS;
                      break; }

         case 8   : { title="Gaussian Blur";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = GAUSSIANBLUR;
                      effects->at(numberLayers)->fxlayer->r=100;
                      break; }

         case 9   : { title="Mirror";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = MIRROR;
                      break; }

         case 10  : { title="SwapRGB";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = SWAPRGB;
                      break; }

        case  11  : {  title = "Negative";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = NEGATIVE;
                      break; }

         default : { added = false; break; }
      }

        //////////////////////////////////////////////////////
        // wasnt in the switch check if its a plugn
        if (!added)
        {
            QString thename = menu->text(id);
            int itemid = jplugin->getPluginId(thename,usingclass);

            if (itemid>=0)
            {
                title = jplugin->vfxPlugins->at(itemid)->getPluginName();
                layerlist->append( new NewLayerList(numberLayers, title) );
                layerlist->at(numberLayers)->thelayer->layername = title;

                effects->append( new FxLayerList(numberLayers) );
                effects->at(numberLayers)->fxlayer->objtype = JAHPLUGIN; //JAHPLUGIN
                effects->at(numberLayers)->fxlayer->pluginnumber = itemid; //JAHPLUGIN
                added = TRUE;
            }
            else
            {
                added = FALSE;
            }
        }
    }

    /////////////////////////////////////////////////////
    // add it to the system
    if (added && (id>=0) && initialized)
    {
        effects->at(numberLayers)->fxlayer->effectnumber = numberLayers;
        layerlist->at(numberLayers)->thelayer->layertype  = LAYER;
        layerlist->at(numberLayers)->thelayer->objtype = EFFECT;

        layerlist->at(1)->thelayer->objtype = MESHLAYER;

        forceupdatefxbuffer = true;

        addSelection(TRUE); objectMenu(numberLayers); updateSliders();
        thenodeframer->addNodes(numberLayers,title);
    }

    ///////////////////////////////////////////////////
    // clean up on the way out
    delete menu;

}


void GLEffect::addRTLayer(void)
{
   //add on demand layers...
   bool added = TRUE;
   QPopupMenu *menu = new QPopupMenu( 0 );

    int existingitems = 0;

    menu->insertItem( "Flag RT",existingitems,0 );                  existingitems+=1;
    menu->insertItem( "Ripple RT",existingitems,0 );                existingitems+=1;
    menu->insertItem( "FishEye RT",existingitems,0 );               existingitems+=1;
    menu->insertItem( "Swirl RT",existingitems,0 );                 existingitems+=1;

    ///////////////////////////////////////////////////////////////////

    int usingclass = 3;
    int totalitems  = existingitems -1;

    if (jplugin->vfxPluginsCounter>0)
    {
        totalitems = addPluginsToMenu(usingclass, existingitems, menu);
    }

    ///////////////////////////////////////////////////////////////////

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddRTButton->mapToGlobal( QPoint( 0, AddRTButton->height() + 1 ) ) );
    QString layNum,temp;
    QString title;

    if ( id != -1 && initialized ) {

      numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {

         case 0 : {   title="Flag RT";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = FLAGRT;
                      break; }

         case 1 : {   title="Ripple RT";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = RIPPLERT;
                      break; }

         case 2 : {   title="Fisheye RT";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = FISHEYERT;
                      break; }

         case 3 : {   title="Swirl RT";
                      layerlist->append( new NewLayerList(numberLayers, title) );
                      layerlist->at(numberLayers)->thelayer->layername = title;
                      effects->append( new FxLayerList(numberLayers) );
                      effects->at(numberLayers)->fxlayer->objtype = SWIRLRT;
                      break; }


         default : { added = false; break; }
      }

      //////////////////////////////////////////////////////
      // wasnt in the switch check if its a plugn

      if (!added)
      {
        QString thename = menu->text(id);
        int itemid = jplugin->getPluginId(thename,usingclass);

        if (itemid>=0)
        {
            title = jplugin->vfxPlugins->at(itemid)->getPluginName();
            layerlist->append( new NewLayerList(numberLayers, title) );
            layerlist->at(numberLayers)->thelayer->layername = title;

            effects->append( new FxLayerList(numberLayers) );
            effects->at(numberLayers)->fxlayer->objtype = JAHPLUGIN; //JAHPLUGIN
            effects->at(numberLayers)->fxlayer->pluginnumber = itemid; //JAHPLUGIN
            added = TRUE;
        }
        else
        {
            added = FALSE;
        }

     }

    }

    delete menu;

    ////////////////////////////////////////////////////
    //add it to the system now

    if (added && (id>=0) && initialized )
    {
        effects->at(numberLayers)->fxlayer->effectnumber = numberLayers;
        layerlist->at(numberLayers)->thelayer->layertype = LAYER;
        layerlist->at(numberLayers)->thelayer->objtype = EFFECT; 

        layerlist->at(1)->thelayer->objtype = MESHLAYER;

        addSelection(TRUE);
        objectMenu(numberLayers);
        updateSliders();

        forceupdatefxbuffer = true;

        thenodeframer->addNodes(numberLayers,title);
    }
}

void GLEffect::addGpuLayer(void)
{

   //add on demand layers...
   bool added = TRUE;

   QPopupMenu *menu = new QPopupMenu( 0 );

    int existingitems = 0;

    if (nv_gpusupport)
    {
        menu->insertItem( "NV30::3D Fire GPU", existingitems,0 );           existingitems+=1;
        menu->insertItem( "NV30::Earthquake NV30 GPU", existingitems,0 );   existingitems+=1;
    }


    #ifdef NVIDIA_GPGPU
    menu->insertItem( "Fisheye NV30 GPGPU", existingitems, 0 );             existingitems+=1;
    menu->insertItem( "Swirl NV30 GPGPU", existingitems, 0 );               existingitems+=1;
    #endif // NVIDIA_GPGPU

   /////////////////////////////////////////////////////////////////////////////////////////////////////////
   //little security mechanism here
   //if there are no plugins skip the following and head straight to the existing defs...
   //if (jplugin->vfxPluginsCounter==0) return;

    int usingclass = 2;

    int totalitems  = existingitems -1;

    if (jplugin->vfxPluginsCounter>0)
    {
        totalitems = addPluginsToMenu(usingclass, existingitems, menu);
    }

    if (!gpuactive)
    {
        for (int i=0; i<=totalitems; i++)
            menu->setItemEnabled(i,false);
    }

    ////////////////////////////////////////////////////////////////////////////////

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddRTButton->mapToGlobal( QPoint( 0, AddRTButton->height() + 1 ) ) );

    QString layNum,temp;
    QString title;

    if ( id != -1 && initialized ) {

      numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {

         case 0 : {   
                     if (nv_gpusupport)
                     {
                         title="3D Fire NV30";
                         layerlist->append( new NewLayerList(numberLayers, title) );
                         layerlist->at(numberLayers)->thelayer->layername = title;
                         effects->append( new FxLayerList(numberLayers) );
                         effects->at(numberLayers)->fxlayer->objtype = FIRE3D_NV30_GPU;
                         break;
                     }
                  }

         case 1 : {  
                     if (nv_gpusupport)
                     {
                         title="Earthquake NV30";
                         layerlist->append( new NewLayerList(numberLayers, title) );
                         layerlist->at(numberLayers)->thelayer->layername = title;
                         effects->append( new FxLayerList(numberLayers) );
                         effects->at(numberLayers)->fxlayer->objtype = EARTHQUAKE_NV30_GPU;
                         break; 
                     }
                  }

        #ifdef NVIDIA_GPGPU
         case 2 : { title="Fisheye NV30 GPGPU";
                     layerlist->append( new NewLayerList(numberLayers, title) );
                     layerlist->at(numberLayers)->thelayer->layername = title;
                     effects->append( new FxLayerList(numberLayers) );
                     effects->at(numberLayers)->fxlayer->objtype = FISHEYE_NV30_GPGPU;
                     break; }

         case 3 : { title="Swirl NV30 GPGPU";
                     layerlist->append( new NewLayerList(numberLayers, title) );
                     layerlist->at(numberLayers)->thelayer->layername = title;
                     effects->append( new FxLayerList(numberLayers) );
                     effects->at(numberLayers)->fxlayer->objtype = SWIRL_NV30_GPGPU;
                     break; }
        #endif // NVIDIA_GPGPU

         default : { added = false;  break; }
      }

        //////////////////////////////////////////////////////
        // wasnt in the switch check if its a plugn

        if (!added)
        {
            QString thename = menu->text(id);
            int itemid = jplugin->getPluginId(thename,usingclass);

            if (itemid>=0)
            {
                title = jplugin->vfxPlugins->at(itemid)->getPluginName();
                layerlist->append( new NewLayerList(numberLayers, title) );
                layerlist->at(numberLayers)->thelayer->layername = title;

                effects->append( new FxLayerList(numberLayers) );
                effects->at(numberLayers)->fxlayer->objtype = JAHPLUGIN; //JAHPLUGIN
                effects->at(numberLayers)->fxlayer->pluginnumber = itemid; //JAHPLUGIN
                added = TRUE;
            }
            else
            {
                added = FALSE;
            }
        }
    }

    ////////////////////////////////////////////////////
    //add it to the system now

    if (added && (id>=0) && initialized)
    {
        effects->at(numberLayers)->fxlayer->effectnumber = numberLayers;
        layerlist->at(numberLayers)->thelayer->layertype = LAYER;
        layerlist->at(numberLayers)->thelayer->objtype = EFFECT;

        layerlist->at(1)->thelayer->objtype = MESHLAYER;

        addSelection(TRUE);
        objectMenu(numberLayers);
        updateSliders();

        forceupdatefxbuffer = true;

        thenodeframer->addNodes(numberLayers,title);
    }

    ///////////////////////////////////////////////////
    //clean up on the way out
    delete menu;

}

/////////////////////////////////////////////////////////////////////////////////
// for the plugins
int GLEffect::addPluginsToMenu(int usingclass, int existingitems, QPopupMenu *menu)
{
    //math based functions
    //int plugcount = 0;
    QPopupMenu *  submenu[10];
    QString     * submenutitle[10];
    int submenucount = 0;

    int menuitem = existingitems;

    for (int x=0; x<jplugin->vfxPluginsCounter; x++)
    {
        // first check for family
        //  if fmaily exists we add plugin there
        //      then check for group
        //          if group exists we add plugin in family, in group

        QString name, family, group;

        name   = jplugin->vfxPlugins->at(x)->getPluginName();
        family = jplugin->vfxPlugins->at(x)->getPluginFamily();
        group  = jplugin->vfxPlugins->at(x)->getPluginGroup();

        //////////////////////////////////////////////////////////////
        //need to get plugin type so we can put it in the right menu ie gpu etc
        //need to also get arb or nv support...
        JAH_PLUGIN_CLASS pluginclass;
        pluginclass = jplugin->vfxPlugins->at(x)->getPluginClass();
        if (pluginclass!=usingclass) continue;


        ///////////////////////////////////////////////////////////////
        //plugin isnt part of a family we put it in the base menu
        if (family=="NULL")
        {
            menu->insertItem( name,menuitem,0 );
        }
        else
        {
            //////////////////////////////////////////////////////////////
            //its part of a family we put it in a submenu
            //need to check if the submenu already exists for reusability
            bool exists = false;;
            int submenuexists;

            if (submenucount>0)
            {
                for (int i=0; i<submenucount; i++)
                {
                    if ( *submenutitle[i]==family )
                    {
                        exists = true;
                        submenuexists = i;
                    }
                    if (exists) break;
                }
            }

            if (exists)
            {
                submenu[submenuexists]->insertItem( name, menuitem, 0 );
            }
            else
            {
                submenutitle[submenucount] = new QString(family);
                submenu[submenucount] = new QPopupMenu(0);

                Q_CHECK_PTR( submenu[submenucount] );
                submenu[submenucount]->insertItem( name, menuitem, 0 );

                menu->insertItem( family, submenu[submenucount] );
                submenucount++;
            }
        }
        //means we added it so increment
        menuitem ++;
    }

    return menuitem;
}
/*
void GLEffect::addPluginLayer(void)
{
   JahPluginLib* jplugin = JahPluginLib::getInstance();

   //little security mechanism here
   if (jplugin->vfxPluginsCounter==0) return;

   bool added = TRUE;

   QPopupMenu *menu = new QPopupMenu( 0 );

    //math based functions
    //int plugcount = 0;
    QPopupMenu *  submenu[10];
    QString     * submenutitle[10];
    int submenucount = 0;

    int menuitem = 0;

    for (int x=0; x<jplugin->vfxPluginsCounter; x++)
    {
        // first check for family
        //  if fmaily exists we add plugin there
        //      then check for group
        //          if group exists we add plugin in family, in group

        QString name, family, group;

        name   = jplugin->vfxPlugins->at(x)->getPluginName();
        family = jplugin->vfxPlugins->at(x)->getPluginFamily();
        group  = jplugin->vfxPlugins->at(x)->getPluginGroup();

        //////////////////////////////////////////////////////////////
        //need to get plugin type so we can put it in the right menu ie gpu etc
        //need to also get arb or nv support...
        int pluginclass;
        pluginclass = jplugin->vfxPlugins->at(x)->getPluginClass();
        if (pluginclass != JAH_GPU_PLUGIN) continue;


        ///////////////////////////////////////////////////////////////
        //plugin isnt part of a family we put it in the base menu
        if (family=="NULL")
        {
            menu->insertItem( name,menuitem,0 );
        }
        else
        {
            //////////////////////////////////////////////////////////////
            //its part of a family we put it in a submenu
            //need to check if the submenu already exists for reusability
            bool exists = false;;
            int submenuexists;

            if (submenucount>0)
            {
                for (int i=0; i<submenucount; i++)
                {
                    if ( *submenutitle[i]==family )
                    {
                        exists = true;
                        submenuexists = i;
                    }

                    if (exists) break;
                }
            }

            if (exists)
            {
                submenu[submenuexists]->insertItem( name, menuitem, 0 );
            }
            else
            {
                submenutitle[submenucount] = new QString(family);
                submenu[submenucount] = new QPopupMenu(0);

                Q_CHECK_PTR( submenu[submenucount] );
                submenu[submenucount]->insertItem( name, menuitem, 0 );

                menu->insertItem( family, submenu[submenucount] );
                submenucount++;

            }
        }

        //means we added it so increment
        menuitem ++;

    }


    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddPluginButton->mapToGlobal( QPoint( 0, AddPluginButton->height() + 1 ) ) );

    QString layNum,temp;
    QString title;

    if ( id != -1 && initialized )
    {
        debug("in here");

        if (jplugin->vfxPlugins->at(id))
        {
            numberLayers+=1; layNum.setNum(numberLayers);

            title = jplugin->vfxPlugins->at(id)->getPluginName();
            layerlist->append( new NewLayerList(numberLayers, title) );
            layerlist->at(numberLayers)->thelayer->layername = title;

            effects->append( new FxLayerList(numberLayers) );
            effects->at(numberLayers)->fxlayer->objtype = JAHPLUGIN; //JAHPLUGIN
            effects->at(numberLayers)->fxlayer->pluginnumber = id; //JAHPLUGIN
        }
        else
        {
            added = FALSE;
        }
    }
    else
    {
        added = FALSE;
    }

    delete menu;

    //////////////////////////////////////////////////////////
    // if it worked...

    if (added)
    {
        effects->at(numberLayers)->fxlayer->effectnumber = numberLayers;
        layerlist->at(numberLayers)->thelayer->layertype = LAYER;
        layerlist->at(numberLayers)->thelayer->objtype = EFFECT;

        layerlist->at(1)->thelayer->objtype = MESHLAYER;

        forceupdatefxbuffer = true;

        addSelection(TRUE); objectMenu(numberLayers); updateSliders();
        thenodeframer->addNodes(numberLayers,title);
    }

}
*/
