/*******************************************************************************
**
** The header file for the Jahshaka render dialog
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef RenderDialog_h
#define RenderDialog_h

/////////////////////////////////////////////////
// RenderConfig class stores configuration settings
// and is used to send them to the encoder...
#include "RenderConfig.h"

//////////////////////////////////////////////////
// asset/media is sent as a videodata object
#include "coreobject.h"
#include "videodata.h"

/////////////////////////////////////////////////
// the encoder is kicked off by the encoding thread
//#include <encodingthread.h>

#include <iostream>
#include <sstream>
#include <stdio.h>

#include <qlabel.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qslider.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qtoolbutton.h>
#include <qmultilineedit.h>
#include <qtextstream.h>
#include <qprogressbar.h>
#include "interfaceobjs/InputLCD.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <qmessagebox.h>
#include <qapplication.h>
#include <qfiledialog.h>
#include <qprogressdialog.h>

#include "encoderthread.h"
#include "jahpreferences.h"


//====================================================================
class RenderDialog : public QDialog
{
    Q_OBJECT

public:
    RenderDialog(const char *name, RenderConfig * thedata, videoData assetData, JahEncoder encoder);
    ~RenderDialog();

    //the encoding thread
    EncodeThread * mythread;

    //the configuration info for the encoder
    RenderConfig * configData;

    //the configuration info for the encoder
	videoData assetObject;
	
	JahEncoder theEncoder;

    void	doEncode();

protected slots:

    void	cancelPressed();

protected:

    QLabel * TitleLabel;
    QPushButton	*cancelBut;
    QProgressBar *progBar;
    QMultiLineEdit	*encodeOutput;

};


#endif // RenderDialog_h
