###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE = lib
CONFIG      +=      staticlib qt warn_on release opengl thread
HEADERS     =       MainEncoder.h \
                    RenderDialog.h \
                    RenderConfig.h \
                    encoderthread.h
SOURCES     =       MainEncoder.cpp \
                    MainEncoderInterface.cpp \
                    MainEncoderRoutines.cpp \
                    RenderDialog.cpp \
                    encoderthread.cpp

TARGET      =       renderdialog
DEPENDPATH  =       $$JAHDEPENDPATH

###############################################################
#the project related includes
INCLUDEPATH =       . .. ../../Source \
                    ../../Core/Objects ../../Core/Render ../../Core/World  \
                    ../../desktop

#files for mpeg encoder on linux
#contains( JAHMPEGENCODER,true ) {
INCLUDEPATH +=  ../../encoders/mpegenc
#}

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
INCLUDEPATH +=  ../../encoders/mpegdec
}

#files for audiosupport
contains( JAHAUDIO,true ) {
INCLUDEPATH +=          ../../libraries/jahaudio
}

INCLUDEPATH +=          ../../Modules/encoder \
                        ../../libraries \
                        ../../libraries/assetobject \
                        ../../libraries/GLCore \
                        ../../libraries/glew \
                        ../../libraries/imagelibs \
                        ../../libraries/jahkeyframes \
                        ../../libraries/jahpreferences \
                        ../../libraries/jahtimer \
                        ../../libraries/jahtracer \
                        ../../libraries/mediaobject
                        
contains( SPACEBALL,true ) {
INCLUDEPATH     +=      ../../libraries/spaceball
}

INCLUDEPATH +=          ../../libraries/jahplayer/diskplayer \
                        ../../uiwidgets \
                        ../../uiwidgets/interfaceobjs \
                        ../../uiwidgets/jahcalc \
                        ../../uiwidgets/jahfileloader \
                        ../../uiwidgets/keyframes \
                        ../../uiwidgets/nodes \
                        ../../uiwidgets/timeline \
                        ../../sqlite \
                        ../../objectlibs/FTGL \
                        ../../objectlibs/glmlib \
                        ../../objectlibs/l3ds \
                        ../../objectlibs/particle \
                        ../../objectlibs/blur \
                        ../../sqlite \
                        $$FREEDIR

contains( JAHOS,IRIX ) {
INCLUDEPATH +=      $$SGIDIR
}


