/*******************************************************************************
**
** The header file for the Jahshaka player module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "encoderthread.h"

//move this to header
EncodeThread::~EncodeThread(void)
{}

///////////////////////////////////////////////////
// the first one is for avi using qstring in C++
// and the second for the mpeg routines in C
// ie feedback is a const char and feedbackstring a QString

void EncodeThread::checkmessage(QString& data)
{
    #ifdef JAHMPEGDECODER
    if (encoder == JAHMPEG)
        data = mpegenc_feedback;
    #endif

    if (encoder == WINAVI)
        data = feedbackString;

}

void EncodeThread::checkmessageString(QString& data)
{
    data = feedbackString;
}

///////////////////////////////////////////////////
//the actual encoding routines are called here


void EncodeThread::run()
{

    ///////////////////////////////////////////////////////
    // this is where we launch the necessary encoder
    //debug("starting to encode clip");

    //////////////////////////////////////////////
    // this is for the encoders
    
    #ifdef JAHMPEGDECODER
    if (encoder == JAHMPEG)
    {
        mpegenc_feedback="starting to encode clip";

        int rendermpeg = mpeglauncher(assetconfig);
    }
    #endif

    #ifdef WIN32
    if (encoder == WINAVI)
    {
        CAVIGen * AviGen = new CAVIGen( assetdata, assetconfig, feedbackString );
    }
    #endif

}

void EncodeThread::stop()
{   
    //debug("stoppping encode thread");
    mutex.lock();
    stopped = TRUE;
    mutex.unlock();
}

void EncodeThread::cleanup()
{   
    //debug("cleanup");   
}


