/*******************************************************************************
**
** The header file for the Jahshaka glplayer module 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef GLPLAYER_H
#define GLPLAYER_H

#include "glworld.h"

#include <qcheckbox.h>
#include <qtabwidget.h>


class GLPlayer :  public  GLWorld {
  Q_OBJECT

public:

GLPlayer( GLCore* core, const char* name,
         QHBox* controls, QHBox* controller, QHBox* leftcontroller, QHBox* rightcontroller,
         int* globalclipnumber, const QGLWidget* shareWidget=0   )
        :  GLWorld(core,name,controller,globalclipnumber )
{
    buildInterfaceMenus(leftcontroller,rightcontroller);
    
    initializeObjects();
};

GLPlayer::~GLPlayer() { }

    void buildInterfaceMenus( QHBox* leftcontroller, QHBox* rightcontroller );

    void initializeObjects();

	bool ignoreForegroundLock;

public slots:

    void updateUiOptions();
    void updateUiSettings();

	void resetXRotation ( void );
	void resetYRotation ( void );

protected:

    void paintGL();

private:
  
	///////////////////////////////////////////////////////////////////////
	//interface variables for the left and right world space menus
	///////////////////////////////////////////////////////////////////////
	
	QFrame			*glworldLeft;

	JahToolButton	*toolrotatein,	*toolrotateout;
	QSlider			*toolrotate;
	
	JahToolButton	*toolpanin,	*toolpanout;
	QSlider			*toolpan;

	QFrame			*glworldRight;
	
	JahToolButton	*toolzoomin,	*toolzoomout;
	QSlider			*zoom;

	///////////////////////////////////////////////////////////////////////
	//animation module ui options
	///////////////////////////////////////////////////////////////////////

	//set up the effects control panel
/*
	QCheckBox		*ForegroundSelect;    
	QCheckBox		*DepthSelect;
	QCheckBox		*BlurSelect;
	QSlider			*HBlurSlider, *VBlurSlider;
	InputLCD		*HBlurSlider_lcd, *VBlurSlider_lcd;

	QCheckBox		*NegativeSelect, *SwapRGBSelect, *MirrorSelect; 
	JahToolButton	*lighticon;
	QCheckBox		*light1, *reflect1, *shader1, *shader2, *smooth1, *mesh1;
	QLabel			*Transparency_1;     
	QSlider			*Trans_1;         
	InputLCD		*Translcd_1;
*/

};



#endif // ANIMATION_H





