/*******************************************************************************
**
** The source file for the Jahshaka animation interface module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "glplayer.h"
#include <qstylefactory.h>

void GLPlayer::buildInterfaceMenus( QHBox* leftcontroller, QHBox* rightcontroller)
{
    QStyle *platinum=QStyleFactory::create("platinum");

	///////////////////////////////////////////////////////////////////////
    //left menu here
    glworldLeft = new QFrame (leftcontroller, "gl left");

    toolrotatein =   new JahToolButton( glworldLeft, "zoomin" );
    addJahPlayerButton( toolrotatein,   0, 50, 30, 27 ,    24, 28, 
		JahBasePath+"Pixmaps/desktop/zoomin.png", JahBasePath+"Pixmaps/desktop/zoomin.png" );

    connect(toolrotatein,    SIGNAL(clicked()), this, SLOT(resetXRotation() )  );

    toolrotate = new QSlider( glworldLeft, "scrubslider" );
    if (platinum) toolrotate->setStyle( platinum );
    toolrotate->setGeometry( QRect( 0, 85, 30, 200 ) );
    toolrotate->setOrientation( QSlider::Vertical );
    toolrotate->setMinValue( -180 );    toolrotate->setMaxValue( 180 );    toolrotate->setValue   ( 0 );

	connect(toolrotate, SIGNAL(valueChanged(int)), this, SLOT(setXRotation(int)) );

	toolpanin =   new JahToolButton( glworldLeft, "zoomin" );
    addJahPlayerButton( toolpanin,   0, 300, 30, 27 ,    24, 28, 
		JahBasePath+"Pixmaps/desktop/zoomin.png", JahBasePath+"Pixmaps/desktop/zoomin.png" );

    connect( toolpanin,    SIGNAL(clicked()), this, SLOT(resetYRotation() )  );

    toolpan = new QSlider( glworldLeft, "scrubslider" );
    if (platinum) toolpan->setStyle( platinum );
    toolpan->setGeometry( QRect( 0, 335, 30, 200 ) );
    toolpan->setOrientation( QSlider::Vertical );
    toolpan->setMinValue( -180 );    toolpan->setMaxValue( 180 );    toolpan->setValue   ( 0 );

	connect(toolpan, SIGNAL(valueChanged(int)), this, SLOT(setYRotation(int)) );

	////////////////////////////////////////////////////////////////////////
    //rightmenu here
    glworldRight =  new QFrame (rightcontroller, "gl right" );

    toolzoomin =   new JahToolButton( glworldRight, "zoomin" );
    addJahPlayerButton( toolzoomin,   0, 115, 30, 27 ,    24, 28, 
		JahBasePath+"Pixmaps/desktop/zoomin.png", JahBasePath+"Pixmaps/desktop/zoomin.png" );

    toolzoomout =   new JahToolButton( glworldRight, "zoomout" );
    addJahPlayerButton( toolzoomout,   0, 355, 30, 27 ,    24, 28, 
		JahBasePath+"Pixmaps/desktop/zoomout.png", JahBasePath+"Pixmaps/desktop/zoomout.png" );

    connect( toolzoomin,    SIGNAL(clicked()), this, SLOT(resetZoom() )  );
    connect( toolzoomout,    SIGNAL(clicked()), this, SLOT(resetZoom() )  );

    zoom = new QSlider( glworldRight, "scrubslider" );
    if (platinum) zoom->setStyle( platinum );
    zoom->setGeometry( QRect( 0, 150, 30, 200 ) );
    zoom->setOrientation( QSlider::Vertical );
    zoom->setMinValue( -10 );    zoom->setMaxValue( 10 );    zoom->setValue   ( 0 );

    connect( zoom,  SIGNAL(sliderMoved(int)), this, SLOT(changeZoom(int) )  );
    
}

////////////////////////////////////////////////
//slots to reset pan and tilt
void GLPlayer::resetXRotation ( void )
{
	debug("reset");
	camera->node->rx = 0.0;
	
	toolrotate->setValue(0);
    
	updateGL();
}

void GLPlayer::resetYRotation ( void )
{
	camera->node->ry = 0.0;
	
	toolpan->setValue(0);
    
	updateGL();
}


