
#include <qmainwindow.h>
#include <qgl.h>
#include <qpen.h>
#include <qpoint.h>
#include <qimage.h>
#include <qwidget.h>
#include <qstring.h>
#include <qpointarray.h>
#include <qmenubar.h>
#include <qslider.h>
#include <qlabel.h>
#include <qbuttongroup.h>

#include <math.h>   //for drawing triangles and circles using trigonometry, etc.

class QMouseEvent;
class QResizeEvent;
class QPaintEvent;
class QToolButton;


 /*
 | a Canvas is a QGLwidget that you can draw on
*/
 //definitions used by Canvas : history
#define myHistorySize 22

 //definitions used by Canvas : mathematical
#define PI        3.14159265358979323846
#define twoPI     PI * 2
#define halfPI    PI / 2
#define quarterPI PI / 4
#define atanPI  atan(PI)
#define toolCirclePointsPerPI    24    //tool configuration

 //definitions used by Canvas : color data structures
typedef GLfloat color3[3];
typedef float color3f255[3];

 //definitions used by Canvas : convolutions
typedef float     float3[3];
typedef float3    kernel3x3[3];
typedef kernel3x3 convolutionKernels[10];
const convolutionKernels convolutionMatrix =
 { { { 0.0, 0.0, 0.0 },                      //fade
     { 0.0, 1.0, 0.0 },
     { 0.0, 0.0, 0.0 } },
   { { 0.0, 0.0, 0.0 },                      //intensify
     { 0.0, 1.0, 0.0 },
     { 0.0, 0.0, 0.0 } },
   { { 0.1111111, 0.1111111, 0.1111111 },    //blur
     { 0.1111111, 0.1111111, 0.1111111 },
     { 0.1111111, 0.1111111, 0.1111111 } },
   { { -0.117647, -0.117647, -0.117647 },    //sharpen
     { -0.117647, 1.941176 , -0.117647 },
     { -0.117647, -0.117647, -0.117647 } },
   { { -0.05, -0.07, -0.05  },               //Laplacian-of-Gaussian variant
     { -0.07, 1.58,  -0.07 },
     { -0.05, -0.07, -0.05  } },
   { { 0.0  , 0.0, 0.0  },                   //edgeDetectX
     { -0.25, 1.5, -0.25 },
     { 0.0  , 0.0, 0.0  } },
   { { 0.0, -0.25, 0.0 },                    //edgeDetectY
     { 0.0, 1.5  , 0.0 },
     { 0.0, -0.25 , 0.0 } },
   { {  0.5,  1.5,  0.5  },                  //sobel
     {  0.0,  1.0,  0.0 },
     { -0.5, -1.5, -0.5  } },
   { { 0.75,  -2.25, 0.75  },                //Laplacian
     { -2.25, 4.0,   -2.25 },
     { 0.75,  -2.25, 0.75  } },
   { { 0.25,  -0.75, 0.25  },                //Laplacian2
     { -0.75, 1.0,   -0.75 },
     { 0.25,  -0.75, 0.25  } } };
enum convolutionType { fade, intensify, blur, sharpen, lapOfGauss,
                       edgeDetectX, edgeDetectY,
                       sobel, laplacian, laplacian2 };

//list of the tools supported by Canvas
enum CanvasTool { none, pen, line, rectangle, rectangleFilled, circle,
                  circleFilled, triangle, triangleFilled };
