/*******************************************************************************
**
** The source file for the Jahshaka animation selections module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/


#include "character.h"

void GLChar::addLayer(void)
{

//add a new layer
//issues when adding over a deleted layer -> need to reset the layer before a add is done...
bool added = TRUE;

//add on demand layers...
QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "QtFont",    5,0 );
    menu->insertItem( "Textured",  4,0 );
    menu->insertItem( "3d Extrude",3,0 );
    menu->insertItem( "Polygon",   2,0 );
    menu->insertItem( "Outline",   1,0 );
    //menu->insertItem( "Bitmap",    1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( AddButton->mapToGlobal( QPoint( 0, AddButton->height() + 1 ) ) );

    if ( id != -1 ) {

        numberLayers+=1;

    switch(id) {


        case 1  : { 
                    layerlist->append( new NewLayerList(numberLayers, "Outline") );
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->extrude = 20.0;
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FOUTLINE; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->lighting = FALSE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->reflect = FALSE;
                    buildLayer(numberLayers,"Outline", TEXT, JAHTEXT);

                    break; }

        case 2  : { 
                    layerlist->append( new NewLayerList(numberLayers, "Polygon") );
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FPOLYGON; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->lighting = FALSE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->reflect = FALSE;
                    buildLayer(numberLayers,"Polygon", TEXT, JAHTEXT);
                    break; }

        case 3  : { 
                    layerlist->append( new NewLayerList(numberLayers, "Extrude") );
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->extrude = 20.0;
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FEXTRUDE; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->lighting = TRUE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->reflect = FALSE;
                    buildLayer(numberLayers,"Extrude", TEXT, JAHTEXT);
                    
                    break; }

        case 4  : { 
                    layerlist->append( new NewLayerList(numberLayers, "Textured") );
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FTEXTURE; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->lighting = FALSE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    buildLayer(numberLayers,"Textured", TEXT, JAHTEXT);
                    
                    break; }

        case 5  : { 
                    layerlist->append( new NewLayerList(numberLayers, "QtFont") );
                    layerlist->at(numberLayers)->thelayer->qtfont = true;
                    layerlist->at(numberLayers)->thelayer->addTextObj();
                    layerlist->at(numberLayers)->thelayer->text->text = "jahshaka";
                    layerlist->at(numberLayers)->thelayer->text->font = JahBasePath+"fonts/arial.ttf";
                    layerlist->at(numberLayers)->thelayer->text->extrude = 20.0;
                    layerlist->at(numberLayers)->thelayer->text->fontstyle = FPIXMAP; //or FSOLID
                    layerlist->at(numberLayers)->thelayer->lighting = FALSE; 
                    layerlist->at(numberLayers)->thelayer->depth = TRUE;
                    layerlist->at(numberLayers)->thelayer->reflect = FALSE;
                    buildLayer(numberLayers,"QtFont", TEXT, JAHTEXT);

                    break; }


        default  :  { break; }

    }
    
    } 
    else 
    { 
        added = FALSE;
    }


    delete menu;

    if (added) 
    {
        layerlist->at(numberLayers)->thelayer->layerAssetStatus = TRUE;
        addSelection();
        objectMenu(numberLayers); 
        updateSliders(); 
    }

}





void GLChar::changeFontDraw() {
    QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Textured",  6,0 );
    menu->insertItem( "3d Extrude",5,0 );
    menu->insertItem( "Polygon",   4,0 );
    menu->insertItem( "Outline",   3,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( textDraw->mapToGlobal( QPoint( 0, textDraw->height() + 1 ) ) );

    if ( id != -1 ) {
    switch(id) {
                case 3  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FOUTLINE;    break;
                case 4  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FPOLYGON;    break;
                case 5  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FEXTRUDE;    break;
                case 6  :  layerlist->at(activeLayer)->thelayer->text->fontstyle = FTEXTURE;    break;
                default :                                                    break;
    }
    }

    delete menu;
    updateGL();  //redraw scene
}















