###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE    =           lib
CONFIG      +=          staticlib qt warn_on release opengl thread

contains( JAHPLAYER,true ) {
HEADERS     +=          jahplayer/jahplayercreate.h \
                        jahplayer/jahplayer.h
}



contains( JAHPLAYER,false ) {
HEADERS     =           jahcreate.h \
                        jahshaka.h \
                        jahstartup.h \
                        jahstartupgl.h
}


contains( SPACEBALL,true ) {
HEADERS     +=          spaceball.h
}


contains( JAHPLAYER,true ) {
SOURCES     =           jahplayer/jahplayercreate.cpp \
                        jahplayer/jahplayerdesktopinterface.cpp \
                        jahplayer/jahplayerinterface.cpp \
                        jahplayer/jahplayermodules.cpp \
                        jahplayer/jahplayerroutines.cpp \
                        jahplayer/jahplayermodes.cpp \
                        jahplayer/jahplayer.cpp \
                        jahglsupport.cpp \
                        jahplayer/jahplayerprefs.cpp \
                        jahstyle.cpp \
                        main.cpp
}

contains( JAHPLAYER,false ) {
SOURCES     =           jahcreate.cpp \
                        jahdesktopinterface.cpp \
                        jahinterface.cpp \
                        jahinterfacedualhead.cpp \
                        jahmodules.cpp \
                        jahroutines.cpp \
                        jahmodes.cpp \
                        jahshaka.cpp \
                        jahstartup.cpp \
                        jahstartupgl.cpp \
                        jahglsupport.cpp \
                        jahprefs.cpp \
                        jahstyle.cpp \
                        main.cpp
}

#files for audiosupport
contains( JAHTHEMES,true ) {
HEADERS     +=          jahmetalstyle.h
SOURCES     +=          jahmetalstyle.cpp
}

TARGET      =           source
DEPENDPATH  =           $$JAHDEPENDPATH

###############################################################
#the project related includes
INCLUDEPATH =           . .. \
                        ../Core/Objects \
                        ../Core/Render \
                        ../Core/World  \
                        ../desktop


#files for mpeg encoder on linux
contains( JAHMPEGENCODER,true ) {
INCLUDEPATH +=          ../encoders/mpegenc
}

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
INCLUDEPATH +=          ../encoders/mpegdec
}

#files for audiosupport
contains( JAHAUDIO,true ) {
INCLUDEPATH +=          ../libraries/jahaudio
}

INCLUDEPATH +=          ../Source \
                        ../Source/jahplayer \
                        ../libraries \
                        ../libraries/assetobject \
                        ../libraries/GLCore \
                        ../libraries/glew \
                        ../libraries/imagelibs \
                        ../libraries/jahkeyframes \
                        ../libraries/jahpreferences \
                        ../libraries/jahtranslate \
                        ../libraries/jahtimer \
                        ../libraries/jahtracer \
                        ../libraries/mediaobject

contains( SPACEBALL,true ) {
INCLUDEPATH     +=          ../libraries/spaceball
}

INCLUDEPATH +=          ../libraries/jahplugins \
                        ../libraries/jahgift \
                        ../libraries/gpumathlib \
                        ../libraries/jahdatabase \
                        ../libraries/jahplayer/diskplayer \
                        ../libraries/jahplayer/ramplayer \
                        ../uiwidgets \
                        ../uiwidgets/interfaceobjs \
                        ../uiwidgets/jahcalc \
                        ../uiwidgets/jahfileloader \
                        ../uiwidgets/keyframes \
                        ../uiwidgets/nodes \
                        ../uiwidgets/timeline \
                        ../objectlibs/FTGL \
                        ../objectlibs/glmlib \
                        ../objectlibs/l3ds \
                        ../objectlibs/particle \
                        ../objectlibs/blur \
                        ../Modules/animate \
                        ../Modules/color \
                        ../Modules/edit \
                        ../Modules/effect \
                        ../Modules/painter \
                        ../Modules/text \
                        ../Modules/glplayer \
                        ../Modules/encoder \
                        ../network \
                        ../network/apollon \
                        ../player \
                        ../sqlite

#includes for the audio hack
contains( JAHAUDIO,true ) {
INCLUDEPATH +=          ../libraries/jahplayer/audioplayer
}

INCLUDEPATH +=          ../sqlite \
                        ../../Pixmaps \
                        ../../Pixmaps/interface \
                        $$FREEDIR

contains( JAHOS,IRIX ) {
INCLUDEPATH +=          $$SGIDIR
}


#temp include here for gift support
#need to get rid of this asap...
INCLUDEPATH +=          /usr/include/glib-2.0 \
                        /usr/lib/glib-2.0/include

