/*******************************************************************************
**
** The source file for the Jahshaka jahcontrol module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

////////////////////////////////////////////////////////////////
// This is the main class that creates and launches the jahshaka interface
// and sets up and connects all the modules and interface objects

#include "jahcreate.h"

//move these to header por favor
#include "qlabel.h"




////////////////////////////////////////////////////////////////
// a reaaaaaly messy hack for dual head using a DEFINE vs a global variable
//will be cleaned out once we get it working
//since its also the easiest way :)


JahControl::JahControl( QWidget *parent,
                        QWidget *menucontroller,
                        QFrame  *mainleftmenu, QFrame *mainworld, QFrame *mainrightmenu,
                        QFrame  *maincontroller,
                        QFrame  *moduleselection, QFrame *modulesettings,QFrame *feedbackbar,
                        QWidget *D2parent,
                        QFrame  *D2mainleftmenu, QFrame *D2mainworld, QFrame *D2mainrightmenu,
                        QFrame  *D2maincontroller,
                        QFrame  *D2moduleselection, QFrame *D2modulesettings,QFrame *D2feedbackbar)

{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();

    //set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    //initialize JahBasePath & Mediapath
    JahPrefs& jprefs = JahPrefs::getInstance();
    JahBasePath   = jprefs.getBasePath();
    JahMediaPath  = jprefs.getMediaPath();
    JahDefaultRes = jprefs.getJahResolution();

    //this is a global variable used by all modules
    globalclipnumber = 0;

    //retreive preferences
    getGlobalPreferences();


    //setup menubar if needed
    if (menuprefs)
        buildMenuBar(parent);

    //////////////////////////////////////////////////////////////
    //create the main frame object controllers
    //used to switch the framesets out according to
    //what module we are currently in
    jtrace.info( "Setting up Interface and loading modules" );

    //////////////////////////////////////////////////////////////
    //create the main controler for the world space object


    //if we are running in widescreen mode then set it up
    //so we share the world space between 2 frames
    if (!widescreen)
    {
        mainworldLayout = new QHBoxLayout( mainworld, 0, 0, "mainworldLayout");
        WorldLayout = new QWidgetStack(mainworld);
        mainworldLayout->addWidget( WorldLayout );
    }
    else
    {

        wideframeLayout = new QGridLayout( mainworld, 1, 1, 11, 6, "frame3Layout");

        //the splitter
        splitter2 = new QSplitter( mainworld, "splitter2" );
        splitter2->setOrientation( QSplitter::Horizontal );

        wideframeLeft = new QHBox( splitter2, "frame4" );
        wideframeLeft->setFrameShape( QFrame::StyledPanel );
        wideframeLeft->setFrameShadow( QFrame::Raised );

        wideframeRight = new QHBox( splitter2, "frame5" );
        wideframeRight->setFrameShape( QFrame::StyledPanel );
        wideframeRight->setFrameShadow( QFrame::Raised );

        wideframeLayout->addWidget( splitter2, 0, 0 );

        QValueList<int> sizeList;
        sizeList.append(120);
        sizeList.append(600);
        splitter2->setSizes(sizeList);

        //this will be for the desktop alone for widescrreen mode
        mainworldLayout2 = new QHBoxLayout( wideframeLeft, 0, 0, "mainworldLayout");
        WorldLayout2 = new QWidgetStack(wideframeLeft);
        mainworldLayout2->addWidget( WorldLayout2 );
        //WorldLayout2->resize(200,800);

        //this will be for all other modules
        mainworldLayout = new QHBoxLayout( wideframeRight, 0, 0, "mainworldLayout");
        WorldLayout = new QWidgetStack(wideframeRight);
        mainworldLayout->addWidget( WorldLayout );


    }

    //////////////////////////////////////////////////////////////
    //create the main left menu controler
    mainworldLeftLayout = new QHBoxLayout( mainleftmenu, 0, 0, "mainworldLeftLayout");
    MainLeftControler = new QWidgetStack(mainleftmenu);
    mainworldLeftLayout->addWidget( MainLeftControler );

    //////////////////////////////////////////////////////////////
    //create the main right menu controler
    mainworldRightLayout = new QHBoxLayout( mainrightmenu, 0, 0, "mainworldRightLayout");
    MainRightControler = new QWidgetStack(mainrightmenu);
    mainworldRightLayout->addWidget( MainRightControler );

    //////////////////////////////////////////////////////////////
    //create the middle frame menu/option controler
    maincontrollerLayout = new QHBoxLayout( maincontroller, 0, 0, "maincontrollerLayout");
    MainControler = new QWidgetStack(maincontroller);
    maincontrollerLayout->addWidget( MainControler );

    //////////////////////////////////////////////////////////////
    //Create Interface frame and switching controllers for modules
    optionals = new QWidgetStack(modulesettings);
    optionals->setGeometry( QRect( 5, 1, 860, 200) );

    ////////////////////////////////////////////////////////////////
    //for dualhead
    if (dualheadprefs==true)
    {
        jtrace.info( "Setting up dual head" );

        //////////////////////////////////////////////////////////////
        //create the main controler for the world space object
        D2mainworldLayout = new QHBoxLayout( D2mainworld, 0, 0, "D2mainworldLayout");
        D2WorldLayout = new QWidgetStack(D2mainworld);
        D2mainworldLayout->addWidget( D2WorldLayout );

        //////////////////////////////////////////////////////////////
        //create the main left menu controler
        D2mainworldLeftLayout = new QHBoxLayout( D2mainleftmenu, 0, 0, "D2mainworldLeftLayout");
        D2MainLeftControler = new QWidgetStack(D2mainleftmenu);
        D2mainworldLeftLayout->addWidget( D2MainLeftControler );

        //////////////////////////////////////////////////////////////
        //create the main right menu controler
        D2mainworldRightLayout = new QHBoxLayout( D2mainrightmenu, 0, 0, "D2mainworldRightLayout");
        D2MainRightControler = new QWidgetStack(D2mainrightmenu);
        D2mainworldRightLayout->addWidget( D2MainRightControler );

        //////////////////////////////////////////////////////////////
        //create the middle frame menu/option controler
        D2maincontrollerLayout = new QHBoxLayout( D2maincontroller, 0, 0, "D2maincontrollerLayout");
        D2MainControler = new QWidgetStack(D2maincontroller);
        D2maincontrollerLayout->addWidget( D2MainControler );

        //////////////////////////////////////////////////////////////
        //Create Interface frame and switching controllers for modules
        D2optionals = new QWidgetStack(D2modulesettings);
        D2optionals->setGeometry( QRect( 5, 1, 860, 200) );
    }



    //////////////////////////////////////////////////////////////
    //connect this to the splash screen through the  parent object
    connect( this,  SIGNAL(creatingModule(const QString &)), parent, SLOT(JahchangeModeText(const QString &))  );
    connect( this,  SIGNAL(finishedModule(int)), parent, SLOT(JahsetProgressValue(int))  );


    /////////////////////////////////////////////////////////////////
    //Create Desktop interface and buttons
    //we should be doing this in desktopinterface.cpp so it can create
    //its own interface like all the other modules...

    //Set up the desktop menu button
    emit creatingModule(jt.tr("Desktop"));

    if (dualheadprefs==true)
    {
        DualDesktop = new QPushButton( D2moduleselection, "Desktop" );
        DualDesktop->setGeometry( QRect( 10, 10, 111, 30 ) );
        DualDesktop->setText( jt.tr( "Desktop"  ) );
        connect( DualDesktop, SIGNAL(clicked()), SLOT(changeModeDesktop()) );

        desktopdisplay = new QHBox (D2WorldLayout, "d2desktop");
        CreateDesktopModule(desktopdisplay);
        D2WorldLayout->addWidget(desktopdisplay,0);
    }
    else
    {
        Desktop = new QPushButton( moduleselection, "Desktop" );
        Desktop->setGeometry( QRect( 10, 10, 111, 30 ) );
        Desktop->setText( jt.tr( "Desktop"  ) );
        connect( Desktop, SIGNAL(clicked()), SLOT(changeModeDesktop()) );

        if (!widescreen)
        {
            desktopdisplay = new QHBox (WorldLayout, "desktop");
            CreateDesktopModule(desktopdisplay);
            WorldLayout->addWidget(desktopdisplay,0);
        }
        else
        {
            //using widescreen mode
            desktopdisplay = new QHBox (WorldLayout, "widedesktop");
            desktopdisplay2 = new QHBox (WorldLayout2, "widedesktop");

            CreateDesktopModule(desktopdisplay,desktopdisplay2);

            WorldLayout2->addWidget(desktopdisplay2,0);
            WorldLayout->addWidget(desktopdisplay,0);
        }

    }

    //create desktop feedback bar
    CreateDesktopFeedbackBox(feedbackbar);

    //connect the desktop preferences to parent object
    connect( this,  SIGNAL(emitStyleColor(QPalette)), parent, SLOT(setStyleColor(QPalette))  );
    connect( thedesktop,  SIGNAL(resetGlobalClipNumber()),  this, SLOT(resetGlobalClipNumber())  );

    connect( thedesktop,  SIGNAL(switchMainModule(QString)),  this, SLOT(switchModule(QString))  );
    connect( thedesktop,  SIGNAL(loadMainModuleFile(QString)),  this, SLOT(loadModuleFile(QString))  );

    emit finishedModule(0+1);

    /////////////////////////////////////////////////////////////////
    //Now we Create and setup the desktop related modules

    //ok lets load the plugins in now...
    //JahTrace& jtrace = JahTrace::getInstance();
    jtrace.info( ">Initializing Plugins");

    emit creatingModule(jt.tr("Plugins"));

    JahPluginLib* jplugin = JahPluginLib::getInstance();
    jplugin->initializePlugins();

    jtrace.info( ">Initialized Plugins");

    /////////////////////////////////////////////////////////////////
    //Now we Create and setup the desktop related modules
    jtrace.info( ">>Loading Main Modules" );

    /////////////////////////////////////////////////////////////////
    //we set up the player application here
    jtrace.info( "Loading Player Module" );

    emit creatingModule(jt.tr("Player"));

    if (dualheadprefs==true)
    {
        playerdisplay = new QFrame (D2WorldLayout, "player");
        CreatePlayerModule(playerdisplay);
        D2WorldLayout->addWidget(playerdisplay,1);
    }
    else
    {
        playerdisplay = new QFrame (WorldLayout, "player");
        CreatePlayerModule(playerdisplay);
        WorldLayout->addWidget(playerdisplay,1);
    }

    emit finishedModule(1+1);

    //added for widescreen mode player updates
    if (widescreen)
    {
        connect( vidplayer,  SIGNAL(playerDraggedAImage()),  this, SLOT(notifyPlayerOfChange())  );
    }

    /////////////////////////////////////////////////////////////////
    //Now we can Create and setup the different jahshaka modules

    //we will break the main object into
    //2 widgets for user mode
    //and optional view modes ie nodeview in effects

    theCoreLayout = new QWidgetStack(mainworld);

    corebox = new QHBox(theCoreLayout,"glcore");

    theCoreLayout->addWidget(corebox,0);

    if (!widescreen)
    {
        theeffectsdisplay2 = new QHBox (theCoreLayout, "effectsnode");
        theCoreLayout->addWidget(theeffectsdisplay2,1);
    }
    else
    {
        theeffectsdisplay2 = new QHBox (WorldLayout2, "effectsnode");
        WorldLayout2->addWidget(theeffectsdisplay2,1);
    }


    //raise the gl interface as default
    theCoreLayout->raiseWidget(0);

    /////////////////////////////////////////////////////////////////
    // the main jahshaka 3d core

    //create core in widget 0
    core = new GLCore (corebox,"glcore");
    connect( core,  SIGNAL(draggedAImage()), SLOT(draggedAImage())  );


    /////////////////////////////////////////////////////////////////
    //we set up the network module  here
    jtrace.info( "Loading Network Module" );

    emit creatingModule(jt.tr("Network"));

    if (dualheadprefs==true)
    {
        DualNetwork = new QPushButton( D2moduleselection, "Network" );
        DualNetwork->setGeometry( QRect( 10, 50, 111, 30 ) );
        DualNetwork->setText( jt.tr( "Network"  ) );
        connect( DualNetwork,  SIGNAL(clicked()), SLOT(changeModeNetwork())  );
    }

    thenetworkdisplay = new QFrame (WorldLayout, "net");
    CreateNetworkModule(thenetworkdisplay);
    WorldLayout->addWidget(thenetworkdisplay,2);

    emit finishedModule(2+1);

    ////////////////////////////////////////////////////////////////
    //we set up the animation module here
    jtrace.info( "Loading Animation Module" );

    emit creatingModule(jt.tr("Animation"));

    AnimationModule = new QPushButton( moduleselection, "Animation" );
    AnimationModule->setGeometry( QRect( 10, 50, 111, 30 ) );
    AnimationModule->setText( jt.tr("Animation") );
    connect( AnimationModule, SIGNAL(clicked()), SLOT(changeModeAnimation()) );  //was Effects

    CreateAnimationModule();

    WorldLayout->addWidget(theCoreLayout,3);

    emit finishedModule(3+1);

    /////////////////////////////////////////////////////////////////
    //we set up the Effects module here
    jtrace.info( "Loading Effects Module" );

    emit creatingModule(jt.tr("Effects"));

    EffectsModule = new QPushButton( moduleselection, "Effects" );
    EffectsModule->setGeometry( QRect( 10, 83, 111, 30 ) );
    EffectsModule->setText( jt.tr( "Effects"  ) );
    connect( EffectsModule,  SIGNAL(clicked()), SLOT(changeModeEffects())  );

    CreateEffectsModule();

    WorldLayout->addWidget(theCoreLayout,4);

    emit finishedModule(4+1);

    /////////////////////////////////////////////////////////////////
    //we set up the editing module here
    jtrace.info( "Loading Editing Module" );

    emit creatingModule(jt.tr("Editing"));

    EditingModule = new QPushButton( moduleselection, "Editing" );
    EditingModule->setGeometry( QRect( 10, 116, 111, 30 ) );
    EditingModule->setText( jt.tr( "Editing"  ) );
    connect( EditingModule,  SIGNAL(clicked()), SLOT(changeModeEditing())  );


    CreateEditingModule();

    WorldLayout->addWidget(theCoreLayout,5);

    emit finishedModule(5+1);

    /////////////////////////////////////////////////////////////////
    //we set up the paint module here
    jtrace.info( "Loading Paint Module" );

    paintbox = new QHBox();// (parent,"glcore");
    paintcore = new GLCore (paintbox,"paintcore",1);

    emit creatingModule(jt.tr("Paint"));

    PaintModule = new QPushButton( moduleselection, "paint" );
    PaintModule->setGeometry( QRect( 10, 149, 111, 30 ) );
    PaintModule->setText( jt.tr( "Paint"  ) );
    connect( PaintModule,  SIGNAL(clicked()), SLOT(changeModePaint())  );


    CreatePaintModule();

    WorldLayout->addWidget(paintbox,6);

    emit finishedModule(6+1);

    /////////////////////////////////////////////////////////////////
    //we set up the CG module here
    jtrace.info( "Loading Text Module" );

    emit creatingModule(jt.tr("Text"));

    TextModule = new QPushButton( moduleselection, "text" );
    TextModule->setGeometry( QRect( 10, 182, 111, 30 ) );
    TextModule->setText( jt.tr( "Text CG"  ) );
    connect( TextModule,  SIGNAL(clicked()), SLOT(changeModeText())  );


    CreateTextModule();

    WorldLayout->addWidget(theCoreLayout,7);

    emit finishedModule(7+1);


    /////////////////////////////////////////////////////////////////
    //these modules are in the desktop menu

    /////////////////////////////////////////////////////////////////
    //we set up the colorcorrection module here
    jtrace.info( "Loading Colorize Module" );

    emit creatingModule(jt.tr("Colorize"));

    CreateColorModule();

    WorldLayout->addWidget(theCoreLayout,10);


    emit finishedModule(8+1);
    /////////////////////////////////////////////////////////////////

    /////////////////////////////////////////////////////////////////
    //we set up the encoding application here
    jtrace.info( "Loading Encoding Module" );

    emit creatingModule(jt.tr("Encoder"));

    if (dualheadprefs==true)
    {
        encodingdisplay = new QFrame (D2WorldLayout, "Encoder");
        CreateEncodingModule(encodingdisplay);
        D2WorldLayout->addWidget(encodingdisplay,11);
    }
    else
    {
        encodingdisplay = new QFrame (WorldLayout, "Encoder");
        CreateEncodingModule(encodingdisplay);
        WorldLayout->addWidget(encodingdisplay,11);
    }

    emit finishedModule(10+1);

    //used to add encoding module to dualhead
    if (dualheadprefs==true)
    {
        DualEncoding = new QPushButton( D2moduleselection, "DualEncoding" );
        DualEncoding->setGeometry( QRect( 10, 90, 111, 30 ) );
        DualEncoding->setText( jt.tr( "Encode"  ) );
        connect( DualEncoding,  SIGNAL(clicked()), SLOT(changeModeEncoding())  );
    }

    /////////////////////////////////////////////////////////////////

    /////////////////////////////////////////////////////////////////
    //we set up the library here
	//currently its not a real module but that will change later on

    jtrace.info( "Loading Library Module" );

    emit creatingModule(jt.tr("Library"));
    
    if (dualheadprefs==true)
    {
        librarydisplay = new QHBox (D2WorldLayout, "Library");
        CreateLibraryModule(librarydisplay);
        D2WorldLayout->addWidget(librarydisplay,12);
    }
    else
    {
        librarydisplay = new QHBox (WorldLayout, "Library");
        CreateLibraryModule(librarydisplay);
        WorldLayout->addWidget(librarydisplay,12);
    }

    emit finishedModule(11+1);

    /////////////////////////////////////////////////////////////////

    //finished loading modules
    jtrace.info( "Finished loading modules" );

    //configure modules for user
    configSystem();

}

void JahControl::configSystem()
{

    /////////////////////////////////////////////////////////////////
    //Raise and activate the default modules
    if (dualheadprefs==true)
    {
        changeModeAnimation();
        dualhead = true;

        //a dual head hack
        //mainworld->resize(964,586);

    }

    //set the main module to desktop
    module = DESKTOP;
    changeModeDesktop();

    //clear out paint... we could also do this the first timepaint is called
    paint->clear();
    //paint->updateGL();

    //update all modules with renderquality now that they have been created
    //maybe we can change globalclipnumber with a global prefs struct
    setModulesRenderQuality();


}


void JahControl::displayVideo2startupImage()
{
    //////////////////////////////////////////////////////
    //display startup image.in video player
    //but only if video player is active...
    if (videohead)
    {
        QImage image;
        QString ldfilename = JahBasePath + "/Pixmaps/jahstartupimage.png";

        //debug("Dualhead pic:"+ldfilename);

        QImageIO iio; iio.setFileName( ldfilename );

        if ( iio.read() )
        {
            image = iio.image();
            displayClipInPlayer(image);
        }
    }
}

void JahControl::resetGlobalClipNumber()
{
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "JahControl::resetGlobalClipNumber()","resetting global clipnumber" );

    globalclipnumber=0;

}




//this is to pass data down to the modules
void JahControl::spaceballmoved(double x, double y, double z, double a, double b , double c)
{
//switch on module for the return    are we using mode or module?
    switch(module) {

        case ANIMATION : { animation->spaceEvent  ( x,y,z,a,b,c ); break; }
        case PLAYER    : {  break; }
        case DESKTOP   : {  break; }
        case PAINT     : {  break; }
        case EFFECTS   : {  break; }
        case TEXTCG    : {  break; }
        case COLORIZE  : {  break; }
        case EDITING   : {  break; }

        default        : {  break; }
    }

}

//we detect keypresses in Jah above so we have to process them here
void JahControl::processKeyPress(QKeyEvent *k)
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();

    switch ( tolower(k->ascii()) )
    {
    case 'd':      {    jtrace.debug("pressed (d)esktop");
                        if (module != DESKTOP)
                        {
                            changeModeDesktop();
                        }
                        break;
                }

        case 'a':  {    jtrace.debug("pressed (a)animation");
                        if (module != ANIMATION)
                        {
                            changeModeAnimation();
                        }
                        break;
                }

        case 'e':  {    jtrace.debug("pressed (e)dit");
                        if (module != EDITING)
                        {
                            changeModeEditing();
                        }
                        break;
                }

        case 'p':  {    jtrace.debug("pressed (p)paint");
                        if (module != PAINT)
                        {
                            changeModePaint();
                        }
                        break;
                }

        case 't':  {    jtrace.debug("pressed (t)ext");
                        if (module != TEXTCG)
                        {
                            changeModeText();
                        }
                        break;
                }

        case 'c':  {    jtrace.debug("pressed (c)olor");
                        if (module != COLORIZE)
                        {
                            changeModeColorize();
                        }
                        break;
                }

        case 'n':  {    jtrace.debug("pressed (n)network");
                        if (module != NETWORK)
                        {
                            changeModeNetwork();
                        }
                        break;
                }

        case 'f':  {    jtrace.debug("pressed e(f)fects");
                        if (module != EFFECTS)
                        {
                            changeModeEffects();
                        }
                        break;
                }

        case ' ':  {
                        jtrace.debug("pressed space");
                        static bool playmode = false;

                        if (module == DESKTOP)
                        {
                            changeModePlayer();
                        }

                        if (module == PLAYER)
                        {
                            playmode = !playmode;

                            if (playmode)
                                vidplayer->LoopForward();
                            else
                                vidplayer->Stop();

                        }

                        if (module == ANIMATION)
                            animation->startanimation();

                        if (module == EFFECTS)
                            effects->startanimation();

                        if (module == EDITING)
                            editing->startanimation();

                        break;
                }

        default :  jtrace.debug("pressed unmapped key"); break;
    }


}

////////////////////////////////////////////////////////
//Jahshaka Destructor
//cleans up as we leave and releases memory...
JahControl::~JahControl() 
{
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "JahControl Destructor","Closing out the core modules" );

    delete thedesktop;   jtrace.debug( ">> Closed thedesktop");
    delete animation;    jtrace.debug( ">> Closed animation");
    delete effects;      jtrace.debug( ">> Closed effects");
    delete editing;      jtrace.debug( ">> Closed editing");
    delete text;         jtrace.debug( ">> Closed text");
    delete colorize;     jtrace.debug( ">> Closed colorize");
    delete vidplayer;    jtrace.debug( ">> Closed vidplayer");
    delete jahnetwork;   jtrace.debug( ">> Closed jahnetwork");
    delete paint;        jtrace.debug( ">> Closed paint");

    jtrace.debug( "JahControl Destructor","Closed out the core modules" );


}


void JahControl::buildMenuBar(QWidget *  parent)
{

    /* XPM */
    static const char * p1_xpm[] = {
    "16 16 3 1",
    "       c None",
    ".      c #000000000000",
    "X      c #FFFFFFFF0000",
    "                ",
    "                ",
    "         ....   ",
    "        .XXXX.  ",
    " .............. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .XXXXXXXXXXXX. ",
    " .............. ",
    "                "};

    /* XPM */
    static const char * p2_xpm[] = {
    "16 16 3 1",
    "       c None",
    ".      c #000000000000",
    "X      c #FFFFFFFFFFFF",
    "                ",
    "   ......       ",
    "   .XXX.X.      ",
    "   .XXX.XX.     ",
    "   .XXX.XXX.    ",
    "   .XXX.....    ",
    "   .XXXXXXX.    ",
    "   .XXXXXXX.    ",
    "   .XXXXXXX.    ",
    "   .XXXXXXX.    ",
    "   .XXXXXXX.    ",
    "   .XXXXXXX.    ",
    "   .XXXXXXX.    ",
    "   .........    ",
    "                ",
    "                "};

    /* XPM */
    static const char * p3_xpm[] = {
    "16 16 3 1",
    "       c None",
    ".      c #000000000000",
    "X      c #FFFFFFFFFFFF",
    "                ",
    "                ",
    "   .........    ",
    "  ...........   ",
    "  ........ ..   ",
    "  ...........   ",
    "  ...........   ",
    "  ...........   ",
    "  ...........   ",
    "  ...XXXXX...   ",
    "  ...XXXXX...   ",
    "  ...XXXXX...   ",
    "  ...XXXXX...   ",
    "   .........    ",
    "                ",
    "                "};

    //for the menus if they are activated
    //need to make this conditional
    //and need to add as a subroutine
    QPixmap p1( p1_xpm );
    QPixmap p2( p2_xpm );
    QPixmap p3( p3_xpm );

    //set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    QMenuBar* menu = new QMenuBar ( parent );//menuBar();

    QPopupMenu* file = new QPopupMenu( menu );
    file->insertItem(p1,"&"+jt.tr("Load"), this, SLOT(slotLoadIconview()), CTRL+Key_L );
    //file->insertItem(p3,"&"+jt.tr("Save"), this, SLOT(slotSave()), CTRL+Key_S );
    file->insertSeparator();
    file->insertItem("&"+jt.tr("Import"), this, SLOT(slotLoadIconview()), CTRL+Key_I);
    file->insertItem("&"+jt.tr("Export"), this, SLOT(slotExport()), CTRL+Key_E);
    file->insertSeparator();
    file->insertItem(""+jt.tr("Preferences"), this, SLOT(changeModePref()), CTRL+Key_P);
    file->insertSeparator();
    file->insertItem("E&xit", qApp, SLOT(quit()), CTRL+Key_X);
    menu->insertItem("&"+jt.tr("File"), file);

    QPopupMenu* edit = new QPopupMenu( menu );
    edit->insertItem("&"+jt.tr("Desktop"), this, SLOT(changeModeDesktop()) );
    edit->insertSeparator();
    edit->insertItem("&"+jt.tr("Animation"), this, SLOT(changeModeAnimation()) );
    edit->insertItem("&"+jt.tr("Effects"), this, SLOT(changeModeEffects()) );
    edit->insertItem(jt.tr("Editing"), this, SLOT(changeModeEditing()) );
    edit->insertItem(jt.tr("Paint"), this, SLOT(changeModePaint()) );
    edit->insertItem(jt.tr("Text"), this, SLOT(changeModeText()) );
    edit->insertSeparator();
    edit->insertItem(jt.tr("Color"), this, SLOT(changeModeColorize()) );
    menu->insertItem("&"+jt.tr("Modules"), edit);

    //QPopupMenu *viewmode = new QPopupMenu( parent );
    //Q_CHECK_PTR( viewmode );
    //viewmode->insertItem( jt.tr("Media"), this, SLOT(printer()) );
    //viewmode->insertItem( jt.tr("Table"), this, SLOT(file()) );

    QPopupMenu* desk = new QPopupMenu( menu );
    desk->insertItem("&"+jt.tr("Load clip"), this, SLOT(slotLoadIconview()) );
    //desk->insertItem("&"+jt.tr("Save clip"), this, SLOT(slotSave()) );
    desk->insertSeparator();
    desk->insertItem(jt.tr("Play clip"), this, SLOT(changeModePlayer()) );
    desk->insertSeparator();
    desk->insertItem(jt.tr("Delete clip"), this, SLOT(clearItem()) );
    //desk->insertSeparator();
    //desk->insertItem("&"+jt.tr("View mode"), viewmode );
    desk->insertSeparator();
    desk->insertItem("&"+jt.tr("Clear desktop"), this, SLOT(clearAll()) );
    //desk->insertItem("&Add desktop", this, SLOT(notImplemented()) );
    //desk->insertItem("&Switch desktop", this, SLOT(notImplemented()) );
    menu->insertItem("&"+jt.tr("Desktop"), desk);

    QPopupMenu* view = new QPopupMenu( menu );
    view->insertItem("&"+jt.tr("Encoder"), this, SLOT(changeModeEncoding()) );
    view->insertItem("&"+jt.tr("Video IO"), this, SLOT(changeModeVideoIO()) );
    menu->insertItem("&"+jt.tr("Utility"), view);

    QPopupMenu* net = new QPopupMenu( menu );
    net->insertItem("&"+jt.tr("Network"), this, SLOT(changeModeNetwork()) );
    net->insertItem("&"+jt.tr("Broadcast"), this, SLOT(changeModeNetwork()) );
    menu->insertItem("&"+jt.tr("JahNet"), net);

}


/////////////////////////////////////////////////////
//some slots for the drop down menus
//since 'thedesktop' doesnt seem to work for them

void JahControl::slotLoadIconview(void)
{
    thedesktop->slotLoadIconview();
}

void JahControl::slotExport(void)
{
    thedesktop->slotExport();
}

void JahControl::clearItem(void)
{
    thedesktop->clearItem();
}

void JahControl::clearAll(void)
{
    thedesktop->clearAll();
}

