/*******************************************************************************
**
** The source file for the Jahshaka jahdesktop code
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

////////////////////////////////////////////////////////////////
// This is the file that sets up  the desktop interface
// and connects it to the routines

#include "jahcreate.h"

void JahControl::CreateDesktopFeedbackBox(QFrame* frame) 
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    QLabel * label = new QLabel(frame);

    label->setGeometry( QRect( 20, 10, 90, 25 ) );
    label->setText( "JahShaka 1.9" );
    QFont label_font(  label->font() );
    label_font.setPointSize( 10 );
    label->setFont( label_font );

    //Create the feedback bar here
    TextView1_2 = new QTextView( frame, "TextView1_2" );
    TextView1_2->setGeometry( QRect( 130, 10, 600, 25 ) );
    TextView1_2->setResizePolicy( QTextView::Manual );
    TextView1_2->setDragAutoScroll( FALSE );
    TextView1_2->setHScrollBarMode( QTextView::AlwaysOff );
    TextView1_2->setVScrollBarMode( QTextView::AlwaysOff );
    TextView1_2->setText( jt.tr( " Jahshaka Media Integrator"  ) );
    QFont TextView1_2_font(  TextView1_2->font() );
    TextView1_2_font.setPointSize( 10 );
    TextView1_2_font.setBold( TRUE );
    TextView1_2->setFont( TextView1_2_font );
    TextView1_2->setTextFormat( QTextView::RichText );
    TextView1_2->show();
    //these buttons work in tandem for get and return of images from modules
    GetButton = new QPushButton( frame, "GetButton" );
    GetButton->setGeometry( QRect( 770, 10, 100, 25 ) );
    GetButton->setText( jt.tr( "Get Desktop"  ) );
    connect( GetButton,  SIGNAL(clicked()), SLOT( GetDesktop())  );
    GetButton->hide();

    ReturnButton = new QPushButton( frame, "GetButton" );
    ReturnButton->setGeometry( QRect( 770, 10, 100, 25 ) );
    ReturnButton->setText( jt.tr( "Return"  ) );
    ReturnButton->setPalette( QPalette( QColor(255, 25, 25) ) );
    connect( ReturnButton,  SIGNAL(clicked()), SLOT( ReturnDesktop())  );
    ReturnButton->hide();

}

void JahControl::CreateDesktopOptions(QHBox* frame) 
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    desktopframe1 = new QFrame(frame);

    SubLoad = new QPushButton( desktopframe1, "Load" );
    SubLoad->setGeometry( QRect( 65, 10, 86, 25 ) );
    SubLoad->setText( jt.tr( "Load"  ) );
    //connect( SubLoad, SIGNAL(clicked()), thedesktop, SLOT( slotLoad()) );
    connect( SubLoad, SIGNAL(clicked()), thedesktop, SLOT( slotLoadIconview()) );

    SubSave = new QPushButton( desktopframe1, "Save" );
    SubSave->setGeometry( QRect( 65, 40, 86, 25 ) );
    SubSave->setText( jt.tr( "Save"  ) );
    connect( SubSave, SIGNAL(clicked()), thedesktop, SLOT( slotSave()) );

    SubPref = new QPushButton( desktopframe1, "Prefs" );
    SubPref->setGeometry( QRect( 65, 100, 86, 25 ) );
    SubPref->setText( tr( "Preferences"  ) );
    connect( SubPref,  SIGNAL(clicked()), SLOT(changeModePref())  );

    desktopframe2 = new QFrame(frame);

    SubImport = new QPushButton( desktopframe2, "Import" );
    SubImport->setGeometry( QRect( 65, 10, 86, 25 ) );
    SubImport->setText( jt.tr( "Import"  ) );
    //connect( SubQuit, SIGNAL(clicked()), qApp, SLOT( quit()) );

    SubExport = new QPushButton( desktopframe2, "Export" );
    SubExport->setGeometry( QRect( 65, 40, 86, 25 ) );
    SubExport->setText( tr( "Export"  ) );
    connect( SubExport,  SIGNAL(clicked()), thedesktop, SLOT(slotExport())  );

    SubLibrary = new QPushButton( desktopframe2, "videoio" );
    SubLibrary->setGeometry( QRect( 65, 100, 86, 25 ) );
    SubLibrary->setText( jt.tr( "Library"  ) );
    connect( SubLibrary,  SIGNAL(clicked()), SLOT(changeModeLibrary())  );

    desktopframe3 = new QFrame(frame);

    Network = new QPushButton( desktopframe3, "Network" );
    Network->setGeometry( QRect( 65, 10, 86, 25 ) );
    Network->setText( jt.tr( "Network"  ) );
    connect( Network,  SIGNAL(clicked()), SLOT(changeModeNetwork())  );

    Share = new QPushButton( desktopframe3, "Share" );
    Share->setGeometry( QRect( 65, 40, 86, 25 ) );
    Share->setText( jt.tr( "Share"  ) );
    //connect( Share,  SIGNAL(clicked()), SLOT(changeModeShare())  );

    SubVideo = new QPushButton( desktopframe3, "videoio" );
    SubVideo->setGeometry( QRect( 65, 100, 86, 25 ) );
    SubVideo->setText( jt.tr( "Video I/O"  ) );
    connect( SubVideo,  SIGNAL(clicked()), SLOT(changeModeVideoIO())  );

    desktopframe4 = new QFrame(frame);

    SubColor = new QPushButton( desktopframe4, "colormodule" );
    SubColor->setGeometry( QRect( 65, 10, 86, 25 ) );
    SubColor->setText( jt.tr( "Colorize"  ) );
    connect( SubColor,  SIGNAL(clicked()), SLOT(changeModeColorize())  );

    Encoding = new QPushButton( desktopframe4, "Encoding" );
    Encoding->setGeometry( QRect( 65, 70, 86, 25 ) );
    Encoding->setText( jt.tr( "Encode"  ) );
    connect( Encoding,  SIGNAL(clicked()), SLOT(changeModeEncoding())  );
    //connect( Encoding,  SIGNAL(clicked()), SLOT(runEncoder())  );

    Broadcasting = new QPushButton( desktopframe4, "Broadcasting" );
    Broadcasting->setGeometry( QRect( 65, 100, 86, 25 ) );
    Broadcasting->setText( jt.tr( "Broadcast"  ) );
    connect( Broadcasting,  SIGNAL(clicked()), SLOT(changeModeBroadcasting())  );

    desktopframe5 = new QFrame(frame);

    SubLoadImg = new QPushButton( desktopframe5, "Delete" );
    SubLoadImg->setGeometry( QRect( 65, 10, 86, 25 ) );
    SubLoadImg->setText( jt.tr( "Delete"  ) );
    connect( SubLoadImg, SIGNAL(clicked()), thedesktop, SLOT( clearItem()) );

    SubSaveImg = new QPushButton( desktopframe5, "Clear" );
    SubSaveImg->setGeometry( QRect( 65, 40, 86, 25 ) );
    SubSaveImg->setText( jt.tr( "ClearAll"  ) );
    connect( SubSaveImg, SIGNAL(clicked()), thedesktop, SLOT( clearAll()) );

    SubQuit = new QPushButton( desktopframe5, "Quit" );
    SubQuit->setGeometry( QRect( 65, 100, 86, 25 ) );
    SubQuit->setText( jt.tr( "Quit"  ) );
    connect( SubQuit, SIGNAL(clicked()), qApp, SLOT( quit()) );

}





void JahControl::CreateDesktopMiddleFrame(QHBox* frame) 
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    page = new QWidget( frame, "page" );
    pageLayout = new QHBoxLayout( page, 0, 0, "pageLayout");
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer );

    modeselectframe = new QFrame( page, "modeselectframe" );
    modeselectframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, modeselectframe->sizePolicy().hasHeightForWidth() ) );
    modeselectframe->setMinimumSize( QSize( 100, 20 ) );
    modeselectframe->setMaximumSize( QSize( 100, 20 ) );
    modeselectframe->setFrameShape( QFrame::StyledPanel );
    modeselectframe->setFrameShadow( QFrame::Raised );

    modeselectbutton = new QPushButton( modeselectframe, "modeselectbutton" );
    modeselectbutton->setGeometry( QRect( 0, 0, 100, 20 ) );
    modeselectbutton->setMinimumSize( QSize( 100, 20 ) );
    modeselectbutton->setMaximumSize( QSize( 100, 20 ) );
    modeselectbutton->setText( tr( "Mode"  ) );
    connect( modeselectbutton,  SIGNAL(clicked()), SLOT( switchMode())  );

    pageLayout->addWidget( modeselectframe );
    QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_2 );

	/////////////////////////////////////////////////////////////////////////////
	// the main desktop buttons

    buttonframe = new QFrame( page, "buttonframe" );
    buttonframe->setMinimumSize( QSize( 600, 30 ) );
    buttonframe->setMaximumSize( QSize( 600, 30 ) );
    buttonframe->setFrameShape( QFrame::NoFrame );
    buttonframe->setFrameShadow( QFrame::Plain );
	
    DesktopName = new JahToolButton( buttonframe, "desktopnamebutton" );
    addJahPlayerButton( DesktopName, 0, 3, 150, 26,   150, 26, JahBasePath+"Pixmaps/desktopController/name_off.png", 
	                                                           JahBasePath+"Pixmaps/desktopController/name_on.png" );
    connect ( DesktopName,    SIGNAL(clicked()), this, SLOT( nameClip()) );
    popup2 = new FancyPopup( buttonframe, "Enter Clipname",250,130 );  //send size and position as well
    connect ( popup2,      SIGNAL( returnText(QString)), this, SLOT( printnameClip(QString)) );


    DesktopLoad = new JahToolButton( buttonframe, "desktopnamebutton" );
    addJahPlayerButton( DesktopLoad, 150, 3, 150, 26,   150, 26, JahBasePath+"Pixmaps/desktopController/load_off.png", 
	                                                             JahBasePath+"Pixmaps/desktopController/load_on.png" );
    connect( DesktopLoad,  SIGNAL(clicked()), thedesktop, SLOT(slotLoadIconview())  );  //this slot is located in desktop.h

    DesktopPlay = new JahToolButton( buttonframe, "desktopnamebutton" );
    addJahPlayerButton( DesktopPlay, 300, 3, 150, 26,   150, 26, JahBasePath+"Pixmaps/desktopController/play_off.png", 
	                                                             JahBasePath+"Pixmaps/desktopController/play_on.png" );
    connect( DesktopPlay,  SIGNAL(clicked()), SLOT(changeModePlayer())  );    //this is located in jahcontrol

    DeleteButton = new JahToolButton( buttonframe, "desktopnamebutton" );
    addJahPlayerButton( DeleteButton, 450, 3, 150, 26,   150, 26, JahBasePath+"Pixmaps/desktopController/delete_off.png", 
	                                                             JahBasePath+"Pixmaps/desktopController/delete_on.png" );
    connect ( DeleteButton,  SIGNAL(clicked()), thedesktop, SLOT( clearItem()) );

    pageLayout->addWidget( buttonframe );

	////////////////////////////////////////////////////////////////////

    QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_3 );

    desktopselectframe = new QFrame( page, "desktopselectframe" );
    desktopselectframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, desktopselectframe->sizePolicy().hasHeightForWidth() ) );
    desktopselectframe->setMinimumSize( QSize( 100, 20 ) );
    desktopselectframe->setMaximumSize( QSize( 100, 20 ) );
    desktopselectframe->setFrameShape( QFrame::StyledPanel );
    desktopselectframe->setFrameShadow( QFrame::Raised );

    desktopselectbutton = new QPushButton( desktopselectframe, "desktopselectbutton" );
    desktopselectbutton->setGeometry( QRect( 0, 0, 100, 20 ) );
    desktopselectbutton->setMinimumSize( QSize( 100, 20 ) );
    desktopselectbutton->setMaximumSize( QSize( 100, 20 ) );
    desktopselectbutton->setText( jt.tr( "Desktop"  ) );
    connect( desktopselectbutton,  SIGNAL(clicked()), SLOT( switchDesktop())  );

    pageLayout->addWidget( desktopselectframe );
    QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    pageLayout->addItem( spacer_4 );

}

void JahControl::addJahPlayerButton( JahToolButton * button, int x1, int y1, int x2, int y2,
                                  int w, int h, QString iconOff, QString iconOn ) 
{

    button->setToggleButton(false);
    //button->setFixedSize(w,h);
    button->setUsesBigPixmap(true);
    button->setGeometry( QRect( x1, y1, x2, y2 ) );

    QIconSet *icoSet;
    icoSet = new QIconSet( QPixmap(iconOff) );
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Large, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Large, QIconSet::Disabled);
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Small, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Small, QIconSet::Disabled);
    button->setIconSet(*icoSet);
    //delete icoSet;

}


//icon for desktop preferences locate jahpath
static const char* basefolder_xpm[] = {
    "15 14 4 1",
    " 	c None",
    ".	c #000000",
    "+	c #FFFF00",
    "@	c #FFFFFF",
    "          .    ",
    "               ",
    "          .    ",
    "       .     . ",
    "  ....  . . .  ",
    " .+@+@.  . .   ",
    "..........  . .",
    ".@+@+@+@+@..   ",
    ".+@+@+@+@+. .  ",
    ".@+@+@+@+@.  . ",
    ".+@+@+@+@+.    ",
    ".@+@+@+@+@.    ",
    ".+@+@+@+@+.    ",
    "...........    "};

void JahControl::CreateDesktopPreferences(QHBox* frame)
{
	//set up translator
    //JahTranslate& jt = JahTranslate::getInstance();

    prefframe1 = new QFrame( frame, "prefframe1" );
    prefframe1->setGeometry( QRect( 0, 40, 860, 200 ) );
    //prefframe1->setFrameShape( QFrame::StyledPanel );
    //prefframe1->setFrameShadow( QFrame::Raised );

    Pref1 = new QPushButton( prefframe1, "Pref1" );
    Pref1->setGeometry( QRect( 59, 41, 70, 21 ) );
    connect( Pref1, SIGNAL(clicked()),  SLOT(stylePlatinum()) );

    Pref2 = new QPushButton( prefframe1, "Pref2" );
    Pref2->setGeometry( QRect( 59, 71, 70, 21 ) );
   connect( Pref2, SIGNAL(clicked()),  SLOT(styleSgi()) );


    Pref3 = new QPushButton( prefframe1, "Pref3" );
    Pref3->setGeometry( QRect( 59, 131, 70, 21 ) );
    connect( Pref3,  SIGNAL(clicked()), SLOT(styleMetal()) );

    Pref4 = new QPushButton( prefframe1, "Pref4" );
    Pref4->setGeometry( QRect( 59, 101, 70, 21 ) );
    connect( Pref4,  SIGNAL(clicked()), SLOT(styleCharcoal()) );


    Pref5 = new QPushButton( prefframe1, "Pref5" );
    Pref5->setGeometry( QRect( 139, 41, 70, 21 ) );
    connect( Pref5, SIGNAL(clicked()),  SLOT(styleGrey()) );

    Pref6 = new QPushButton( prefframe1, "Pref6" );
    Pref6->setGeometry( QRect( 139, 71, 70, 21 ) );
    connect( Pref6, SIGNAL(clicked()),  SLOT(styleBlue()) );

    Pref7 = new QPushButton( prefframe1, "Pref7" );
    Pref7->setGeometry( QRect( 139, 101, 70, 21 ) );
    connect( Pref7,  SIGNAL(clicked()), SLOT(styleGreen()) );

    Pref8 = new QPushButton( prefframe1, "Pref8" );
    Pref8->setGeometry( QRect( 139, 131, 70, 21 ) );
    connect( Pref8,  SIGNAL(clicked()), SLOT(styleWhite()) );  //change to signal...?

    Pref10 = new QCheckBox( prefframe1, "Pref10" );
    Pref10->setGeometry( QRect( 59, 160, 70, 21 ) );
    Pref10->setChecked(jahStyleprefs);
    connect( Pref10,  SIGNAL(clicked()), this, SLOT(setStyleOption())  );

    StorageBox = new QLineEdit( prefframe1, "StorageBox" );
    StorageBox->setGeometry( QRect( 249, 40, 181, 21 ) );
    StorageBox->setText( JahMediaPath );

    StorageButton = new QPushButton( prefframe1, "StorageButton" );
    StorageButton->setGeometry( QRect( 249, 71, 70, 21 ) );
    connect( StorageButton, SIGNAL(clicked()),  SLOT(setStoragePath()) );

    QPixmap pix; pix = QPixmap( basefolder_xpm );

    StorageLocation = new QToolButton( prefframe1, "StorageLocation" );
    StorageLocation->setGeometry( QRect( 449, 40, 31, 21 ) );
    StorageLocation->setIconSet(pix);
    //StorageLocation->setMinimumSize( QSize( 32, 0 ) );
    //StorageLocation->setMaximumSize( QSize( 32, 32767 ) );
    connect( StorageLocation , SIGNAL(clicked()),  SLOT(getStoragePath()) );

    storagelabel = new QLabel( prefframe1, "storagelabel" );
    storagelabel->setGeometry( QRect( 289, 11, 151, 21 ) );
    storagelabel->setAlignment( int( QLabel::AlignCenter ) );

    renderqualityslider = new QSlider( prefframe1, "renderqualityslider" );
    renderqualityslider->setGeometry( QRect( 330, 130, 140, 21 ) );
    renderqualityslider->setOrientation( QSlider::Horizontal );

    QStyle *platinum=QStyleFactory::create("platinum");
    if(platinum)   renderqualityslider->setStyle(  platinum );

    renderqualityslider->setOrientation( QSlider::Horizontal );
    renderqualityslider->setTickmarks( QSlider::Right );
    renderqualityslider->setMinValue( 0 );
    renderqualityslider->setMaxValue( 2 );

    //check prefs and read in renderquality
    renderqualityslider->setValue   ( jahrenderquality );
    connect( renderqualityslider,   SIGNAL(sliderReleased()),    SLOT(setGlobalRenderQuality()) );


    renderercombo = new QComboBox( FALSE, prefframe1, "renderercombo" );
    renderercombo->setGeometry( QRect( 330, 169, 141, 21 ) );
    renderercombo->insertItem("Qt GL Renderer  (fast)");
    renderercombo->insertItem("GPU Renderer    (fast)");
    renderercombo->insertItem("Software        (slow)");
    renderercombo->insertItem("Qt Renderer Exp (fastest)");
    renderercombo->setCurrentItem(renderer); //4:2:0
    connect( renderercombo,  SIGNAL(activated(int)), this, SLOT(setRenderer(int))  );

    //we must add 3 options here for the 3 renereres

    renderlabel = new QLabel( prefframe1, "renderlabel" );
    renderlabel->setGeometry( QRect( 289, 111, 151, 21 ) );
    renderlabel->setAlignment( int( QLabel::AlignCenter ) );

    rendererlabel = new QLabel( prefframe1, "rendererlabel" );
    rendererlabel->setGeometry( QRect( 250, 169, 75, 21 ) );
    rendererlabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignLeft ) );

    renderqualitylabel = new QLabel( prefframe1, "renderqualitylabel" );
    renderqualitylabel->setGeometry( QRect( 250, 139, 75, 21 ) );
    renderqualitylabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignLeft ) );

    uiframe1 = new QFrame( prefframe1, "uiframe1" );
    uiframe1->setGeometry( QRect( 229, 10, 2, 180 ) );
    uiframe1->setFrameShape( QFrame::StyledPanel );
    uiframe1->setFrameShadow( QFrame::Raised );

    uisettingslabel = new QLabel( prefframe1, "uisettingslabel" );
    uisettingslabel->setGeometry( QRect( 510, 20, 120, 21 ) );
    uisettingslabel->setAlignment( int( QLabel::AlignCenter ) );

    DualHead = new QCheckBox( prefframe1, "DualHead" );
    DualHead->setGeometry( QRect( 500, 80, 140, 20 ) );
    DualHead->setChecked(dualheadprefs);
    connect( DualHead,  SIGNAL(clicked()), this, SLOT(setDualHeadOption())  );

    MenuOption = new QCheckBox( prefframe1, "MenuOption" );
    MenuOption->setGeometry( QRect( 500, 50, 140, 20 ) );
    MenuOption->setChecked(menuprefs);
    connect( MenuOption,  SIGNAL(clicked()), this, SLOT(setMenuOption())  );

    PositionPrefs = new QCheckBox( prefframe1, "PositionPrefs" );
    PositionPrefs->setGeometry( QRect( 500, 140, 140, 20 ) );
    PositionPrefs->setChecked(rememberprefs);
    connect( PositionPrefs,  SIGNAL(clicked()), this, SLOT(setGlobalPositionSize())  );

    VideoHead = new QCheckBox( prefframe1, "VideoHead" );
    VideoHead->setGeometry( QRect( 500, 110, 140, 20 ) );
    VideoHead->setChecked(videohead);
    connect( VideoHead,  SIGNAL(clicked()), this, SLOT(setVideoHeadOption())  );

    WideScreenBox = new QCheckBox( prefframe1, "WideScreen" );
    WideScreenBox->setGeometry( QRect( 500, 170, 140, 20 ) );
    WideScreenBox->setChecked(widescreen);
    connect( WideScreenBox,  SIGNAL(clicked()), this, SLOT(setWidescreenOption())  );




    uiframe2 = new QFrame( prefframe1, "uiframe2" );
    uiframe2->setGeometry( QRect( 250, 110, 230, 2 ) );
    uiframe2->setFrameShape( QFrame::StyledPanel );
    uiframe2->setFrameShadow( QFrame::Raised );

    interfacelabel = new QLabel( prefframe1, "interfacelabel" );
    interfacelabel->setGeometry( QRect( 59, 10, 151, 21 ) );
    interfacelabel->setAlignment( int( QLabel::AlignCenter ) );

    uiframe3 = new QFrame( prefframe1, "uiframe3" );
    uiframe3->setGeometry( QRect( 490, 9, 2, 180 ) );
    uiframe3->setFrameShape( QFrame::StyledPanel );
    uiframe3->setFrameShadow( QFrame::Raised );

    uiframe4 = new QFrame( prefframe1, "uiframe4" );
    uiframe4->setGeometry( QRect( 670, 9, 2, 180 ) );
    uiframe4->setFrameShape( QFrame::StyledPanel );
    uiframe4->setFrameShadow( QFrame::Raised );

    languagelabel = new QLabel( prefframe1, "languagelabel" );
    languagelabel->setGeometry( QRect( 710, 20, 120, 21 ) );
    languagelabel->setAlignment( int( QLabel::AlignCenter ) );

    LanguageCombo = new QComboBox( FALSE, prefframe1, "LanguageCombo" );
    LanguageCombo->setGeometry( QRect( 680, 45, 170, 21 ) );
    LanguageCombo->insertItem("English");
    LanguageCombo->insertItem("Spanish");
    LanguageCombo->insertItem("French");
    LanguageCombo->insertItem("Portuguese");
    LanguageCombo->insertItem("German");
    LanguageCombo->setCurrentItem(0); //should be languagepref
    connect( LanguageCombo,  SIGNAL(activated(int)), this, SLOT(setLanguage(int))  );

    jahreslabel = new QLabel( prefframe1, "languagelabel" );
    jahreslabel->setGeometry( QRect( 710, 75, 120, 21 ) );
    jahreslabel->setAlignment( int( QLabel::AlignCenter ) );

    JahresCombo = new QComboBox( FALSE, prefframe1, "JahresCombo" );
    JahresCombo->setGeometry( QRect( 680, 100, 170, 21 ) );

	projectData thedata;

	thedata.buildComboBox(JahresCombo);
	
	JahresCombo->setCurrentItem(JahDefaultRes); //should be languagepref
    connect( JahresCombo,  SIGNAL(activated(int)), this, SLOT(setResolution(int))  );
	
    uiframe6 = new QFrame( prefframe1, "uiframe6" );
    uiframe6->setGeometry( QRect( 700, 140, 130, 2 ) );
    uiframe6->setFrameShape( QFrame::StyledPanel );
    uiframe6->setFrameShadow( QFrame::Raised );

    PrefExit = new QPushButton( prefframe1, "PrefExit" );
    PrefExit->setGeometry( QRect( 730, 160, 70, 21 ) );
    connect( PrefExit,  SIGNAL(clicked()), SLOT(changeModeDesktop())  );

    PreferenceslanguageChange();

}

void JahControl::PreferenceslanguageChange()
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

	//    setCaption( tr( "Form1" ) );
    interfacelabel->setText( jt.tr( "Interface Skins" ) );

    Pref1->setText( jt.tr( "Platinum" ) );
    Pref4->setText( jt.tr( "Charcoal" ) );
    Pref2->setText( jt.tr( "SGI" ) );
    Pref3->setText( jt.tr( "Brush Metal" ) );
    Pref5->setText( jt.tr( "Grey" ) );
    Pref6->setText( jt.tr( "Blue" ) );
    Pref7->setText( jt.tr( "Green" ) );
    Pref8->setText( jt.tr( "White" ) );
    Pref10->setText( jt.tr( "Remember UI" ) );
    StorageLocation->setText( jt.tr( "Dir" ) );
    StorageButton->setText( jt.tr( "Set Path" ) );

    MenuOption->setText( jt.tr( "Use Menus" ) );
    DualHead->setText( jt.tr( "Dual Head" ) );
    VideoHead->setText( jt.tr( "Video Head" ) );
    WideScreenBox->setText( jt.tr( "Wide Screen" ) );
    PositionPrefs->setText( jt.tr( "Remember UI Geometry" ) );

    PrefExit->setText( jt.tr( "RETURN" ) );

    storagelabel->setText( jt.tr( "Media Storage" ) );
    renderlabel->setText( jt.tr( "Render Settings" ) );
    uisettingslabel->setText( jt.tr( "User Interface" ) );

    languagelabel->setText( jt.tr( "Language" ) );
    jahreslabel->setText( jt.tr( "Resolution" ) );

	

    rendererlabel->setText( jt.tr( "Renderer" ) );
    renderqualitylabel->setText( jt.tr( "Quality" ) );
}


