/*******************************************************************************
**
** The source file for the Jahshaka Jahstyle module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "jahshaka.h"
#include "qsizepolicy.h"

/////////////////////////////////////////////////////////////
// Builds the frame of the interface

//void Jah::setupInterface( QWidget* parent, const char* name )
void Jah::setupInterface( )
{

    this->setMinimumSize( QSize( 1026, 768 ) );
    this->setSizeIncrement( QSize( 1, 1 ) );

    //should be based on screen resolution/gcard texturemem
    //and saved as a preference along with media dir and colorscheme
    this->setBaseSize( QSize( 1024, 786 ) );

    jahshakaLayout = new QGridLayout( this, 1, 1, 0, 0, "jahshakaLayout");

    QSizePolicy sizePolicy( QSizePolicy::Expanding, QSizePolicy::Expanding);

        menucontroller = new QFrame( this, "menucontroller" );
        menucontroller->setMinimumSize( QSize( 0, 0 ) );
        menucontroller->setMaximumSize( QSize( 32767, 15 ) );
        menucontroller->setPaletteBackgroundColor( QColor( 100, 100, 100 ) );
        menucontroller->setFrameShape( QFrame::StyledPanel );
        menucontroller->setFrameShadow( QFrame::Raised );

        jahshakaLayout->addWidget( menucontroller, 0, 0 );

        mainleftmenu = new QFrame( this, "mainleftmenu" );
        mainleftmenu->setMinimumSize( QSize( 30, 0 ) );
        mainleftmenu->setMaximumSize( QSize( 30, 1000 ) );
        mainleftmenu->setPaletteBackgroundColor( QColor( 100, 100, 100 ) );
        mainleftmenu->setFrameShape( QFrame::NoFrame );
        mainleftmenu->setFrameShadow( QFrame::Plain );

        mainleftmenu->setSizePolicy( sizePolicy );

        jahshakaLayout->addWidget( mainleftmenu, 0, 0 );

        mainworld = new QFrame( this, "mainworld" );
        mainworld->setMinimumSize( QSize( 964, 486 ) );
        mainworld->setMaximumSize( QSize( 3000, 2000 ) );
        mainworld->setPaletteBackgroundColor( QColor( 35, 35, 35 ) );
        mainworld->setCursor( QCursor( 2 ) );
        mainworld->setFrameShape( QFrame::NoFrame );
        mainworld->setFrameShadow( QFrame::Plain );

        mainworld->setSizePolicy( sizePolicy );

        jahshakaLayout->addWidget( mainworld, 0, 1 );

        mainrightmenu = new QFrame( this, "mainrightmenu" );
        mainrightmenu->setMinimumSize( QSize( 30, 0 ) );
        mainrightmenu->setMaximumSize( QSize( 30, 1000 ) );
        mainrightmenu->setPaletteBackgroundColor( QColor( 100, 100, 100 ) );
        mainrightmenu->setFrameShape( QFrame::NoFrame );
        mainrightmenu->setFrameShadow( QFrame::Plain );

        mainrightmenu->setSizePolicy( sizePolicy );

        jahshakaLayout->addWidget( mainrightmenu, 0, 2 );

        maincontroller = new QFrame( this, "maincontroller" );
        maincontroller->setMinimumSize( QSize( 0, 35 ) );
        maincontroller->setMaximumSize( QSize( 32767, 35 ) );
        maincontroller->setPaletteBackgroundColor( QColor( 100, 100, 100 ) );
        maincontroller->setFrameShape( QFrame::StyledPanel );
        maincontroller->setFrameShadow( QFrame::Raised );

        jahshakaLayout->addMultiCellWidget( maincontroller, 1, 1, 0, 2 );

    moduleinterface = new QFrame( this, "moduleinterface" );
    moduleinterface->setMinimumSize( QSize( 0, 235 ) );  ////////was 222 now is 209
    moduleinterface->setMaximumSize( QSize( 32767, 209 ) );
    moduleinterface->setFrameShape( QFrame::Box );
    moduleinterface->setFrameShadow( QFrame::Plain );

    moduleinterfaceLayout = new QHBoxLayout( moduleinterface, 0, 0, "moduleinterfaceLayout");

    moduleselection = new QFrame( moduleinterface, "moduleselection" );
    moduleselection->setMinimumSize( QSize( 125, 0 ) );
    moduleselection->setMaximumSize( QSize( 125, 32767 ) );
    moduleselection->setFrameShape( QFrame::NoFrame );
    moduleselection->setFrameShadow( QFrame::Raised );
    moduleinterfaceLayout->addWidget( moduleselection );

    modules = new QFrame( moduleinterface, "modules" );
    modules->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, modules->sizePolicy().hasHeightForWidth() ) );
    modules->setBackgroundOrigin( QFrame::WidgetOrigin );
    modules->setFrameShape( QFrame::NoFrame );
    modules->setFrameShadow( QFrame::Raised );

    modulesLayout = new QGridLayout( modules, 1, 1, 0, 0, "modulesLayout");

    feedbackbar = new QFrame( modules, "feedbackbar" );
    feedbackbar->setMinimumSize( QSize( 0, 40 ) );
    feedbackbar->setMaximumSize( QSize( 32767, 40 ) );
    feedbackbar->setFrameShape( QFrame::NoFrame );
    feedbackbar->setFrameShadow( QFrame::Plain );
    feedbackbar->setLineWidth( 0 );

    modulesLayout->addMultiCellWidget( feedbackbar, 0, 0, 0, 1 );

    modulesettings = new QFrame( modules, "modulesettings" );
    modulesettings->setMinimumSize( QSize( 870, 0 ) );
    modulesettings->setFrameShape( QFrame::StyledPanel );
    modulesettings->setFrameShadow( QFrame::Raised );
    modulesettings->setMargin( 0 );

    modulesLayout->addWidget( modulesettings, 1, 0 );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    modulesLayout->addItem( spacer, 1, 1 );
    moduleinterfaceLayout->addWidget( modules );

    jahshakaLayout->addMultiCellWidget( moduleinterface, 2, 2, 0, 2 );

    ///////////////////////////////////////////////////////////////
    //set the caption
    this->setCaption( tr( "JahShaka", "Realtime Editing and Effects" ) );

    //resize the app here based on prefs either small or large
    //this->resize( QSize(1270, 970).expandedTo(minimumSizeHint()) );

    int jw,jh;

    if ( QApplication::desktop()->width()  >= 1280 ) jw = 1270; else jw = 1026;
    if ( QApplication::desktop()->height() >= 970 ) jh = 970;   else jh = 768;

    this->resize( QSize(jw, jh).expandedTo(minimumSizeHint()) );


}


/////////////////////////////////////////////////////////////
// sets up the default look and feel of the interface

void Jah::setupMyCustomColors() 
{

    //first we set up the font
    QFont appFont = QApplication::font();
    appFont.setPointSize(10);
    appFont.setFamily("Helvetica");
    QFont::setDefaultFont(QFont("Helvetica", 10, QFont::Normal, false));
    qApp->setFont( QFont( "Helvetica", 10 ), TRUE );

    //now we set up the style
    QStyle *QSGIStyle=QStyleFactory::create("sgi");

    if(QSGIStyle)   
        qApp->setStyle( QSGIStyle );

    QPalette pal( QColor( 80, 80, 80 ) );

    QColorGroup active      (pal.active().foreground(), pal.active().background(),
                            pal.active().light(), pal.active().dark(),
                            pal.active().mid(), pal.active().text(),
                            pal.active().base() );
    active.setColor( QColorGroup::ButtonText,  Qt::white  );
    active.setColor( QColorGroup::Shadow,  Qt::black  );

    QColorGroup disabled    (pal.disabled().foreground(), pal.disabled().background(),
                            pal.disabled().light(), pal.disabled().dark(),
                            pal.disabled().mid(), pal.disabled().text(),
                            pal.disabled().base() );
    disabled.setColor( QColorGroup::ButtonText,  Qt::white  );

    QPalette newPalette( active, disabled, active );
    qApp->setPalette( newPalette, TRUE );


}

/////////////////////////////////////////////////////////////
// used to change the color of the interface

void Jah::setStyleColor(QPalette pal) 
{

    /////////////////////////////////////////////////////////////
    // First we set the color of the lower frames

    QColorGroup active      (pal.active().foreground(), pal.active().background(),
                            pal.active().light(), pal.active().dark(),
                            pal.active().mid(), pal.active().text(),
                            pal.active().base() );
    active.setColor( QColorGroup::ButtonText,  Qt::black  );
    active.setColor( QColorGroup::Shadow,  Qt::black  );

    QColorGroup disabled    (pal.disabled().foreground(), pal.disabled().background(),
                            pal.disabled().light(), pal.disabled().dark(),
                            pal.disabled().mid(), pal.disabled().text(),
                            pal.disabled().base() );
    disabled.setColor( QColorGroup::ButtonText,  Qt::black  );

    QPalette newPalette( active, disabled, active );
    qApp->setPalette( newPalette, TRUE );

    //these all get set by the qApp command above
    //moduleselection->setPalette( newPalette, TRUE );
    //modulesettings->setPalette( newPalette, TRUE );
    //feedbackbar->setPalette( newPalette, TRUE );

    /////////////////////////////////////////////////////////////
    // Now we set the color of the upper frame  as lighter than above

    QColor lighten = pal.color( QPalette::Active, QColorGroup::Background    );

    int red = lighten.red()+20;
    int green = lighten.green()+20;
    int blue = lighten.blue()+20;

    QPalette opp (QColor( red, green, blue ));

    QColorGroup oactive     (opp.active().foreground(), opp.active().background(),
                            opp.active().light(), opp.active().dark(),
                            opp.active().mid(), opp.active().text(),  //as white
                            opp.active().base() );
    oactive.setColor( QColorGroup::ButtonText,  Qt::black  );
    oactive.setColor( QColorGroup::Shadow,  Qt::black  );

    QColorGroup odisabled   (opp.disabled().foreground(), opp.disabled().background(),
                            opp.disabled().light(), opp.disabled().dark(),
                            opp.disabled().mid(), opp.disabled().text(),
                            opp.disabled().base() );
    odisabled.setColor( QColorGroup::ButtonText,  Qt::black  );

    QPalette onewPalette( oactive, odisabled, oactive );

    maincontroller->setPalette( onewPalette, TRUE );
    mainleftmenu->setPalette( onewPalette, TRUE );
    mainrightmenu->setPalette( onewPalette, TRUE );

}






