/*******************************************************************************
**
** The source file for the Jahshaka Jahroutines module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

// These are all the routines used by the jahcontrol class
//this file can be broken into module switching and utility routines

#include "jahcreate.h"

#include "RenderDialog.h"


void JahControl::changeModePref()
{

  if (dualhead==true)
  {
    D2optionals->raiseWidget(8);
  }
  else
  {
    optionals->raiseWidget(8);
  }
}

void JahControl::changeModeDesktop()
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    if (module != DESKTOP)
    {
        stopAnimation();
    }

    module = DESKTOP;
    TextView1_2->setText( jt.tr( " Jahshaka Media Integrator"  ) );
    checkDesktopButton();
    GetButton->hide();

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    if (dualhead==true)
    {
        D2WorldLayout->raiseWidget(0);
        D2optionals->raiseWidget(0);
        D2MainControler->raiseWidget(0);
        D2MainLeftControler->raiseWidget(0);
        D2MainRightControler->raiseWidget(0);         //raise the desktop controller on startup

    }
    else
    {
        WorldLayout->raiseWidget(0);
        optionals->raiseWidget(0);

        MainControler->raiseWidget(0);
        MainLeftControler->raiseWidget(0);
        MainRightControler->raiseWidget(0);         //raise the desktop controller on startup
    }

    thedesktop->setFocus();
}


void JahControl::changeModePlayer()
{

    bool clipselected = false;

    videoData theclip = thedesktop->getVideoData(clipselected);

    if (clipselected)
    {

        if (module != PLAYER)
        {
            stopAnimation();
        }

        module = PLAYER;  QString name; name = " Jahshaka Video Player : ";

        name = name.append(thedesktop->getClipname());       //add clip name to title text
        TextView1_2->setText( name );                        //we should also add format and resolution

        if (widescreen)
        {
            WorldLayout2->raiseWidget(0);
        }

        if (dualhead==true)
        {
            D2WorldLayout->raiseWidget(1);
            D2optionals->raiseWidget(1);
            D2MainControler->raiseWidget(1);
            D2MainLeftControler->raiseWidget(1);
            D2MainRightControler->raiseWidget(1);         //raise the desktop controller on startup

        }
        else
        {
            WorldLayout->raiseWidget(1);
            optionals->raiseWidget(1);
            MainControler->raiseWidget(1);
            MainLeftControler->raiseWidget(1);
            MainRightControler->raiseWidget(1);         //raise the desktop controller on startup
        }

        vidplayer->LoadMySequence(theclip);

        vidplayer->setFocus();

    }
}

void JahControl::changeModeNetwork()
{

    module = NETWORK;

    //hack here from effects
    WorldLayout->raiseWidget(0);


    if (dualhead==true)
    {
        D2optionals->raiseWidget(2);
    }
    else
    {
        optionals->raiseWidget(2);
    }

    jahnetwork->setFocus();
}

void JahControl::changeModeLibrary()
{

    module = LIBRARY;

    //hack here from effects
    WorldLayout->raiseWidget(12);
    //MainControler->raiseWidget(12);


	/*
    if (dualhead==true)
    {
        D2optionals->raiseWidget(12);
    }
    else
    {
        optionals->raiseWidget(12);
    }
	*/

    //jahnetwork->setFocus();
}

void JahControl::changeModeNetworkP2P()
{


    module = NETWORK;

    //hack here from effects
    WorldLayout->raiseWidget(2);


    if (dualhead==true)
    {
        D2optionals->raiseWidget(2);
    }
    else
    {
        optionals->raiseWidget(2);
    }

    jahnetwork->setFocus();
}



void JahControl::changeModeAnimation() 
{
    //this stops playback in the other modules so we arent eating resources
    if (module != ANIMATION) 
    { 
        stopAnimation(); 
    }

    module = ANIMATION;      
    TextView1_2->setText( tr( " Jahshaka Animation Module"  ) );
 
    checkDesktopButton();

    WorldLayout->raiseWidget(10);        
    
    optionals->raiseWidget(3);
    MainControler->raiseWidget(3);
    MainLeftControler->raiseWidget(3);  MainRightControler->raiseWidget(3);

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    connect(core, SIGNAL(paintit()), animation, SLOT(paintGL()) );

    connect(core, SIGNAL(mousePress(QMouseEvent*)),   animation, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseRelease(QMouseEvent*)), animation, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseMove(QMouseEvent*)),    animation, SLOT(mouseMoveEvent(QMouseEvent*)) );

    animation->raiseCore();

}

void JahControl::changeModeEffects() 
{   
    //this stops playback in the other modules so we arent eating resources
    if (module != EFFECTS) 
    { 
        stopAnimation(); 
    }

    module = EFFECTS;  
    TextView1_2->setText( tr( " Jahshaka Effects Module"  ) );
  
    checkDesktopButton();

    WorldLayout->raiseWidget(10);
    optionals->raiseWidget(4);
    MainControler->raiseWidget(4);
    MainLeftControler->raiseWidget(4);  MainRightControler->raiseWidget(4);

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    connect(core, SIGNAL(paintit()), effects, SLOT(paintGL()) );
    
    connect(core, SIGNAL(mousePress(QMouseEvent*)),   effects, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseRelease(QMouseEvent*)), effects, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseMove(QMouseEvent*)),    effects, SLOT(mouseMoveEvent(QMouseEvent*)) );

    effects->raiseCore();

}

//move to jahroutines.cpp
void JahControl::switchViewEffects(void)
{
    static int theid = 1;

    if (theid==2) theid=0;

    if (!widescreen)
    {
        theCoreLayout->raiseWidget(theid);
    }
    else
    {
        WorldLayout2->raiseWidget(theid);
    }

    theid+=1;

}

void JahControl::changeModeEditing() 
{
    //this stops playback in the other modules so we arent eating resources
    if (module != EDITING) 
    { 
        stopAnimation(); 
    }

    module = EDITING; 
    TextView1_2->setText( tr( " Jahshaka Editing Module"  ) );
   
    checkDesktopButton();

    WorldLayout->raiseWidget(10);        
    optionals->raiseWidget(5);
    MainControler->raiseWidget(5);
    MainLeftControler->raiseWidget(5);  MainRightControler->raiseWidget(5);

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    connect(core, SIGNAL(paintit()), editing, SLOT(paintGL()) );

    connect(core, SIGNAL(mousePress(QMouseEvent*)),   editing, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseRelease(QMouseEvent*)), editing, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseMove(QMouseEvent*)),    editing, SLOT(mouseMoveEvent(QMouseEvent*)) );

    editing->raiseCore();

}

void JahControl::changeModePaint() 
{
    //this stops playback in the other modules so we arent eating resources
    if (module != PAINT) 
    { 
        stopAnimation(); 
    }

    module = PAINT;  
    TextView1_2->setText( tr( " Jahshaka Paint Module"  ) );
   
    checkDesktopButton();

    WorldLayout->raiseWidget(6); //was 10 eh...
    
    optionals->raiseWidget(6);
    MainControler->raiseWidget(6);
    MainLeftControler->raiseWidget(6);  MainRightControler->raiseWidget(6);

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    connect(paintcore, SIGNAL(paintit()), paint, SLOT(paintGL()) );
    
    connect(paintcore, SIGNAL(mousePress(QMouseEvent*)),   paint, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(paintcore, SIGNAL(mouseRelease(QMouseEvent*)), paint, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(paintcore, SIGNAL(mouseMove(QMouseEvent*)),    paint, SLOT(mouseMoveEvent(QMouseEvent*)) );

    paint->raiseCore();

    paint->resizePaintGL();

    paint->refreshGL();

}

void JahControl::changeModeText() 
{

	if (module != TEXTCG) 
    { 
        stopAnimation(); 
    }

    module = TEXTCG;
    TextView1_2->setText( tr( " Jahshaka Text Module"  ) );
 
    checkDesktopButton();

    WorldLayout->raiseWidget(10);        
     optionals->raiseWidget(7);
    MainControler->raiseWidget(7);
    MainLeftControler->raiseWidget(7);  MainRightControler->raiseWidget(7);

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    connect(core, SIGNAL(paintit()), text, SLOT(paintGL()) );

    connect(core, SIGNAL(mousePress(QMouseEvent*)),   text, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseRelease(QMouseEvent*)), text, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseMove(QMouseEvent*)),    text, SLOT(mouseMoveEvent(QMouseEvent*)) );

    text->raiseCore();

}

void JahControl::changeModeColorize() 
{

    if (module != COLORIZE) 
    { 
        stopAnimation(); 
    }
   
    module = COLORIZE;    
    TextView1_2->setText( tr( " Jahshaka Color Module"  ) );

    checkDesktopButton();

    WorldLayout->raiseWidget(10);       optionals->raiseWidget(10);
    MainControler->raiseWidget(10);
    MainLeftControler->raiseWidget(10); MainRightControler->raiseWidget(10);

    if (widescreen)
    {
        WorldLayout2->raiseWidget(0);
    }

    connect(core, SIGNAL(paintit()), colorize, SLOT(paintGL()) );
 
    connect(core, SIGNAL(mousePress(QMouseEvent*)),   colorize, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseRelease(QMouseEvent*)), colorize, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseMove(QMouseEvent*)),    colorize, SLOT(mouseMoveEvent(QMouseEvent*)) );

    colorize->raiseCore();

}


/////////////////////////////////////////////////
// see OpenML reference code for openml compliant video io
void JahControl::changeModeVideoIO()
{


}

void JahControl::changeModeEncoding()
{

    //module = ENCODING;

    bool clipselected = false;

    videoData theclip = thedesktop->getVideoData(clipselected);

    if (clipselected)
    {
        if (module != ENCODING)
        {
            stopAnimation();
        }

        module = ENCODING;

        QString name = " Jahshaka Encoding Module : ";

        name = name.append(thedesktop->getClipname());       //add clip name to title text
        TextView1_2->setText( name );                        //we should also add format and resolution

        if (widescreen)
        {
            WorldLayout2->raiseWidget(0);
        }

        if (dualhead==true)
        {
            D2WorldLayout->raiseWidget(11);
            D2optionals->raiseWidget(11);
            D2MainControler->raiseWidget(11);
            D2MainLeftControler->raiseWidget(11);
            D2MainRightControler->raiseWidget(11);         //raise the desktop controller on startup

        }
        else
        {
            WorldLayout->raiseWidget(11);
            optionals->raiseWidget(11);
            MainControler->raiseWidget(11);
            MainLeftControler->raiseWidget(11);
            MainRightControler->raiseWidget(11);         //raise the desktop controller on startup
        }

        jahencoder->LoadMySequence(theclip);

        jahencoder->setFocus();

    }

}

void JahControl::changeModeBroadcasting()
{

    //module = BROADCASTING;
    //optionals->raiseWidget(2);
    //jahbroadcasting->setFocus();
}










