/*******************************************************************************
**
** The source file for the Jahshaka jahdesktop code
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

////////////////////////////////////////////////////////////////
// This is the file that sets up  the desktop interface
// and connects it to the routines

#include "jahplayercreate.h"

void JahControl::CreateDesktopFeedbackBox(QFrame* frame) 
{
}

void JahControl::CreateDesktopOptions(QHBox* frame) 
{
}


void JahControl::CreateDesktopMiddleFrame(QHBox* frame) 
{
	  page = new QWidget( frame, "page" );
  pageLayout = new QHBoxLayout( page, 0, 0, "pageLayout");
  QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer );

  modeselectframe = new QFrame( page, "modeselectframe" );
  modeselectframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, modeselectframe->sizePolicy().hasHeightForWidth() ) );
  modeselectframe->setMinimumSize( QSize( 100, 20 ) );
  modeselectframe->setMaximumSize( QSize( 100, 20 ) );
  modeselectframe->setFrameShape( QFrame::StyledPanel );
  modeselectframe->setFrameShadow( QFrame::Raised );

  modeselectbutton = new QPushButton( modeselectframe, "modeselectbutton" );
  modeselectbutton->setGeometry( QRect( 0, 0, 100, 20 ) );
  modeselectbutton->setMinimumSize( QSize( 100, 20 ) );
  modeselectbutton->setMaximumSize( QSize( 100, 20 ) );
  modeselectbutton->setText( tr( "Mode"  ) );
  connect( modeselectbutton,  SIGNAL(clicked()), SLOT( switchMode())  );

  pageLayout->addWidget( modeselectframe );
  QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer_2 );

  buttonframe = new QFrame( page, "buttonframe" );
  buttonframe->setMinimumSize( QSize( 336, 30 ) );
  buttonframe->setMaximumSize( QSize( 336, 30 ) );
  buttonframe->setFrameShape( QFrame::NoFrame );
  buttonframe->setFrameShadow( QFrame::Plain );

  //////////////////////////////////////////////
  // player buttons
  playername =   new JahToolButton( buttonframe, "binview" );
  addJahPlayerButton( playername,   0, 2, 84, 23 ,    84, 23, "Pixmaps/jahplayer/playername.png", "Pixmaps/jahplayer/playernameon.png" );
  connect ( playername,    SIGNAL(clicked()), this, SLOT( nameClip()) );

  popup2 = new FancyPopup( buttonframe, "Enter Clipname",250,130 );  //send size and position as well
  connect ( popup2,      SIGNAL( returnText(QString)), this, SLOT( printnameClip(QString)) );

  playerload =   new JahToolButton( buttonframe, "binview" );
  addJahPlayerButton( playerload,   84, 2, 84, 23 ,    84, 23, "Pixmaps/jahplayer/playerload.png", "Pixmaps/jahplayer/playerloadon.png" );
  connect( playerload,  SIGNAL(clicked()), thedesktop, SLOT(slotLoadIconview())  );  //this slot is located in desktop.h

  playerplay =   new JahToolButton( buttonframe, "binview" );
  addJahPlayerButton( playerplay,   168, 2, 84, 23,    84, 23, "Pixmaps/jahplayer/playerplay.png", "Pixmaps/jahplayer/playerplayon.png" );
  connect( playerplay,  SIGNAL(clicked()), SLOT(changeModePlayer())  );    //this is located in jahcontrol

  playerdelete =   new JahToolButton( buttonframe, "binview" );
  addJahPlayerButton( playerdelete,   252, 2, 84, 23,   84, 23, "Pixmaps/jahplayer/playerdelete.png", "Pixmaps/jahplayer/playerdeleteon.png" );
  connect ( playerdelete,  SIGNAL(clicked()), thedesktop, SLOT( clearItem()) );

  pageLayout->addWidget( buttonframe );

  QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer_3 );

  desktopselectframe = new QFrame( page, "desktopselectframe" );
  desktopselectframe->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, desktopselectframe->sizePolicy().hasHeightForWidth() ) );
  desktopselectframe->setMinimumSize( QSize( 100, 20 ) );
  desktopselectframe->setMaximumSize( QSize( 100, 20 ) );
  desktopselectframe->setFrameShape( QFrame::StyledPanel );
  desktopselectframe->setFrameShadow( QFrame::Raised );

  desktopselectbutton = new QPushButton( desktopselectframe, "desktopselectbutton" );
  desktopselectbutton->setGeometry( QRect( 0, 0, 100, 20 ) );
  desktopselectbutton->setMinimumSize( QSize( 100, 20 ) );
  desktopselectbutton->setMaximumSize( QSize( 100, 20 ) );
  desktopselectbutton->setText( tr( "Desktop"  ) );
  connect( desktopselectbutton,  SIGNAL(clicked()), SLOT( switchDesktop())  );

  pageLayout->addWidget( desktopselectframe );
  QSpacerItem* spacer_4 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
  pageLayout->addItem( spacer_4 );

}

//icon for desktop preferences locate jahpath
static const char* basefolder_xpm[] = {
    "15 14 4 1",
    " 	c None",
    ".	c #000000",
    "+	c #FFFF00",
    "@	c #FFFFFF",
    "          .    ",
    "               ",
    "          .    ",
    "       .     . ",
    "  ....  . . .  ",
    " .+@+@.  . .   ",
    "..........  . .",
    ".@+@+@+@+@..   ",
    ".+@+@+@+@+. .  ",
    ".@+@+@+@+@.  . ",
    ".+@+@+@+@+.    ",
    ".@+@+@+@+@.    ",
    ".+@+@+@+@+.    ",
    "...........    "};

/////////////////////////////////////////////////////
// need to make this a popup dialog

void JahControl::CreateDesktopPreferences(QHBox* frame)
{
	//set up translator
    //JahTranslate& jt = JahTranslate::getInstance();

    prefframe1 = new QFrame( frame, "prefframe1" );
    prefframe1->setGeometry( QRect( 0, 0, 860, 200 ) );

    interfacelabel = new QLabel( prefframe1, "interfacelabel" );
    interfacelabel->setGeometry( QRect( 20, 10, 151, 21 ) );
    interfacelabel->setAlignment( int( QLabel::AlignCenter ) );

    Pref1 = new QPushButton( prefframe1, "Pref1" );
    Pref1->setGeometry( QRect( 10, 41, 70, 21 ) );
    connect( Pref1, SIGNAL(clicked()),  SLOT(stylePlatinum()) );

    Pref2 = new QPushButton( prefframe1, "Pref2" );
    Pref2->setGeometry( QRect( 10, 71, 70, 21 ) );
    connect( Pref2, SIGNAL(clicked()),  SLOT(styleSgi()) );
 
    Pref3 = new QPushButton( prefframe1, "Pref3" );
    Pref3->setGeometry( QRect( 10, 131, 70, 21 ) );
    connect( Pref3,  SIGNAL(clicked()), SLOT(styleMetal()) );

    Pref4 = new QPushButton( prefframe1, "Pref4" );
    Pref4->setGeometry( QRect( 10, 101, 70, 21 ) );
    connect( Pref4,  SIGNAL(clicked()), SLOT(styleCharcoal()) );

    Pref5 = new QPushButton( prefframe1, "Pref5" );
    Pref5->setGeometry( QRect( 90, 41, 70, 21 ) );
    connect( Pref5, SIGNAL(clicked()),  SLOT(styleGrey()) );

    Pref6 = new QPushButton( prefframe1, "Pref6" );
    Pref6->setGeometry( QRect( 90, 71, 70, 21 ) );
    connect( Pref6, SIGNAL(clicked()),  SLOT(styleBlue()) );

    Pref7 = new QPushButton( prefframe1, "Pref7" );
    Pref7->setGeometry( QRect( 90, 101, 70, 21 ) );
    connect( Pref7,  SIGNAL(clicked()), SLOT(styleGreen()) );

    Pref8 = new QPushButton( prefframe1, "Pref8" );
    Pref8->setGeometry( QRect( 90, 131, 70, 21 ) );
    connect( Pref8,  SIGNAL(clicked()), SLOT(styleWhite()) );  //change to signal...?

    Pref10 = new QCheckBox( prefframe1, "Pref10" );
    Pref10->setGeometry( QRect( 15, 160, 130, 21 ) );
    Pref10->setChecked(jahStyleprefs);
    connect( Pref10,  SIGNAL(clicked()), this, SLOT(setStyleOption())  );

	//the vertical line
    uiframe1 = new QFrame( prefframe1, "uiframe1" );
    uiframe1->setGeometry( QRect( 180, 10, 2, 180 ) );
    uiframe1->setFrameShape( QFrame::StyledPanel );
    uiframe1->setFrameShadow( QFrame::Raised );

	//////////////////////////////////////////////////////////////

    storagelabel = new QLabel( prefframe1, "storagelabel" );
    storagelabel->setGeometry( QRect( 250, 11, 151, 21 ) );
    storagelabel->setAlignment( int( QLabel::AlignCenter ) );

    StorageBox = new QLineEdit( prefframe1, "StorageBox" );
    StorageBox->setGeometry( QRect( 200, 40, 240, 21 ) );
    StorageBox->setText( JahMediaPath );

    StorageButton = new QPushButton( prefframe1, "StorageButton" );
    StorageButton->setGeometry( QRect( 200, 71, 70, 21 ) );
    connect( StorageButton, SIGNAL(clicked()),  SLOT(setStoragePath()) );

    QPixmap pix; pix = QPixmap( basefolder_xpm );

    StorageLocation = new QToolButton( prefframe1, "StorageLocation" );
    StorageLocation->setGeometry( QRect( 370, 71, 70, 21 ) );
    StorageLocation->setIconSet(pix);
    connect( StorageLocation , SIGNAL(clicked()),  SLOT(getStoragePath()) );

    uiframe2 = new QFrame( prefframe1, "uiframe2" );
    uiframe2->setGeometry( QRect( 200, 108, 250, 2 ) );
    uiframe2->setFrameShape( QFrame::StyledPanel );
    uiframe2->setFrameShadow( QFrame::Raised );

	///////////////////////////////////////////////////////////////


    languagelabel = new QLabel( prefframe1, "languagelabel" );
    languagelabel->setGeometry( QRect( 250, 115, 120, 21 ) );
    languagelabel->setAlignment( int( QLabel::AlignCenter ) );

    LanguageCombo = new QComboBox( FALSE, prefframe1, "LanguageCombo" );
    LanguageCombo->setGeometry( QRect( 220, 140, 200, 21 ) );
    LanguageCombo->insertItem("English");
    LanguageCombo->insertItem("Spanish");
    LanguageCombo->insertItem("French");
    LanguageCombo->insertItem("Portuguese");
    LanguageCombo->insertItem("German");
    LanguageCombo->setCurrentItem(0); //should be languagepref
    connect( LanguageCombo,  SIGNAL(activated(int)), this, SLOT(setLanguage(int))  );


    jahreslabel = new QLabel( prefframe1, "languagelabel" );
    jahreslabel->setGeometry( QRect( 200, 165, 120, 21 ) );
    jahreslabel->setAlignment( int( QLabel::AlignLeft ) );

    JahresCombo = new QComboBox( FALSE, prefframe1, "JahresCombo" );
    JahresCombo->setGeometry( QRect( 250, 165, 170, 21 ) );

	projectData thedata;

	thedata.buildComboBox(JahresCombo);
	
	JahresCombo->setCurrentItem(JahDefaultRes); //should be languagepref
    connect( JahresCombo,  SIGNAL(activated(int)), this, SLOT(setResolution(int))  );



    uiframe3 = new QFrame( prefframe1, "uiframe3" );
    uiframe3->setGeometry( QRect( 470, 9, 2, 180 ) );
    uiframe3->setFrameShape( QFrame::StyledPanel );
    uiframe3->setFrameShadow( QFrame::Raised );

	/////////////////////////////////////////////////////////////////

    uisettingslabel = new QLabel( prefframe1, "uisettingslabel" );
    uisettingslabel->setGeometry( QRect( 510, 11, 120, 21 ) );
    uisettingslabel->setAlignment( int( QLabel::AlignCenter ) );

    //DualHead = new QCheckBox( prefframe1, "DualHead" );
    //DualHead->setGeometry( QRect( 500, 80, 140, 20 ) );
    //DualHead->setChecked(dualheadprefs);
    //connect( DualHead,  SIGNAL(clicked()), this, SLOT(setDualHeadOption())  );

    MenuOption = new QCheckBox( prefframe1, "MenuOption" );
    MenuOption->setGeometry( QRect( 500, 50, 140, 20 ) );
    MenuOption->setChecked(menuprefs);
    connect( MenuOption,  SIGNAL(clicked()), this, SLOT(setMenuOption())  );

    PositionPrefs = new QCheckBox( prefframe1, "PositionPrefs" );
    PositionPrefs->setGeometry( QRect( 500, 140, 180, 20 ) );
    PositionPrefs->setChecked(rememberprefs);
    connect( PositionPrefs,  SIGNAL(clicked()), this, SLOT(setGlobalPositionSize())  );

    VideoHead = new QCheckBox( prefframe1, "VideoHead" );
    VideoHead->setGeometry( QRect( 500, 110, 140, 20 ) );
    VideoHead->setChecked(videohead);
    connect( VideoHead,  SIGNAL(clicked()), this, SLOT(setVideoHeadOption())  );

    WideScreenBox = new QCheckBox( prefframe1, "WideScreen" );
    WideScreenBox->setGeometry( QRect( 500, 170, 140, 20 ) );
    WideScreenBox->setChecked(widescreen);
    connect( WideScreenBox,  SIGNAL(clicked()), this, SLOT(setWidescreenOption())  );


    PreferenceslanguageChange();

}

void JahControl::PreferenceslanguageChange()
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

	//    setCaption( tr( "Form1" ) );
    interfacelabel->setText( jt.tr( "Interface Skins" ) );

    Pref1->setText( jt.tr( "Platinum" ) );
    Pref4->setText( jt.tr( "Charcoal" ) );
    Pref2->setText( jt.tr( "SGI" ) );
    Pref3->setText( jt.tr( "Brush Metal" ) );
    Pref5->setText( jt.tr( "Grey" ) );
    Pref6->setText( jt.tr( "Blue" ) );
    Pref7->setText( jt.tr( "Green" ) );
    Pref8->setText( jt.tr( "White" ) );
    Pref10->setText( jt.tr( "Remember Style" ) );
    StorageLocation->setText( jt.tr( "Change Dir" ) );
    StorageButton->setText( jt.tr( "Set Path" ) );

    MenuOption->setText( jt.tr( "Use Menus" ) );
    //DualHead->setText( jt.tr( "Dual Head" ) );
    VideoHead->setText( jt.tr( "Video Head" ) );
    WideScreenBox->setText( jt.tr( "Wide Screen" ) );
    PositionPrefs->setText( jt.tr( "Remember UI Geometry" ) );

    storagelabel->setText( jt.tr( "Media Storage" ) );
    uisettingslabel->setText( jt.tr( "User Interface" ) );

    languagelabel->setText( jt.tr( "Language" ) );
    jahreslabel->setText( jt.tr( "Res" ) );

}


/////////////////////////////////////////////////////////////////////
// need to move this to where the other one is...

void JahControl::addJahPlayerButton( JahToolButton * button, int x1, int y1, int x2, int y2,
                                  int w, int h, QString iconOff, QString iconOn ) {

    button->setToggleButton(false);
    //button->setFixedSize(w,h);
    button->setUsesBigPixmap(true);
    button->setGeometry( QRect( x1, y1, x2, y2 ) );

    QIconSet *icoSet;
    icoSet = new QIconSet( QPixmap(iconOff) );
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Large, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Large, QIconSet::Disabled);
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Small, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Small, QIconSet::Disabled);
    button->setIconSet(*icoSet);
    //delete icoSet;

}


