/*******************************************************************************
**
** The source file for the Jahshaka Jahroutines module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

// These are all the routines used by the jahcontrol class
//this file can be broken into module switching and utility routines

#include "jahplayercreate.h"

////////////////////////////////////////////
// preferences for the player are in a popup dialog box
// thats created every time mon

void JahControl::changeModePref()
{
	prefsdialog->show();

}

void JahControl::changeModeDesktop()
{
	//set up translator
    JahTranslate& jt = JahTranslate::getInstance();

    if (module != DESKTOP)
    {
        stopAnimation();
    }

    module = DESKTOP;

    WorldLayout->raiseWidget(0);
    optionals->raiseWidget(0);

    MainControler->raiseWidget(0);
    MainLeftControler->raiseWidget(0);
    MainRightControler->raiseWidget(0);         //raise the desktop controller on startup

    thedesktop->setFocus();
}


void JahControl::changeModePlayer()
{

    bool clipselected = false;

    videoData theclip = thedesktop->getVideoData(clipselected);

    if (clipselected)
    {

        if (module != PLAYER)
        {
            stopAnimation();
        }

        module = PLAYER;  
		
		//QString name; name = " Jahshaka Video Player : ";
        //name = name.append(thedesktop->getClipname());       //add clip name to title text
        //TextView1_2->setText( name );                        //we should also add format and resolution


            WorldLayout->raiseWidget(1);
            optionals->raiseWidget(1);
            MainControler->raiseWidget(1);
            MainLeftControler->raiseWidget(1);
            MainRightControler->raiseWidget(1);         //raise the desktop controller on startup

        vidplayer->LoadMySequence(theclip);

        vidplayer->setFocus();

    }
}

void JahControl::changeModeNetwork()
{
}

void JahControl::changeModeNetworkP2P()
{   
}



void JahControl::changeModeAnimation() 
{
    //this stops playback in the other modules so we arent eating resources
    if (module != GLPLAYER) 
    { 
        stopAnimation(); 
    }

    module = GLPLAYER;      
    //TextView1_2->setText( tr( " Jahshaka Animation Module"  ) );
 
    checkDesktopButton();

    WorldLayout->raiseWidget(3);        
//    WorldLayout->raiseWidget(10);        
    
    optionals->raiseWidget(3);
    MainControler->raiseWidget(3);
    MainLeftControler->raiseWidget(3);  
	MainRightControler->raiseWidget(3);

//    if (widescreen)
  //  {
    //    WorldLayout2->raiseWidget(0);
    //}

    connect(core, SIGNAL(paintit()), animation, SLOT(paintGL()) );

    connect(core, SIGNAL(mousePress(QMouseEvent*)),   animation, SLOT(mousePressEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseRelease(QMouseEvent*)), animation, SLOT(mouseReleaseEvent(QMouseEvent*)) );
    connect(core, SIGNAL(mouseMove(QMouseEvent*)),    animation, SLOT(mouseMoveEvent(QMouseEvent*)) );

    animation->raiseCore();

}

void JahControl::changeModeEffects() 
{   
}

//move to jahroutines.cpp
void JahControl::switchViewEffects(void)
{
    static int theid = 1;

    if (theid==2) theid=0;

    if (!widescreen)
    {
        theCoreLayout->raiseWidget(theid);
    }
    else
    {
        WorldLayout2->raiseWidget(theid);
    }

    theid+=1;

}

void JahControl::changeModeEditing() 
{
}

void JahControl::changeModePaint() 
{
}

void JahControl::changeModeText() 
{
}

void JahControl::changeModeColorize() 
{
}


/////////////////////////////////////////////////
// see OpenML reference code for openml compliant video io
void JahControl::changeModeVideoIO()
{
}

void JahControl::changeModeEncoding()
{
}

void JahControl::changeModeBroadcasting()
{
}










