/*******************************************************************************
**
** The source file for the Jahshaka desktop module file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

////////////////////////////////////////////////////////////////
// This is the file that sets up all the individual modules
// and connects them to the desktop

#include "jahplayercreate.h"

////////////////////////////////////////////////////////////////
//Code to set up the Animation module


void JahControl::CreateDesktopModule(QHBox* frame,QHBox* frame2)
{
    if(dualheadprefs==true)
    {

    }
    else
    {
        MainDesktopControler    = new QHBox(MainControler);
        MainControler->addWidget(MainDesktopControler,0);

        MainDesktopLeftControler  = new QHBox(MainLeftControler);
        MainLeftControler->addWidget(MainDesktopLeftControler,0); //animation

        MainDesktopRightControler  = new QHBox(MainRightControler);
        MainRightControler->addWidget(MainDesktopRightControler,0); //animation

        //module user controles
        optionals_desktop = new QVBox(optionals);
        optionals->addWidget(optionals_desktop,0);


		// Create Desktop Interface Preferences Here
        prefsdialog   = new QWidget(0,"Preferences");	
		prefsdialog->setMinimumSize( QSize( 700, 200 ) );
		prefsdialog->setMaximumSize( QSize( 700, 200 ) );
		prefsdialog->setBaseSize( QSize( 700, 200 ) );
		prefsdialog->resize( QSize(700, 200) );

		//prefsdialog->hide();
        
        optionals_prefs = new QFrame( prefsdialog, "prefsController" );
        optionals_prefs->setMinimumSize( QSize( 700, 200 ) );
        optionals_prefs->setMaximumSize( QSize( 700, 200 ) );
        
    }

    ////////////////////////////////////////////////////////////////////////
    // create the desktop module/object

    thedesktop = new JahDesktop( frame, frame2, MainDesktopLeftControler, 
                                MainDesktopRightControler,
                                "desktop", &globalclipnumber );

    ///////////////////////////////////////////////////////////////
    //now we set up the desktop interface
    //all other modules do this themselves ie effects,animation
    //but since desktop controls all of them its easier to do it here

    // setup the desktop middle frame first ie load, delete, play, etc
    CreateDesktopMiddleFrame(MainDesktopControler);


	//gotta create this ina dialog and hide it unless called?
    //Set up Desktop Preferences Options and buttons here
    
	preferencesframe  = new QHBox(optionals_prefs);
	preferencesframe->setGeometry( QRect( 0, 0, 860, 200 ) );
    CreateDesktopPreferences(preferencesframe);

}

void JahControl::CreatePlayerModule(QFrame* frame)
{
    if (dualheadprefs==true)
    {
        MainPlayerControler  = new QHBox(D2MainControler);
        D2MainControler->addWidget(MainPlayerControler,1);

        MainPlayerLeftControler  = new QHBox(D2MainLeftControler);
        D2MainLeftControler->addWidget(MainPlayerLeftControler,1); //animation

        MainPlayerRightControler  = new QHBox(D2MainRightControler);
        D2MainRightControler->addWidget(MainPlayerRightControler,1); //animation

        optionals_player   = new QHBox(D2optionals);
        D2optionals->addWidget(optionals_player,1);

    }
    else
    {

        MainPlayerControler  = new QHBox(MainControler);
        MainControler->addWidget(MainPlayerControler,1);

        MainPlayerLeftControler  = new QHBox(MainLeftControler);
        MainLeftControler->addWidget(MainPlayerLeftControler,1); //animation

        MainPlayerRightControler  = new QHBox(MainRightControler);
        MainRightControler->addWidget(MainPlayerRightControler,1); //animation

        optionals_player   = new QHBox(optionals);
        optionals->addWidget(optionals_player,1);


    }

    ////////////////////////////////////////////////////////////////////////
    // create the player module/object

    vidplayer = new MainPlayer( frame, "playerlayout", optionals_player, MainPlayerControler,
                                MainPlayerLeftControler,MainPlayerRightControler );

	connect( vidplayer,  SIGNAL(toggleTheDesktopImages()), this, SLOT(changeModeDesktop())  );
	connect( vidplayer,  SIGNAL(toggleTheDesktopTable()), this, SLOT(changeModeDesktop())  );

    //////////////////////////////////////////////////////
    //display startup image.in video player.
    //gives trouble under linux... due to timer in player?
    displayVideo2startupImage();

}


//this is now the 3dplayer module
void JahControl::CreateAnimationModule() 
{

    MainAnimationControler  = new QHBox(MainControler);
    MainControler->addWidget(MainAnimationControler,3); //animation

    MainAnimationLeftControler  = new QHBox(MainLeftControler);
    MainLeftControler->addWidget(MainAnimationLeftControler,3); //animation

    MainAnimationRightControler  = new QHBox(MainRightControler);
    MainRightControler->addWidget(MainAnimationRightControler,3); //animation

    //set up module control space
    optionals_animation = new QHBox(optionals);
    optionals->addWidget(optionals_animation,3);

    ////////////////////////////////////////////////////////////////////////
    // create the animation module/object

    animation = new GLPlayer( core, "Animation" , optionals_animation,
                            MainAnimationControler,
                            MainAnimationLeftControler, MainAnimationRightControler,
                            &globalclipnumber  );

    //without this windows boxes loose tracking in the anime module (only?)
    animation->setMouseTracking( false );


    //added for video head
    connect ( animation,   SIGNAL(updatePlayer(QImage)), SLOT( displayClipInPlayer(QImage)) );


}

////////////////////////////////////////////////////////////////
//Code to set up the Effects module

void JahControl::CreateEffectsModule()
{
}
void JahControl::CreateEditingModule() 
{
}
void JahControl::CreatePaintModule() 
{
}
void JahControl::CreateTextModule() 
{
}
void JahControl::CreateColorModule() 
{
}
void JahControl::CreateEncodingModule(QFrame* frame)
{
}
void JahControl::CreateNetworkModule(QFrame* frame)
{
}
