/*******************************************************************************
**
** The source file for the Jahshaka Jahroutines module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

// These are all the routines used by the jahcontrol class
//this file can be broken into module switching and utility routines

#include "jahplayercreate.h"


void JahControl::addImageToDesktop( videoData thedata )
{

    //need to call the table function when we load clips in the desktop module
    thedesktop->addItemToDesktopTable( globalclipnumber, thedata );
    thedesktop->addImage2(thedata);
    thedesktop->doRefresh();

    thedesktop->addAssetTodatabase(thedata);

}

////////////////////////////////////////////////////////////////////////////
// used in the network p2p module to grab clips from the p2p share
// thedata is the path+filename of the clip

void JahControl::addStringToDesktop( QString thedata )
{
    //need to call the table function when we load clips in the desktop module
    //thedesktop->addItemToDesktopTable( globalclipnumber, thedata );
    //thedesktop->addImage2(thedata);
    //debug("adding string to desktop");

    thedesktop->loadJahAsset(thedata);

    //thedesktop->addImage2database(thedata);

}


////////////////////////////////////////////////////////////////////////////
// used for drag and drop

void JahControl::draggedAImage( )
{
    //first see if a layer is selected in the calling module
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug("grabbing asset now that it dropped");

     switch(module) {

        case GLPLAYER     : { //animation->stopanimation();
                                jtrace.debug("animation");
                                int pp = animation->activeLayers->getFinalSelection();
                                jtrace.debug("acitve layer:",pp);

                                //is layer active?

                                break; }
        default           : {
                              jtrace.debug("drag and drop::","unknown module");
                              break;
                            }

      }

    ReturnDesktop();


}

void JahControl::checkClearPlayer() 
{
    if (  (module == PLAYER) )
    { 
        vidplayer->ClearOut(); 
    }
}


void JahControl::notifyPlayerOfChange()
{
    bool clipstatus = false;

    videoData theclip = thedesktop->getVideoData(clipstatus);

    if (clipstatus)
    {
        if (module == PLAYER)
        {
            vidplayer->ClearOut();

            vidplayer->LoadMySequence(theclip);
            vidplayer->setFocus();

        }
    }
}

/////////////////////////////////////////////////////////////////////////////
//this was added  to blast a image to the player on demand from a module
//but its used for videohead support from modules
//and so it messes up the player in dual head mode

void JahControl::displayClipInPlayer(QImage thedata )
{
    debug("JahControl >>doing display clip in player");

    vidplayer->ClearOut();
    vidplayer->BlastImage(thedata);
}

void JahControl::stopAnimation() 
{    //stop playback in other modules

    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();

     switch(module) {

        case GLPLAYER     : { animation->stopanimation();
                                QObject::disconnect(core, SIGNAL(paintit()), animation, SLOT(paintGL()) );
                                QObject::disconnect(core, SIGNAL(mousePress(QMouseEvent*)),   animation, SLOT(mousePressEvent(QMouseEvent*)) );
                                QObject::disconnect(core, SIGNAL(mouseRelease(QMouseEvent*)), animation, SLOT(mouseReleaseEvent(QMouseEvent*)) );
                                QObject::disconnect(core, SIGNAL(mouseMove(QMouseEvent*)),    animation, SLOT(mouseMoveEvent(QMouseEvent*)) );
                              break; }


	    case DESKTOP      : { break; }  //was StopPlayer

        case PLAYER       : { vidplayer->ClearOut();        break; }  //was StopPlayer

        default           : {
                              jtrace.debug("JahControl::","unknown module in stopAnimation()");
                              break;
                            }

      }

 }




//checks the get/return button on the desktops status
void JahControl::checkDesktopButton() 
{
}


////////////////////////////////////////////////////////////
// routines to send clips from desktop to modules

void JahControl::GetDesktop() 
{
}

void JahControl::ReturnDesktop()
{
}

//these are used to grab the current active desktop clip...
//need error checking on this ie what if newclip is blank?
void JahControl::GrabClipAnim()    
{
}

void JahControl::GrabClipEffects() 
{    
}


//the editor needs to return a clip
//future drag and drop implementation here
void JahControl::AddClipEdit()     
{
}

void JahControl::GrabClipEdit()    
{
}

void JahControl::ReturnClipEdit()  
{    
}

void JahControl::GrabClipAnimKey() 
{    
}

void JahControl::GrabClipCG()      
{    
}

void JahControl::GrabClipColorize()
{    
}

void JahControl::GrabClipPaint()   
{    
}

void JahControl::GrabClipNetwork() 
{    
}

void JahControl::nameClip() 
{  
}

//check to see if a clip is selected first or we crash!
void JahControl::printnameClip(QString item) 
{
}


void JahControl::switchMode(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...
   bool added = TRUE;
   //need a global mode variable to track the main mode...

   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( "Web",3,0 );
    menu->insertItem( "Audio",2,0 );
    menu->insertItem( "Video",1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( modeselectbutton->mapToGlobal( QPoint( 0, modeselectbutton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) 
    {
   
      switch(id) {
         case 1   :  { break; }
         case 2   :  { break; }
         case 3   :  { break; }
         default  :  {  break; }
      }
    } 
    else 
    { 
        added = FALSE;
    }

    delete menu;

}


void JahControl::switchDesktop(void)
{
   //add a new layer
   //issues when adding over a deleted layer -> need to reset the layer before a add is done...
   bool added = TRUE;
   //need a global mode variable to track the main mode...

   //add on demand layers...
   QPopupMenu *menu = new QPopupMenu( 0 );

    menu->insertItem( ">> add new",2,0 );
    menu->insertItem( "Desktop 1",1,0 );

    menu->setMouseTracking( TRUE );
    int id = menu->exec( desktopselectbutton->mapToGlobal( QPoint( 0, desktopselectbutton->height() + 1 ) ) );
    QString layNum,temp;

    if ( id != -1 ) {
      //if (numberLayers==NUMBER_LAYERS) return;
      //numberLayers+=1; layNum.setNum(numberLayers);

      switch(id) {
         case 1  : { break; }
         case 2  : { break; }
         case 3  : { break; }
         default  :  {  break; }

      }
    } else { added = FALSE;}

    delete menu;

}













