###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE        =       lib
CONFIG          +=      staticlib qt warn_on release opengl thread
HEADERS         =       desktop.h \
                        desktopcanvas.h \
                        desktoptable.h
SOURCES         =       desktop.cpp \
                        desktopcanvas.cpp \
                        desktoptable.cpp \
                        desktopinterface.cpp \
                        desktopdbase.cpp \
                        desktopfileio.cpp \
                        desktopfileloaders.cpp

TARGET          =       desktop
DEPENDPATH      =       $$JAHDEPENDPATH

###############################################################
#the project related includes
INCLUDEPATH =       . .. ../Source \
                    ../Core/Objects ../Core/Render ../Core/World  \
                    ../desktop

#files for mpeg encoder on linux
contains( JAHMPEGENCODER,true ) {
INCLUDEPATH +=  ../encoders/mpegenc
}

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
INCLUDEPATH +=  ../encoders/mpegdec
}

#files for mpeg decoder on linux
contains( SPACEBALL,true ) {
INCLUDEPATH +=  ../libraries/spaceball
}

#files for audiosupport
contains( JAHAUDIO,true ) {
INCLUDEPATH +=          ../libraries/jahaudio
}

INCLUDEPATH +=          ../desktop \
                        ../libraries \
                        ../libraries/assetobject \
                        ../libraries/GLCore \
                        ../libraries/glew \
                        ../libraries/imagelibs \
                        ../libraries/jahkeyframes \
                        ../libraries/jahpreferences \
                        ../libraries/jahtranslate \
                        ../libraries/jahtimer \
                        ../libraries/jahtracer \
                        ../libraries/mediaobject
                        
contains( SPACEBALL,true ) {
INCLUDEPATH     +=      ../libraries/spaceball
}

INCLUDEPATH +=          ../libraries/jahplugins \
                        ../libraries/jahdatabase \
                        ../uiwidgets \
                        ../uiwidgets/interfaceobjs \
                        ../uiwidgets/jahcalc \
                        ../uiwidgets/jahfileloader \
                        ../uiwidgets/keyframes \
                        ../uiwidgets/nodes \
                        ../uiwidgets/timeline \
                        ../objectlibs/FTGL \
                        ../objectlibs/glmlib \
                        ../objectlibs/l3ds \
                        ../objectlibs/particle \
                        ../objectlibs/blur \
                        ../sqlite \
                        $$FREEDIR


contains( JAHOS,IRIX ) {
INCLUDEPATH +=      $$SGIDIR
}

