/*******************************************************************************
**
** The header file for the Jahshaka player module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef DESKTOPCANVAS_H
#define DESKTOPCANVAS_H

#include <glworld.h>

#include <sqlite.h>
#include <qmessagebox.h>
#include <mediaobject.h>
#include <qwidgetstack.h>
#include <qtable.h>

#include "jahtracer.h"


class videoData;
struct sqlite;

static const int imageRTTI = 984376;
const bool no_writing = FALSE;

class ImageItem: public QCanvasRectangle {
public:

  ImageItem( videoData full, QImage img, QCanvas *canvas, QString& clipname );
  int rtti () const { return imageRTTI; }
  bool hit( const QPoint&) const;
  int Type () const { return _type; }

  videoData getClip() { return itemdata; }

  QString getText() { return name; }
  void setText(QString& newname) { name=newname;}

  // Actually it'd be better to implement it using RTTI (dynamic_cast)
  // but jahshaka gives segfault on dynamic_cast for me ;-(
  enum {ITEM_IMAGE, ITEM_AUDIO};
protected:
  void drawShape( QPainter & );
  int _type;
private:
  QImage image;
  //QImage fullres;
  QPixmap pixmap;
  QString name;

  videoData itemdata;

  //stores the images width and height for justification
  int imagewidth, imageheight;
  //stores to die's width and
  int diewidth, dieheight;

};



class FigureEditor : public QCanvasView {
  Q_OBJECT

public:
  FigureEditor(QCanvas*, QWidget* parent=0, const char* name=0, WFlags f=0);
  void clear();
  void clearItem();
  bool eraseItem(int clipnumber);
  void setItemtext(QString&);

  int getDesktopSelect();

  QString imagetext;
  ImageItem *globalitem;

  videoData selectedClip;

  //temporary workaround here as sgi dont check for infunc creation properly
  bool bordercreated;
  bool move;

protected:
  void contentsMousePressEvent(QMouseEvent*);
  void contentsMouseReleaseEvent(QMouseEvent*);
  void contentsMouseMoveEvent(QMouseEvent*);

signals:
  void status(const QString&);
  void updateClipPosition(videoData data);
    void activeFlagDesktop();
    
private:
  QCanvasItem* moving;
  QPoint moving_start;
  int height;

  QCanvasPolygonalItem  *border;
  QCanvasItem* borderframe;
  QCanvasText* itemtext;
};


#endif




