/*******************************************************************************
**
** The source file for the Jahshaka desktop database file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/


#include "desktop.h"



void JahDesktop::addAssetTodatabase(videoData thedata )
{
    theDatabase->addImage2database(thedata);
}


void JahDesktop::renameImageindatabase( int imagenumber, QString newname)
{
    theDatabase->renameImageindatabase( imagenumber,newname);
}

void JahDesktop::updateClipPosition( videoData data)
{
    theDatabase->updateClipPosition( data );

    //we should write this data out when we exit not all the time
   
}



//this is the main startup routine that rebuilds the desktop
//from the database by reading in all assets
//break this out into separate routines to make it easier to deal with...
//make this return bool for success to trap errors

void JahDesktop::RebuildDesktop()
{
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.info("Loading assets onto the desktop");

    int numclip = theDatabase->TestDatabase();

    if (numclip==0)
    {
        jtrace.debug("Database is empty");
        return;
    }


    /////////////////////////////////////////////////
    //loop through number of clips in videodatatable and add each one to the desktop
    //we need to update image locations for all clips when a clip is added and when we are leaving the app
    //using the sql:update command

    jtrace.info(">>Loading Assets from Database");

    for (int x=1; x<=numclip; x++)
    {

        //jtrace.debug(">>Loading Asset ",x);

        videoData thedata;

        //grabs the asset, if its not there we get a -1 in theCategory
        thedata = theDatabase->restoreImageFromDatabase(x);

        int thecat = thedata.theCategory;

        if ( (thecat >=0) && (thecat <=5) )
        {

            QString clipname = thedata.clipname;
            QString filename = thedata.filename;

            //add to table
            jtrace.info("Adding asset:", thedata.location+thedata.filename+thedata.extension );
            addItemToDesktopTable( x-1,  thedata );

            //a lousy way to check if the clip has been renamed
            if (clipname == filename)
            {
                addImage2(thedata);
            }
            else
            {
                addImage(thedata); //wassup here?
            }

        }

        canvas->update();
        *clipnumber = numclip;

    }


    jtrace.debug(">> finished loading Assets from Database");

    //system crashes if correct number of clips in videodata is not specified
    //we need to update global clipnumber

}











