/*******************************************************************************
**
** The source file for the Jahshaka animation interface module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "desktop.h"
#include <qstylefactory.h>

void JahDesktop::buildInterfaceMenus( QHBox* leftcontroller, QHBox* rightcontroller) 
{

    QStyle *platinum=QStyleFactory::create("platinum");

    //left menu here
    glworldLeft = new QFrame (leftcontroller, "gl left");

    //we are only using these 2 for now but we may use the others later on
    toolthumbview = new JahToolButton( glworldLeft, "thumbview" );
    addJahPlayerButton( toolthumbview, 0, 205, 30, 27 ,    24, 28, JahBasePath+"Pixmaps/desktop/thumbview.png", JahBasePath+"Pixmaps/desktop/thumbview.png" );

    toolbinview =   new JahToolButton( glworldLeft, "binview" );
    addJahPlayerButton( toolbinview,   0, 233, 30, 27 ,    24, 28, JahBasePath+"Pixmaps/desktop/binview.png", JahBasePath+"Pixmaps/desktop/binview.png" );

    //connect tools to object and add object to display widget
    connect( toolthumbview,   SIGNAL(clicked()), this, SLOT(toggleDesktopImages() )  );
    connect( toolbinview,     SIGNAL(clicked()), this, SLOT(toggleDesktopTable() )  );


}


void JahDesktop::addJahPlayerButton( JahToolButton * button, int x1, int y1, int x2, int y2,
                                  int w, int h, QString iconOff, QString iconOn ) 
{

    button->setToggleButton(false);
    //button->setFixedSize(w,h);
    button->setUsesBigPixmap(true);
    button->setGeometry( QRect( x1, y1, x2, y2 ) );

    QIconSet *icoSet;
    icoSet = new QIconSet( QPixmap(iconOff) );
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Large, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Large, QIconSet::Disabled);
    icoSet->setPixmap    ( QPixmap(iconOn), QIconSet::Small, QIconSet::Active);
    icoSet->setPixmap    ( QPixmap(iconOff), QIconSet::Small, QIconSet::Disabled);
    button->setIconSet(*icoSet);
    //delete icoSet;

}







