/*******************************************************************************
**
** The source file for the Jahshaka core avi file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

//#include <MainEncoder.h>

#ifndef CAVIGEN_H
#define CAVIGEN_H

#include <windows.h>
#include <memory.h>
#include <vfw.h>

#include <avi_utils.h>

//the config object
#include "RenderConfig.h"

//the videodata class
#include "videodata.h"

#include <qstring.h>

class CAVIGen
{
public:

 // Inplace constructor with BITMAPINFOHEADER
 CAVIGen(videoData theasset, RenderConfig theconfig, QString &feedback);
 ~CAVIGen();

 BOOL InitEngine();
 BOOL AddFrame(BYTE* bmBits);
 BOOL ReleaseEngine();
 BOOL RenderAviSequence( QString & feedback, videoData &theasset);

//protected:
 char m_sFile[2048];   // name of output file
 DWORD m_dwRate;    // Frame rate
 BITMAPINFOHEADER m_bih;  // structure contains information for a single stream

private:

    QString DestDirectory;        
    QString DestFilename; 
    QString SourceFilename; 
    QString SourceDirectory; 
    QString SourceExtension; 
    int startframe;
    int endframe;

	int destwidth;
	int destheight;

 long        m_lFrame;    // frame counter
 PAVIFILE    m_pAVIFile;  // file interface pointer
 PAVISTREAM  m_pStream;  // Address of the stream interface
 PAVISTREAM  m_pStreamCompressed; // Address of the compressed video stream
};

#endif

