###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../Settings.pro )

###############################################################
# the rest of the makefile settings

TEMPLATE = app
CONFIG +=       qt warn_on release opengl thread

contains( JAHPLAYER,false ) {
TARGET = ../jahshaka
}

contains( JAHPLAYER,true ) {
TARGET = ../jahplayer
}

DEPENDPATH = $$JAHDEPENDPATH

###############################################################
#set up include path for linking

INCLUDEPATH =   Source Core/Objects Core/Render Core/World  . .. \
                desktop

#files for mpeg encoder on linux
contains( JAHMPEGENCODER,true ) {
INCLUDEPATH +=  encoders/mpegenc
}

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
INCLUDEPATH +=  encoders/mpegdec
}

#files for mpeg decoder on linux
contains( SPACEBALL,true ) {
INCLUDEPATH +=  libraries/spaceball
}

INCLUDEPATH +=  libraries \
                libraries/jahtracer \
                libraries/assetobject \
                libraries/imagelibs  \
                libraries/mediaobject  \
                libraries/jahpreferences \
                libraries/jahtranslate \
                libraries/GLCore \
                libraries/glew \
                libraries/jahgift \
                libraries/jahkeyframes \
                libraries/plugins \
                libraries/gpumathlib \
                libraries/jahdatabase \
                libraries/jahplayer/diskplayer \
                libraries/jahplayer/ramplayer \
                uiwidgets/interfaceobjs \
                uiwidgets/timeline \
                uiwidgets/jahfileloader \
                uiwidgets/keyframes \
                uiwidgets/nodes \
                uiwidgets/jahcalc \
                objectlibs/FTGL \
                objectlibs/glmlib \
                objectlibs/blur \
                objectlibs/l3ds \
                objectlibs/particle \
                network \
                network/apollon \
                Modules/animate \
                Modules/glplayer \
                Modules/color \
                Modules/edit \
                Modules/effect \
                Modules/painter \
                Modules/text \
                Modules/encoder \
                player \
                player/ramplayer \
                player/diskplayer

#includes for the audio hack
contains( JAHAUDIO,true ) {
INCLUDEPATH +=	libraries/jahplayer/audioplayer \
                libraries/jahaudio \
                libraries/jahaudio/G72x \
                libraries/jahaudio/GSM610
}

INCLUDEPATH +=	sqlite \
                $$FREEDIR

###############################################################
#set up lib path for linking

LIBS +=         Source/libsource.a \
                Core/World/libworld.a \
                Core/Render/librender.a \
                Core/Objects/libobjects.a

contains( JAHPLAYER,false ) {
LIBS +=         network/libnetwork.a
}

#includes for the audio hack
contains( JAHGIFT,true ) {
LIBS +=         network/apollon/libapollon.a
}

LIBS +=         objectlibs/l3ds/libl3ds.a \
                objectlibs/FTGL/libftgl.a \
                objectlibs/glmlib/libglmlib.a \
                objectlibs/particle/libparticle.a \
                desktop/libdesktop.a \
                libraries/jahdatabase/libjahdatabase.a \
                sqlite/libsqlite.a \
                player/libplayer.a \
                libraries/jahplayer/ramplayer/libramplayer.a \
                libraries/jahplayer/diskplayer/libdiskplayer.a

#includes for the audio hack
contains( JAHAUDIO,true ) {
LIBS +=	        libraries/jahplayer/audioplayer/libaudioplayer.a \
                libraries/jahaudio/libjahaudio.a \
                libraries/jahaudio/G72x/libjahaudiog72.a \
                libraries/jahaudio/GSM610/libjahaudiogGSM.a
}

contains( JAHPLAYER,false ) {
LIBS +=	        Modules/color/libcolor.a \
                Modules/edit/libedit.a \
                Modules/animate/libanimate.a \
                Modules/text/libtext.a \
                Modules/effect/libeffect.a
}

contains( JAHPLAYER,true ) {
LIBS +=	        Modules/glplayer/libglplayer.a
}


LIBS +=         objectlibs/blur/libblur.a

contains( JAHPLAYER,false ) {
LIBS +=         Modules/encoder/librenderdialog.a \
                Modules/painter/libpainter.a
}

LIBS +=         libraries/assetobject/libvideodata.a \
                libraries/imagelibs/libtga.a  \
                libraries/jahkeyframes/libjahkeyframes.a \
                libraries/mediaobject/libmediaobject.a  \
                libraries/jahtracer/libjahtracer.a \
                libraries/jahtimer/libjahtimer.a \
                libraries/jahpreferences/libjahpreferences.a \
                libraries/jahtranslate/libjahtranslate.a \
                libraries/GLCore/libglcore.a \
                libraries/glew/libglew.a

#includes for the audio hack
contains( JAHGIFT,true ) {
LIBS +=         libraries/jahgift/libjahgift.a
}

contains( JAHPLAYER,false ) {
LIBS +=         libraries/jahplugins/libjahplugins.a \
                libraries/gpumathlib/libgpumathlib.a
}


LIBS +=         uiwidgets/interfaceobjs/libinterfaceobjs.a \
                uiwidgets/jahcalc/libjahcalc.a

contains( JAHPLAYER,false ) {
LIBS +=         uiwidgets/keyframes/libkeyframes.a \
                uiwidgets/nodes/libjahnodes.a  \
                uiwidgets/timeline/libjahtimeline.a
}

LIBS +=         uiwidgets/jahfileloader/libjahfileloader.a

#files for mpeg encoder on linux
contains( JAHMPEGENCODER,true ) {
LIBS +=  encoders/mpegenc/libmpegenc.a
}

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
LIBS +=  encoders/mpegdec/libmpegdec.a
}

#files for spaceball on linux
contains( SPACEBALL,true ) {
LIBS +=      libraries/spaceball/libspaceball.a 
}	
                	
LIBS +=  	-lm  -lfreetype -lXi

contains( JAHOS,LINUX ) {
LIBS +=         -lglut -ljpeg 
}

contains( LINUXAVISUPPORT,true ) {
LIBS +=         -laviplay
}

contains( JAHOS,DARWIN ) {
LIBS +=         -framework GLUT -framework OpenGL -lobjc
}
contains( JAHOS,IRIX ) {
LIBS +=         /usr/freeware/lib32/libglut.a  \
                -lm -L/usr/freeware/lib32 -lfreetype
}
