/*******************************************************************************
**
** The header file for the Jahshaka glworld module 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef GLCORE_H
#define GLCORE_H

#include <qimage.h>
#include <qwidget.h>
#include <qgl.h>
#include <qdropsite.h>
#include <qdragobject.h>
#include <qevent.h>

#include <math.h>

#include "jahtracer.h"
#include "jahpreferences.h"


#include <GL/glut.h>

///////////////////////////////////////////
// main class
//class GLCore : public QWidget {
class GLCore : public QGLWidget {
    Q_OBJECT

public:
    
    GLCore( QWidget* parent, const char* name, int mode=0 );    

public slots:
    void initializeGL( void );
    void paintGL( void ) { emit paintit(); } 
    void resizeGL( int w, int h ); 

protected:
    ///////////////////////////////////////////////////////////////
    void dragEnterEvent(QDragEnterEvent* event);
    void dropEvent(QDropEvent* event);

public:

    //set zoom up
    void setZoom(GLfloat zoom);

    //these should all be private
    //size of the render context
    int renderwidth;
    int renderheight;

    bool useimagesize;
    int imagewidth;
    int imageheight;

    //first one is a dupe here
    GLfloat fAspectval;
    GLfloat fAspect;

    //zoom for the main window
    GLfloat zoomVal;
  
    int glmode;

    void	mousePressEvent( QMouseEvent *e );
    void	mouseReleaseEvent( QMouseEvent *e );
    void	mouseMoveEvent( QMouseEvent *e );

signals:

    void paintit(void);
    void resizeit(void);

    void mousePress(QMouseEvent*);
    void mouseRelease(QMouseEvent*);
    void mouseMove(QMouseEvent*);

    void draggedAImage();

private:
  
    //int X_RESOLUTION;
    //int Y_RESOLUTION;

};



#endif // GLWORLD_H




















































