/*******************************************************************************
**
** The header file for the Jahshaka glworld module 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef GLCORE_H
#define GLCORE_H

#include <qimage.h>
#include <qwidget.h>
#include <qgl.h>

#include <math.h>

#include "jahtracer.h"
#include "jahpreferences.h"

#include <GL/glut.h>

extern bool HWFOG;


class JahGLCore : public QGLWidget {
    Q_OBJECT

public:
    
    JahGLCore( QWidget* parent=0, const char* name=0 )
        : QGLWidget( parent, name ) 
    {
    
        //this just sets the format
        QGLFormat format;
        format.setAlpha(TRUE);
        format.setDoubleBuffer(TRUE);
        format.setDepth(TRUE);
        format.setRgba(TRUE);
        format.setAccum(FALSE);
        format.setStereo(FALSE);
        format.setStencil(FALSE);
        format.setDirectRendering( TRUE ); 
        setFormat(format); 
    
    };
        
    //the opengl functions we had to override
    void resizeGL( int w, int h )
    {
        gw=w; gh=h;
        emit resize();
    };

    void initializeGL( void ) { emit initialize(); };
    void paintGL( void )      { emit paint(); } 

signals:
    void paint(void);
    void initialize(void);
    void resize(void);

public:
    int gw;
    int gh;

};

///////////////////////////////////////////
// main class
class GLCore : public QWidget {
//class GLCore : public QGLWidget {
    Q_OBJECT

public:
    
///    GLCore( QWidget* parent, const char* name );
    GLCore( QWidget* parent, const char* name, QWidget* module, const QGLWidget* shareWidget=0 );
    //~GLCore();
    
    static void initCore( void );
    
    void resizeGL( int w, int h ); 

public slots:
    void initializeGL( void );
    void resize( void );

public:
    void makeCurrent( void );
    void updateGL( void );
    QImage grabFrameBuffer(bool val=0);

    void paintGL( void ) { debug(" tha paint"); emit paintit(); } 


    //set zoom up
    void setZoom(GLfloat zoom);

    //these should all be private
    //size of the render context
    int renderwidth;
    int renderheight;

    bool useimagesize;
    int imagewidth;
    int imageheight;

    //first one is a dupe here
    GLfloat fAspectval;
    GLfloat fAspect;

    //zoom for the main window
    GLfloat zoomVal;
  
signals:

    void paintit(void);

private:
  
    int X_RESOLUTION;
    int Y_RESOLUTION;

    JahGLCore*    jahCore;
    
    //this is starting to work :)
    //static JahGLCore*    jahCore;
};



#endif // GLWORLD_H




















































