/*******************************************************************************
**
** The header file for the Jahshaka assetexchange object
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef ASSETEXCHANGE_H
#define ASSETEXCHANGE_H

#include "jahtracer.h"
#include "jahpreferences.h"

#include "qstring.h"
#include "qimage.h"
#include "qfile.h"
#include "qdir.h"

#include "videodata.h"

#include "mediaobject.h"

#ifdef AUDIOSUPPORT
#include "sndfile.h"
#endif

class videoData;

/////////////////////////////////////////////////////////////
// need a lot of cleaning up here!

class assetExchange
{
    public:

        //constructor and destructor
        assetExchange(void);
        ~assetExchange(void);


        //used to see if a mediaobject is valid (on disk)
        bool   isMediaValid(videoData &theasset);

        //media access routines
        bool   getMediaFilename(videoData &theasset, int frame, QString &returnName);
        bool   getMediaLength(videoData &theasset, int &frame);
        QImage getImage(videoData &theasset, int frame=1);
        QString getsequencefilename( videoData &theasset, int frame );

        //for streaming we keep the media objects state open and share it with the routines
        //we are missing a open stream and close strem - maybe put a close in the destructor?
        QImage getStreamImage(videoData &theasset, int frame=1);

        bool   streamMediaintoimage( const QString loadfilename,  QImage & image, int frame);

        //utility routines used to package and export assets
        void ExportAsset(videoData &asset, QString destination);

    private:

        QString JahBasePath;
        //QString filename;

        //internal utility routines
        bool   loadFileintoimage( const QString loadfilename, QImage & image);
        bool   loadMediaintoimage( const QString loadfilename, QImage & image, int frame);

        //we dont initialize this unless we are streaming...
        mediaData * openStream;

        bool streamOpen;

        //copy utility used by ExportAsset
        bool copyFile( const QString oldFilePath, const QString newFilePath);

};

#endif






