/*******************************************************************************
**
** The header file for the Jahshaka videodata file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/


#ifndef VIDEODATA_H
#define VIDEODATA_H

#include "qstring.h"
#include "qimage.h"
#include "qfile.h"

#ifdef AUDIOSUPPORT
#include "sndfile.h"
#endif

#include "mediaobject.h"
#include "assetexchange.h"

//#include "jahpreferences.h"

enum VideoCategory     { IMAGE, KEY, CLIP, CLIPKEY, AUDIO, MEDIA, NOCATEGORY };

enum VideoType         { STILL, SEQUENCE, MOVIE, AVI, MPEG, MP3, AIFF, NOTYPE };


//asset grows up and becomes a object
class videoData
{
public:
    videoData(void) 
    {
        //set up deafults
        startframe  = 0;
        endframe    = 0;
        clipinframe = 0;
        clipoutframe= 0;
        xpos        = 0;
        ypos        = 0;
        clipnumber  =-1;

        clipname = "";

		theCategory = NOCATEGORY;
		theType = NOTYPE;
    };

    ~videoData(void) {};

    //category informaiton
    VideoCategory theCategory;
    VideoType     theType;

    //for the clip
    QString     clipname;
    int         clipnumber;

    QString     location,filename;
    QString     extension;
    int         startframe, endframe;
    int         clipinframe, clipoutframe;
    bool        videotex;
    QString	    videoext;
   
    //desktop position data
    double      xpos;
    double      ypos;

    //other routines
    int         getNumFrames(void);
    QString     getFullFileName();
    int         getMaxFrames();


};


//we store clip size data in here as well for easy access
struct mediaSize
{
    int         width;
    int         height;
};

#ifdef AUDIOSUPPORT
struct AudioData
{
	QString clipname;
	QString filename;
	SNDFILE* sndfile_handle;
	SF_INFO file_info;
	unsigned long file_lenght;
};
#endif


#endif






