###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE = lib
CONFIG		+= staticlib qt warn_on release opengl thread
HEADERS		=   au.h            common.h        config.h \
                float_cast.h    sfendian.h      sf_unistd.h \
                sndfile.h       wav_w64.h


SOURCES     +=  aiff.c          alaw.c          au.c \
                au_g72x.c       avr.c           command.c       common.c \
                dither.c        double64.c      dwd.c \
                dwvw.c          file_io.c       float32.c \
                gsm610.c        htk.c           ima_adpcm.c \
                interleave.c    ircam.c         mat4.c \
                mat5.c          ms_adpcm.c      nist.c \
                ogg.c           paf.c           pcm.c \
                pvf.c           raw.c           rx2.c \
                sd2.c           sds.c           sfendian.c \
                sndfile.c       strings.c       svx.c \
                txw.c           ulaw.c          voc.c \
                vox_adpcm.c     w64.c           wav.c \
                wav_w64.c       wve.c           xi.c


TARGET = jahaudio
DEPENDPATH = $$JAHDEPENDPATH

###############################################################
#the project related includes particle
INCLUDEPATH =           . .. ../../Source \
                        ../../Core/Objects ../../Core/Render ../../Core/World  \
                        ../../desktop
            

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
INCLUDEPATH +=          ../../encoders/mpegdec
}

#files for mpeg encoder on linux
contains( JAHMPEGENCODER,true ) {
INCLUDEPATH +=          ../../encoders/mpegenc
}

#files for mpeg decoder on linux
contains( SPACEBALL,true ) {
INCLUDEPATH +=          ../../libraries/spaceball
}

INCLUDEPATH +=          ../../libraries \
                        ../../libraries/jahaudio ../../libraries/jahaudio/G72x ../../libraries/jahaudio/GSM610

contains( JAHOS,IRIX ) {
INCLUDEPATH +=          $$SGIDIR
}
			

