/*******************************************************************************
**
** The header file for the Jahshaka jahcalc module 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef JAHDATABASE
#define JAHDATABASE

#include <qstring.h>

#include <qmessagebox.h>
#include <qwidgetstack.h>
#include <qtable.h>
#include <qdropsite.h>

#include <videodata.h>
#include "jahtracer.h"

#include "sqlite.h"
struct sqlite;

class JahDatabase
{

public:
    JahDatabase(const char* name);
    ~JahDatabase();


    ////////////////////////////////////////////////////////
    //Initialize and Open the database

    void InitializeDatabase(void);
    void CloseDatabase(int clipnum);

    int  TestDatabase(void);
    bool WipeDatabase(void);

    void updateClipPosition(videoData data);

    int OpenDesktopTable();

    int GetDatabaseClipNumber();

    void addImage2database( videoData thedata );

    void removeImagefromdatabase( int imagenumber );
    void deleteImagefromdatabase( int imagenumber );
    void renameImageindatabase( int imagenumber, QString newname);

    videoData getImageFromDatabase(int clipnumber);
    bool doesAssetExistindatabase(int clipnum);

    videoData restoreImageFromDatabase(int clipnumber);

    void purgeDatabase( int imagenumber );

    //int *clipnumber;

private:

    /////////////////////////////////////////////////
    //the embedded database
    sqlite*         db;

    QString JahBasePath;
    QString JahMediaPath;


};

#endif // FORM1_H
