/*******************************************************************************
**
** The header file for the Jahshaka jahpreferences module 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef JAHKEYFRAMEOBJECT_H
#define JAHKEYFRAMEOBJECT_H

/////////////////////////////////////////////////////////
//core keyframe structure

#include "jahkeyframes.h"
#include "qptrlist.h"
#include "jahtracer.h"

////////////////////////////////////////////////////////////
// the main layer object class

class JahKeyframeObject 
{

public:
    JahKeyframeObject(void);

    ~JahKeyframeObject(void);

    //////////////////////////////////////////////
    //keyframe routines
    void printInfo(void);
    void addNodes(int currentFrame, motionNode * newNode);
    void removeNodes(int currentFrame);
	int  getPrevFrame(int currentFrame);
    int  getNextFrame(int currentFrame); 

    bool doesKeyframeExist(int theFrame);
    int  getKeyframe(int theFrame);
	
    void sortNodes(void);
    void clear(void);

    void swap(int &x, int &y);

    void updateNodes(int currentFrame);  //gets interpolation

    void getFirstLastFrame( int *firstFrame, int *lastFrame);

    int  getNode(int frameNumber, motionNode *mn);

    void getLinearInterpolation(motionNode *mn,int nn,int pn,int a, int frameNumber);

    void reset(void);
    
public:

    //make these private and add routines to access them...

      //for keyframes
    int  numnodes;

    //the current node
    motionNode  *node;
    
    //for the linked list for dynamic keyframes
    QPtrList<motionNode> *nodelist;

};



#endif

