/*******************************************************************************
**
** The header file for the Jahshaka player JahPlayer file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
** Based on * flip - pageflipper for TIFF animations
** Copyright (C) 1999 Mark B. Allan (mba@reptilelabour.com)
**
** in the process of being rewritten
**
*******************************************************************************/

//why not just send videodata obj over?

//we need to work on the mediaObject directly here
//instead of using the asset exchange
//since the exchange only grabs

#ifndef JahPlayer_h
#define JahPlayer_h

#include <qlabel.h>
#include <qfile.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <qstring.h>
#include <qdialog.h>
#include <qwmatrix.h>
#include <qmessagebox.h>

#include <qdropsite.h>
#include <qdragobject.h>

#include "videodata.h"

#include "jahtracer.h"


class JahPlayer	: public QWidget
{
	Q_OBJECT

public:
	JahPlayer(QWidget *parent = 0, const char* name = 0);
	~JahPlayer();
    
    //the asset to be loaded in the player
    videoData playerAssetData;
    assetExchange * exchange;
    bool assetdefined;
    
    //video head preferences
    bool videohead;

	//int	LoadImages(QString filename, int maxFrames = 10000, int z = 1);
	int	LoadImages(videoData & desktopclip);
	//int	LoadImages(const char* filename, int maxFrames = 10000, int z = 1);
	//void	GetImages( QImage, int maxFrames = 1, int z = 1);
	
	inline int	GetNumFrames()	{	return numFrames;	}
	inline int	GetMaxFrames()	{	return maxFrames;	}
	inline int	GetWidth()		{	return (int)width;	}
	inline int	GetHeight()		{	return (int)height;	}
	inline bool	isLoading()		{	return timer.isActive();	}
	
	inline int	getFileHeight()	{	return origHeight;	}
	inline int	getFileWidth()	{	return origWidth;	}
	inline QString	getExtension()	{	return dotTif;	}
	
	inline int getOrigWidth()	{ return origWidth; }
	inline int getOrigHeight()	{ return origHeight; }
	inline const char *getBaseString()	{ return baseString; }
	
	inline void setCurMinFrame(int in)	{	curMinFrame = in; }
	inline void setCurMaxFrame(int in)	{	curMaxFrame = in; }
	inline int getCurMinFrame()	{	return curMinFrame; }
	inline int getCurMaxFrame()	{	return curMaxFrame; }
	
	void	Reset();
	void	SetDisplayZoom(double);
	
	bool	checkMem();
	bool	getMemUsage(float* mem, float* swap);
	
	void	showMemInfo(bool status);
	
public slots:
	void	SetFrame (int);
    void	LoadTheFrame(int frame);
	
signals:
	void	Done(int, bool);
	void	LoadingFrame(int);
	void    resizePlayer(mediaSize);
	void	updateplayer2(QPixmap);

    void    draggedAImage();


protected:
	void	drawPixmap();
	void	paintEvent(QPaintEvent * );
	void	LoadSingleImage();
	void	OutOfMemory();

    ///////////////////////////////////////////////////////////////
    void dragEnterEvent(QDragEnterEvent* event);
    void dropEvent(QDropEvent* event);

private:
	QWMatrix	m;
	int		loadZoom;
	float		displayZoom;

	QTimer	timer;
	QPixmap	*pixlist;
	int		frame;
	int		numFrames;
	int		maxFrames;
	
	int		loadFrame;
	int		lastFrame;
	int		startFrame;
  int   slen;
	QString	baseString;
	QString dotTif;
	
	
	uint	width;
	uint	height;
	uint	origWidth;
	uint	origHeight;
	int		curMinFrame;
	int		curMaxFrame;
	
	int		flipPID;
	bool	doMemCheck;
	float	begSwap;
	float	begMem;
	float	curSwap;
	float	curMem;
	float	swapThresh;
	QLabel	*memLabel;
	QLabel	*swapLabel;
	QString	memString;
	QString swapString;
};


#endif // JahPlayer_h
