/*******************************************************************************
**
** The header file for the Jahshaka jahpreferences object 
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

//#include <iostream>

#include "jahpreferences.h"

/////////////////////////////////////////////////////////////////////
//we should make this routine save the prefs and load the prefs in 
//to make things a bit cleane rmon

JahPrefs JahPrefs::_instance ;

JahPrefs::JahPrefs() 
    throw()
{   
    //these dont actually need to be initialized   
    BasePath            = "invalid";
    MediaPath           = "invalid";

    JahRenderQuality    = 2;          //default is BMP
    JahRenderer         = 0;          //default is HARDREN

    //these guys default to software till we see if the new
    //hardware renderer works - it should its 1
#ifdef JAHIRIX
    JahRenderer = 2;
#endif

#ifdef JAHDARWIN
    JahRenderer = 2;
#endif

	////////////////////////////////////////
	// default resolution on startup
    //XResolution         = 720;  //default to CCIR601 SDI
    //YResolution         = 486;    
	//Ratio               = "4:3";

	//this becomes
	jahResolution = 3;		//default to D1 NTSC

	////////////////////////////////////////
	// ui settings
    dualHead            = false;
    wideScreen          = false;
    videoHead           = false;
    videoHeadX          = 0;
    videoHeadY          = 0;

	#ifndef JAHPLAYER
    rememberGeometry    = false;
	#else
    rememberGeometry    = true;
	#endif
    
	XPos                = 0;    
    YPos                = 0;     
    JahWidth            = 1024;
    JahHeight           = 768;

    XPos2                = 0;    
    YPos2                = 0;     
    JahWidth2            = 1024;
    JahHeight2           = 768;

    HwFog               = false;
    HwAliasing          = false;
    vertexshaders       = false;
    gpusupport          = false;
    nv_gpusupport       = false;

    foundPrefs          = FALSE;

    language            = "English";

    jahstyle            = FALSE;
    themestyle          = 0;
    themecolor          = 0;

	//for the jahnet server
	autoLaunchserver	= FALSE;

}

JahPrefs::~JahPrefs() 
    throw()
{

}

JahPrefs& JahPrefs::getInstance()
    throw()
{
    return (_instance);
}

void JahPrefs::savePreferences(void)
    throw()
{
    //debug( "Storing the global preferences" );

    QSettings settings;
    #ifndef __sgi
	#ifndef JAHPLAYER
    settings.setPath( "jahshaka.com", "jahshaka" );
	#else
    settings.setPath( "jahplayer.com", "jahplayer" );
	#endif
	#endif

    settings.writeEntry( "/recent files/1",     MediaPath );

    settings.writeEntry( "/recent files/2",     JahRenderQuality );
    settings.writeEntry( "/recent files/3",     rememberGeometry );
    settings.writeEntry( "/recent files/4",     dualHead );

    settings.writeEntry( "/recent files/5",     videoHead );

    settings.writeEntry( "/recent files/6",     jahstyle );

    settings.writeEntry( "/recent files/7",     jahResolution );

    settings.writeEntry( "/recent files/8",     menuBars );

    //the theme
    settings.writeEntry( "/recent files/9",     themestyle );
    settings.writeEntry( "/recent files/10",    themecolor );

    settings.writeEntry( "/recent files/11",    language );
    settings.writeEntry( "/recent files/12",    wideScreen );
    settings.writeEntry( "/recent files/13",    autoLaunchserver );
    settings.writeEntry( "/recent files/14",    JahVersion );


    //application geometry
    settings.writeEntry( "/geometry/x",         XPos );
    settings.writeEntry( "/geometry/y",         YPos );
    settings.writeEntry( "/geometry/width",     JahWidth );
    settings.writeEntry( "/geometry/height",    JahHeight );

    //dualhead geometry
    settings.writeEntry( "/geometry/x2",         XPos2 );
    settings.writeEntry( "/geometry/y2",         YPos2 );
    settings.writeEntry( "/geometry/width2",     JahWidth2 );
    settings.writeEntry( "/geometry/height2",    JahHeight2 );

    //videohead geometry
    settings.writeEntry( "/geometry/x3",     videoHeadX );
    settings.writeEntry( "/geometry/y3",     videoHeadY );


}

void JahPrefs::saveVideoheadPreferences(void)
    throw()
{
//    debug( "Storing the global preferences" );

    QSettings settings;
    #ifndef __sgi
	#ifndef JAHPLAYER
    settings.setPath( "jahshaka.com", "jahshaka" );
	#else
    settings.setPath( "jahplayer.com", "jahplayer" );
	#endif
	#endif

    settings.writeEntry( "/geometry/x3",     videoHeadX );
    settings.writeEntry( "/geometry/y3",     videoHeadY );


}

void JahPrefs::loadPreferences(void)
    throw()
{

    //debug( "loading the global preferences" );
    bool itworked;

    QSettings settings;
    #ifndef __sgi
	#ifndef JAHPLAYER
    settings.setPath( "jahshaka.com", "jahshaka" );
	#else
    settings.setPath( "jahplayer.com", "jahplayer" );
	#endif
	#endif

    int intval   = 0;
    bool boolval = 0;
    QString strval;

    strval   = settings.readEntry    ( "/recent files/1", strval, &itworked );
    if (itworked) MediaPath = strval;

    intval   = settings.readNumEntry ( "/recent files/2", intval, &itworked );
    if (itworked) JahRenderQuality = intval;

    boolval  = settings.readBoolEntry( "/recent files/3", boolval, &itworked );
    if (itworked) rememberGeometry = boolval;

    boolval  = settings.readBoolEntry( "/recent files/4", boolval, &itworked );
    if (itworked) dualHead = boolval;

    boolval  = settings.readBoolEntry( "/recent files/5", boolval, &itworked );
    if (itworked) videoHead = boolval;

    ///////////////////////////////////////////////////////////////////////////
    //we can use these to save the style...

    boolval   = settings.readBoolEntry ( "/recent files/6", boolval, &itworked );
    if (itworked) jahstyle = boolval;

    intval   = settings.readNumEntry ( "/recent files/7", intval, &itworked );
    if (itworked) jahResolution = intval;

    boolval  = settings.readBoolEntry( "/recent files/8", boolval, &itworked );
    if (itworked) menuBars = boolval;

    intval   = settings.readNumEntry ( "/recent files/9", intval, &itworked );
    if (itworked) themestyle = intval;

    intval   = settings.readNumEntry ( "/recent files/10", intval, &itworked );
    if (itworked) themecolor = intval;

    strval   = settings.readEntry ( "/recent files/11", strval, &itworked );
    if (itworked) language = strval;

    boolval   = settings.readBoolEntry ( "/recent files/12", boolval, &itworked );
    if (itworked) wideScreen = boolval;

    boolval   = settings.readBoolEntry ( "/recent files/13", boolval, &itworked );
    if (itworked) autoLaunchserver = boolval;


    //now we do the geometry settings

    intval   = settings.readNumEntry ( "/geometry/x", intval, &itworked );
    if (itworked) XPos = intval;

    intval   = settings.readNumEntry ( "/geometry/y", intval, &itworked );
    if (itworked) YPos = intval;

    intval   = settings.readNumEntry ( "/geometry/width", intval, &itworked );
    if (itworked) JahWidth = intval;

    intval   = settings.readNumEntry ( "/geometry/height", intval, &itworked );
    if (itworked) JahHeight = intval;

    //for dualhead
    intval   = settings.readNumEntry ( "/geometry/x2", intval, &itworked );
    if (itworked) XPos2 = intval;

    intval   = settings.readNumEntry ( "/geometry/y2", intval, &itworked );
    if (itworked) YPos2 = intval;

    intval   = settings.readNumEntry ( "/geometry/width2", intval, &itworked );
    if (itworked) JahWidth2 = intval;

    intval   = settings.readNumEntry ( "/geometry/height2", intval, &itworked );
    if (itworked) JahHeight2 = intval;

    //for videohead
    intval   = settings.readNumEntry ( "/geometry/x3", intval, &itworked );
    if (itworked) videoHeadX = intval;

    intval   = settings.readNumEntry ( "/geometry/y3", intval, &itworked );
    if (itworked) videoHeadY = intval;

    //if it didnt work then we didnt find the preferences
    foundPrefs = true;

}

void JahPrefs::checkVersion(void)
    throw()
{

    //debug( "loading the global preferences" );
    bool itworked;

    QSettings settings;
    #ifndef __sgi
	#ifndef JAHPLAYER
    settings.setPath( "jahshaka.com", "jahshaka" );
	#else
    settings.setPath( "jahplayer.com", "jahplayer" );
	#endif
	#endif

    int intval   = 0;
    bool boolval = 0;
    QString strval;

    strval   = settings.readEntry    ( "/recent files/14", strval, &itworked );
    if (itworked) MediaPath = strval;

	//if we didnt find the version then the prefs are old
	//and need to be updated before moving ahead
	if ((!itworked) || (strval!=JahVersion))
	{
		savePreferences();
	}
	else
	{
		debug("preferences are ok...");
	}
}

/////////////////////////////////////////////////////////////////
//routines to set data start here

void JahPrefs::setJahVersion(QString jahver)  { JahVersion       = jahver; }

void JahPrefs::setJahResolution(int xres)   { jahResolution         = xres;  }
//void JahPrefs::setXRes(int xres)          { XResolution         = xres;  }
//void JahPrefs::setYRes(int yres)          { YResolution         = yres;  }
//void JahPrefs::setRatio(QString ratio)    { Ratio               = ratio; }

void JahPrefs::setBasePath(QString path)  { BasePath            =  path; }
void JahPrefs::setMediaPath(QString path) { MediaPath           =  path; }

void JahPrefs::setMenubars(bool value)    { menuBars            = value; }
void JahPrefs::setDualhead(bool value)    { dualHead            = value; }
void JahPrefs::setWidescreen(bool value)  { wideScreen          = value; }

void JahPrefs::setThemestyle(int  value)  { themestyle          = value; }
void JahPrefs::setThemecolor(int  value)  { themecolor          = value; }

void JahPrefs::setVideohead(bool value)   { videoHead           = value; }
void JahPrefs::setVideoheadX(int  value)  { videoHeadX          = value; }
void JahPrefs::setVideoheadY(int  value)  { videoHeadY          = value; }

void JahPrefs::setRememberGeometry(bool value)    { rememberGeometry    = value; }
void JahPrefs::setGeometryX(int value)    { XPos                = value; }
void JahPrefs::setGeometryY(int value)    { YPos                = value; }
void JahPrefs::setGeometryWidth(int value)  { JahWidth          = value; }
void JahPrefs::setGeometryHeight(int value) { JahHeight         = value; }

void JahPrefs::setGeometryX2(int value)    { XPos2                = value; }
void JahPrefs::setGeometryY2(int value)    { YPos2                = value; }
void JahPrefs::setGeometryWidth2(int value)  { JahWidth2          = value; }
void JahPrefs::setGeometryHeight2(int value) { JahHeight2         = value; }

void JahPrefs::setLanguage(QString value) { language            = value; }

void JahPrefs::setHwFog(bool value)       { HwFog               = value; }
void JahPrefs::setHwAliasing(bool value)  { HwAliasing          = value; }
void JahPrefs::setVShading(bool value)    { vertexshaders       = value; }
void JahPrefs::setGpusupport(bool value)  { gpusupport          = value; }
void JahPrefs::setNVGpusupport(bool value){ nv_gpusupport       = value; }

void JahPrefs::setMaxVertexInstructionsARB(int value) { max_vertex_program_instructions_ARB = value; }
void JahPrefs::setMaxFragmentInstructionsARB(int value) { max_fragment_program_instructions_ARB = value; }

void JahPrefs::setRenderer(int value)     { JahRenderer         = value; }
void JahPrefs::setRenderQuality(int value) { JahRenderQuality   = value; }

void JahPrefs::setStyle(bool value)        { jahstyle = value; }
void JahPrefs::setStyleTheme(int value)    { themestyle = value; }
void JahPrefs::setStyleColor(int value)    { themecolor = value; }

void JahPrefs::setAutoLaunchServer(bool value)    { autoLaunchserver = value; }

/////////////////////////////////////////////////////////////////
//routines to get data start here

bool JahPrefs::getFoundPrefs(void)      { return foundPrefs;  }

QString JahPrefs::getJahVersion(void)   { return JahVersion;  }

int JahPrefs::getJahResolution(void)    { return jahResolution; }
//int JahPrefs::getXRes(void)             { return XResolution; }
//int JahPrefs::getYRes(void)             { return YResolution; }
//QString JahPrefs::getRatio(void)        { return Ratio;       }

QString JahPrefs::getBasePath(void)     { return BasePath;    }
QString JahPrefs::getMediaPath(void)    { return MediaPath;   }

bool JahPrefs::getMenubars(void)        { return menuBars;    }
bool JahPrefs::getDualhead(void)        { return dualHead;    }
bool JahPrefs::getWidescreen(void)      { return wideScreen;  }

int  JahPrefs::getThemestyle(void)      { return themestyle;  }
int  JahPrefs::getThemecolor(void)      { return themecolor;  }

bool JahPrefs::getVideohead(void)       { return videoHead;   }
int  JahPrefs::getVideoheadX(void)      { return videoHeadX;  }
int  JahPrefs::getVideoheadY(void)      { return videoHeadY;  }

bool JahPrefs::getRememberGeometry(void) { return rememberGeometry; }
int  JahPrefs::getGeometryX(void)       { return XPos;        }
int  JahPrefs::getGeometryY(void)       { return YPos;        }
int  JahPrefs::getGeometryWidth(void)   { return JahWidth;    }
int  JahPrefs::getGeometryHeight(void)  { return JahHeight;   }

int  JahPrefs::getGeometryX2(void)      { return XPos2;       }
int  JahPrefs::getGeometryY2(void)      { return YPos2;       }
int  JahPrefs::getGeometryWidth2(void)  { return JahWidth2;   }
int  JahPrefs::getGeometryHeight2(void) { return JahHeight2;  }

QString JahPrefs::getLanguage(void)        { return language;    }

bool JahPrefs::getHwFog(void)           { return HwFog;       }
bool JahPrefs::getHwAliasing(void)      { return HwAliasing;  }
bool JahPrefs::getVShading(void)        { return vertexshaders; }
bool JahPrefs::getGpusupport(void)      { return gpusupport;  }
bool JahPrefs::getNVGpusupport(void)    { return nv_gpusupport; }

int  JahPrefs::getMaxVertexInstructionsARB(void) { return max_vertex_program_instructions_ARB; }
int  JahPrefs::getMaxFragmentInstructionsARB(void) { return max_fragment_program_instructions_ARB; }

int  JahPrefs::getRenderer(void)        { return JahRenderer; }
int  JahPrefs::getRenderQuality(void)   { return JahRenderQuality; }

bool JahPrefs::getStyle(void)           { return jahstyle; }
int  JahPrefs::getStyleTheme(void)      { return themestyle; }
int  JahPrefs::getStyleColor(void)      { return themecolor; }

bool  JahPrefs::getAutoLaunchServer(void)      { return autoLaunchserver; }


