/*******************************************************************************
**
** The source file for the Jahshaka network server module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#include "httpd.h"



///////////////////////////////////////////////////////////
//this routes us to the correct routine based on the port
//data is coming in on... 4242 is conversation data
//and 4243 is media data

void ClientSocket::readClient()
{

   if (servport==4242)
   {
    readClientData();
   }
   else if (servport=4243)
   {
    readClientMedia();
   }

}

void ClientSocket::readClientData()        //sends this back to the client...
{

    //////////////////////////////////////////////////////
    //this is for text only conversations

    debug("TEXT SERVER receiving data");

    QString echotext,temp,temp2;

    QTextStream os( this );

    while ( canReadLine() )
    {
        echotext = temp.setNum(line) + " : " + readLine();
        emit sendtext(echotext);
        line++;
    };

    //emit sendtext("coming from the server");
    //emit sendtext(echotext);

}

void ClientSocket::readClientMedia()        //sends this back to the client...
{

    debug("MEDIA SERVER receiving data");

    //////////////////////////////////////////////////////
    //if text header hasnt been sent yet

    if (senttext==false)
    {

        //create the videodata object
        datafile = new videoData;
        QString read,conv;
        QTextStream os( this );

        //enum VideoCategory     { IMAGE, KEY, CLIP, CLIPKEY };
        //enum VideoType         { STILL, SEQUENCE, QUICKTIME, AVI, MPEG };

        debug(">>>reading header<<<");
        read=readLine(); read=read.stripWhiteSpace(); datafile->clipname   = read;
        read=readLine(); read=read.stripWhiteSpace(); datafile->clipnumber = read.toInt();
        read=readLine(); read=read.stripWhiteSpace(); datafile->filename   = read;
        read=readLine(); read=read.stripWhiteSpace(); datafile->location   = JahMediaPath + "media/share/"; //this would be jahpath+share...
        read=readLine(); read=read.stripWhiteSpace(); datafile->extension  = read;
        read=readLine(); read=read.stripWhiteSpace(); //datafile->videoext   = read;

        //we actually need to get this value from the local desktop not the clients...
        read=readLine(); read=read.stripWhiteSpace(); // int thenum = read.toInt(); datafile->clipnumber = thenum++; // this is currentframe datafile->startframe = read.toInt();

        read=readLine(); read=read.stripWhiteSpace(); datafile->startframe = read.toInt();
        read=readLine(); read=read.stripWhiteSpace(); datafile->endframe   = read.toInt(); //should be 1

        read=readLine(); read=read.stripWhiteSpace(); datafile->theType     = STILL;
        read=readLine(); read=read.stripWhiteSpace(); datafile->theCategory = IMAGE;
        //while ( canReadLine() ) {readLine();}
        datafile->xpos       = 5;
        datafile->ypos       = 5;

        senttext=true;

    }

    debug(">>>finished reading header<<<");

    //////////////////////////////////////////////////////
    //if image hasnt been sent yet first pass
    if (sentdata==false)
    {
        debug("Clipname:"+datafile->clipname);
        debug("Filename:"+datafile->filename);
        debug("location:"+datafile->location);
        debug("extension:"+datafile->extension);
        debug("JahPath:"+JahMediaPath);

        QString clipname =  JahMediaPath + "media/share/" + datafile->filename + datafile->extension;

        debug("Clipname:"+clipname);

        debug("receiving media image data");
        //thisis the first time so we can read in teh image size here and set flags for the next time around...
        //by reading in the buffer size
        //and comparing it to the size of the image we know how many passes its gonna take

        Q_ULONG buff; buff=this->bytesAvailable();
        QString rere; rere.setNum(buff);
        debug("The buffer size before is:"+rere);

        //check if the tempfile exists on first pass and if so erase it
        QFile file( clipname );

        if ( QFile::exists( clipname ) ) { file.remove(); }

        file.open( IO_WriteOnly );

        int x=0; QString debugdata;

        while( this->bytesAvailable() ) { x++; file.putch(this->getch()); }

        file.close();
        emit sendtext("finito...");
        debug(">>finished reading"+debugdata.setNum(x));


        sentdata=true;
        return;
    }

    //////////////////////////////////////////////////////////
    //means we are back here again since the buffer couldnt send everything
    //and we need to keep writing data to the file

    debug("receiving more media image data...");

    QString clipname =  JahMediaPath + "media/share/" + datafile->filename + datafile->extension;

    debug("Clipname:"+clipname);

    QFile file( clipname );

    file.open( IO_WriteOnly | IO_Append );

    int x=0; QString debugdata;

    while( this->bytesAvailable() ) { x++; file.putch(this->getch()); }

    file.close();
    emit sendtext("finito...");
    debug(">>finished reading"+debugdata.setNum(x));

    Q_ULONG buffy; buffy=this->bytesAvailable();
    QString rerey; rerey.setNum(buffy);
    debug("The buffer size is:"+rerey);
}

void ClientSocket::connectionClosed()
{
    debug("we are closing the connection");

    //ok if it was port 4243 then they sent a media clip so we can add it to the desktop now!
    //though we should really debug the mofo first
    QString text; debug("closing Connection on port :" + text.setNum(servport));
    if (servport==4243)
    {
        //datafile->printinfo();
        emit updateDesktop(*datafile);
    }

    delete this;
}

/////////////////////////////////////////////////////////////
//This is the main server connection code
//it creates a new ClientSocket for each connect and that
//instance is now responsible for the communication with that client.

void SimpleServer::newConnection( int socket )
{
  int portnum = portnumber;

  ClientSocket * thesock = new ClientSocket( socket, this, portnum );

  //(void)new ClientSocket( socket, this, portnum );

  QString text; text = "Incoming Connection on socket :" + text.setNum(socket);
  emit copyText(text); debug(text);

  //if this is a connection on socket 4242 we shopuld first check
  //to see if we are connect back to them and
  //if not emit a recirocating connection...
  //now how do we find out if we have a connection to that ip?
  //this is important so we dont get stuck in a loop between clients

  //first lets find out the ip address...
  //address = new QHostAddress(thesock->peerAddress());



  QString name = thesock->peerName();
  debug("Incoming Connection on name :" + name);

  //note that portnum holds last incomming connection port number
  Q_UINT16 thaport = thesock->peerPort();
  debug("Incoming Connection on port :" + text.setNum((int)thaport));
  debug("Incoming Connection on port :" + text.setNum(portnumber));

  //CChatSocket *currentSocket = (CChatSocket *)sender();

  //this is not socket stupid, its the port...
  //if (socket==4242)  { emit recipConnect(thesock->peerAddress()); }
  emit recipConnect(thesock->peerAddress());

}

void SimpleServer::socketText( QString text)
{
    emit copyText(text);
}

void SimpleServer::socketUpdateDesktop( videoData datafile)
{

  debug("passing on videoData from socket close");

  //datafile.printinfo();

  emit sendupdateDesktop(datafile);
}


int SimpleServer::lastPortNum( void)
{
    return portnumber;
}

