/*******************************************************************************
**
** The source file for the Jahshaka network client module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#include "networking.h"


void JahNet::createNewClient() 
{
	if (!serverLaunched)
		launchServer();

	//we create the chat client here on port 4242
	socket = new QSocket( this );

	connect( socket, SIGNAL(connected()), this, SLOT(socketConnected()) );
	connect( socket, SIGNAL(connectionClosed()), SLOT(socketConnectionClosed()) );
	connect( socket, SIGNAL(readyRead()), SLOT(socketReadyRead()) );
	connect( socket, SIGNAL(error(int)), SLOT(socketError(int)) );

	// connect to the server
	//infoText->append( tr("Trying to connect to the server\n") );

	//get hostname from fields here
	QString hostname = serveredit->text() ;
	debug("host :" + hostname);

	socket->connectToHost( hostname, 4242 );

}                    //QHostAddress addy


void JahNet::createNewClient(QHostAddress addy) {

	//we create the chat client here on port 4242
	if (socket) { debug("already a socket..."); return; }
	if ( (socket->isOpen() ) && ( socket->state() != QSocket::Connecting) ) { debug("already connected"); return; }


	//we create the chat client here on port 4242
	socket = new QSocket( this );

	connect( socket, SIGNAL(connected()), this, SLOT(socketConnected()) );
	connect( socket, SIGNAL(connectionClosed()), SLOT(socketConnectionClosed()) );
	connect( socket, SIGNAL(readyRead()), SLOT(socketReadyRead()) );
	connect( socket, SIGNAL(error(int)), SLOT(socketError(int)) );

	// connect to the server
	//infoText->append( tr("Trying to connect to the server\n") );

	//get hostname from fields here
	QString hostname = serveredit->text() ;
	debug("host :" + hostname);

	socket->connectToHost( hostname, 4242 );

}



void JahNet::closeConnection() {

  socket->close();

  if ( socket->state() == QSocket::Closing ) {
    // We have a delayed close.
    connect( socket, SIGNAL(delayedCloseFinished()), SLOT(socketClosed()) );
  } else {
    // The socket is closed.
    socketClosed();
	}

}

void JahNet::sendToServer() {


    //copy text to screen first
    clienttextfeedback->append(  texteditbox->text() +"\n"  );

    QTextStream os(socket);
    os << texteditbox->text() << "\n";

    texteditbox->setText( "" );

}

void JahNet::sendMediaToServer( videoData clip, int clipnumber ) {

  //////////////////////////////////////////////////////////////
  //first we open up a new socket separate from the converstaion

  datasocket = new QSocket( this );

  //get hostip and port from fields here
  QString hostname = serveredit->text() ;
  QString porttext = "4243" ;  //the image server is on a different port...
  int portnumber= porttext.toInt();

  debug("host :" + hostname + " port:" + porttext);

  //need to do some debugging here in case we cant connect...
  datasocket->connectToHost( hostname, portnumber );

  /////////////////////////////////////////////////////////////////
  //first we send the header data for the clip

  QTextStream os(datasocket);
  QString write, parse;

  write=clip.clipname;                           os << write << "\n";
  write=clip.clipnumber;                         os << write << "\n";
  write=clip.filename;                           os << write << "\n";
  write=clip.location;                           os << write << "\n";
  write=clip.extension;                          os << write << "\n";
  write=clip.videoext;                           os << write << "\n";
  write=parse.setNum(clipnumber);                os << write << "\n";

  write=parse.setNum(clip.startframe);           os << write << "\n";
  write=parse.setNum(clip.endframe);             os << write << "\n";

  write=parse.setNum(clip.theCategory);          os << write << "\n";
  write=parse.setNum(clip.theType);              os << write << "\n";

  datasocket->flush();
  ///////////////////////////////////////////////////////////////////
  //now we send the clip, for sequences we will have to send the files 1 by 1

  int x=0;   QString debugdata,readfile;
  //Q_ULONG thedata;

  readfile =  clip.location+clip.filename+clip.extension; debug("Readfile is:"+readfile);
  QFile file( readfile);

  file.open( IO_Raw | IO_ReadOnly );

  while( !file.atEnd() ) { x++; datasocket->putch( file.getch() );   }


  file.close();
  datasocket->flush();


  //wait for all data to finished being sent and then
  //tell the host to add the file to the hosts desktop...
  Q_ULONG stillleft; stillleft = datasocket->bytesToWrite();
  while (stillleft != 0) { stillleft = datasocket->bytesToWrite(); }

  //QString tillleft; tillleft = "bytes to write:"+tillleft.setNum(stillleft); debug(tillleft);

  // how do we do tis mon? aaah maybe by closing the socket :)
  //tell server its ok to add it now...?



  ///////////////////////////////////////////////////////////////
  //now we close out the socket

  datasocket->close();

  if ( datasocket->state() == QSocket::Closing ) {
    // We have a delayed close.
    connect( socket, SIGNAL(delayedCloseFinished()), SLOT(socketClosed()) );
  } else {
	    // The socket is closed.
	    socketClosed();
  }

  texteditbox->setText( "successfully sent clip" );
  debug( "sent imagesize "+write.setNum(x) );



}

void JahNet::GrabDesktopClip() {

  emit GrabClip();

}

void JahNet::addClip(videoData clip, int clipnumber) {

  sendMediaToServer(clip, clipnumber);

}


void JahNet::socketReadyRead() {

	// read from the server
	while ( socket->canReadLine() ) {
	    //infoText->append( socket->readLine() );
	}

}

void JahNet::socketConnected()    { clienttextfeedback->append( tr("Connected to server\n") ); }

void JahNet::socketConnectionClosed()    { clienttextfeedback->append( tr("Connection closed by the server\n") ); }

void JahNet::socketClosed()    {  clienttextfeedback->append( tr("Connection closed\n") ); }

void JahNet::socketError( int e )    { clienttextfeedback->append( tr("Error number %1 occurred\n").arg(e) ); }


