/*******************************************************************************
**
** The header file for the Jahshaka network module
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "networking.h"


void JahNet::initializeObjects()
{
    //start up the servers here for incoming connections on port 4242/4243  and connect the slots
	//we need to turn this on manually or in the prefs

	if (autoLaunchServer)
		launchServer();

    //for p2p module
    jahGift = 0;

    NetStatus = true;

    //hook up Gift shared folder here
    theSharedFolder = new FileMainFrame ( mainshareframe,"shareview");

	//this is where we set the share folder
    theSharedFolder->fileView()->setDirectory( "/root/.giFT/completed/" );
    
	connect( theSharedFolder, SIGNAL(loadButton( )), this, SLOT(sendClipToDesktop( )) );

    //initialize gift engine
    #ifdef JAHGIFT
    initializeGift();
    #endif
}

void JahNet::ServerInfo()
{

}

void JahNet::launchServer()
{
    
    server      = new SimpleServer(4242,this);		//the text server on port 4242
    imageserver = new SimpleServer(4243,this);		//the image server on port 4243

    //hook them up
    connect( server, SIGNAL(newConnect()), SLOT(newConnect()) );
    connect( server, SIGNAL(copyText(QString )), SLOT(echoText(QString  )) );

    //for reciprocating chat connections
    connect( server, SIGNAL(recipConnect(QHostAddress )), SLOT(recirprocateConnection(QHostAddress  )) );

	serverLaunched = TRUE;

}

void JahNet::setConnectServer()
{
    JahPrefs& jprefs  = JahPrefs::getInstance();

	autoLaunchServer = autoConnect->isChecked();

    jprefs.setAutoLaunchServer(autoLaunchServer);
}


void JahNet::sendClipToDesktop()
{
    //debug("sending clip...");

    QString result = theSharedFolder->returnFilename;

    if (result)
    {

        emit updateDesktopString(result);

    }

}

void JahNet::newConnect()
{
    clienttextfeedback->append( "New connection\n" );
}

void JahNet::echoText(QString text)
{
    clienttextfeedback->append( text+"\n" );
}

void JahNet::recirprocateConnection(QHostAddress addy)
{

    //debug("server has received connection, reciprocating");

    //but which server? 4242 or 4243?
    //QString theaddyip = addy.toString();
    //debug("client connected to server from:"+theaddyip);

    int theportnumber;
    theportnumber =    server->lastPortNum();
    //debug("last connection to server was from:");

    //QString tellme;
    //debug(tellme.setNum(theportnumber));

    createNewClient(addy);

}



void JahNet::updatetheDesktop(  videoData datafile )
{    
    //now we need to get the global clip number and increment it before adding...
    int clipnum = *clipnumber;
    clipnum++;

    datafile.clipnumber = clipnum;

    *clipnumber = clipnum;

    //now add datafile to desktop
    //maybe desktop should update clipnumber on its own everytime
    //for other routines as well?
    emit updateDesktop(datafile);
}








