###############################################################
#
# Jahshaka 1.9a4 QMake module files 
#
###############################################################

#include presets file in home directory
include( ../../../Settings.pro )

###############################################################
#the rest of the makefile settings

TEMPLATE = lib
CONFIG		+= staticlib qt warn_on release opengl thread
HEADERS		= 		FTBBox.h \
                FTBitmapGlyph.h \
                FTCharmap.h \
                FTCharToGlyphIndexMap.h \
                FTContour.h \
                FTExtrdGlyph.h \
                FTFace.h \
                FTFont.h \
                FTGL.h \
                FTGLBitmapFont.h \
                FTGLExtrdFont.h \
                FTGLOutlineFont.h \
                FTGLPixmapFont.h \
                FTGLPolygonFont.h \
                FTGLTextureFont.h \
                FTGlyph.h \
                FTGlyphContainer.h \
                FTLibrary.h \
                FTList.h \
                FTOutlineGlyph.h \
                FTPixmapGlyph.h \
                FTPoint.h \
                FTPolyGlyph.h \
                FTSize.h \
                FTTextureGlyph.h \
                FTVector.h \
                FTVectoriser.h 
SOURCES     =   FTBitmapGlyph.cpp \
                FTCharmap.cpp \
                FTContour.cpp \
                FTExtrdGlyph.cpp \
                FTFace.cpp \
                FTFont.cpp \
                FTGLBitmapFont.cpp \
                FTGLExtrdFont.cpp \
                FTGLOutlineFont.cpp \
                FTGLPixmapFont.cpp \
                FTGLPolygonFont.cpp \
                FTGLTextureFont.cpp \
                FTGlyph.cpp \
                FTGlyphContainer.cpp \
                FTLibrary.cpp \
                FTOutlineGlyph.cpp \
                FTPixmapGlyph.cpp \
                FTPoint.cpp \
                FTPolyGlyph.cpp \
                FTSize.cpp \
                FTTextureGlyph.cpp \
                FTVectoriser.cpp 
TARGET = ftgl
DEPENDPATH = $$JAHDEPENDPATH

###############################################################
#the project related includes
INCLUDEPATH =		. .. ../../Core/Objects ../../Core/Render ../../Core/World  \
            ../../desktop
contains( JAHOS,LINUX ) {
INCLUDEPATH += 		../../encoders/mpeg_encode ../../encoders/mpeg_play
}

INCLUDEPATH +=          ../../libraries \
                        ../../libraries/assetobj \
                        ../../libraries/GLCore \
                        ../../libraries/glew \
                        ../../libraries/imagelibs \
                        ../../libraries/jahkeyframes \
                        ../../libraries/jahpreferences \
                        ../../libraries/jahtimer \
                        ../../libraries/jahtracer \
                        ../../libraries/mediaobject
                        
contains( SPACEBALL,true ) {
INCLUDEPATH     +=      ../../libraries/spaceball
}

INCLUDEPATH +=          ../../uiwidgets \
                        ../../uiwidgets/interfaceobjs \
                        ../../uiwidgets/jahcalc \
                        ../../uiwidgets/jahfileloader \
                        ../../uiwidgets/keyframes \
                        ../../uiwidgets/nodes \
                        ../../uiwidgets/timeline \
                        ../../Modules/animate \
                        ../../Modules/color \
                        ../../Modules/edit \
                        ../../Modules/effect \
                        ../../Modules/painter \
                        ../../Modules/text \
                        ../../objectlibs/FTGL \
                        ../../objectlibs/glmlib \
                        ../../objectlibs/l3ds \
                        ../../objectlibs/particle \
                        ../../network \
                        ../../player \
                        ../../sqlite \
                        $$FREEDIR


contains( JAHOS,IRIX ) {
INCLUDEPATH +=          $$SGIDIR
}




