###############################################################
#
# Jahshaka 1.9a4 QMake module files
#
###############################################################

#include presets file in home directory
include( ../../../Settings.pro )

###############################################################
#the rest of the makefile settings


TEMPLATE	= lib
CONFIG		= staticlib warn_off release opengl thread

HEADERS		= general.h \
		  p_vector.h \
		  papi.h
SOURCES		= action_api.cpp \
		  actions.cpp \
		  opengl.cpp \
		  system.cpp

TARGET = particle
DEPENDPATH = $$JAHDEPENDPATH
INCLUDEPATH =		. .. ../../Core/Objects ../../Core/Render ../../Core/World  \
			../../desktop
contains( JAHOS,LINUX ) {
INCLUDEPATH += 		../../encoders/mpeg_encode ../../encoders/mpeg_play
}


INCLUDEPATH +=          ../../libraries \
                        ../../libraries/assetobj \
                        ../../libraries/GLCore \
                        ../../libraries/glew \
                        ../../libraries/imagelibs \
                        ../../libraries/jahkeyframes \
                        ../../libraries/jahpreferences \
                        ../../libraries/jahtimer \
                        ../../libraries/jahtracer \
                        ../../libraries/mediaobject
                        
contains( SPACEBALL,true ) {
INCLUDEPATH     +=      ../../libraries/spaceball
}

INCLUDEPATH +=          ../../uiwidgets \
                        ../../uiwidgets/interfaceobjs \
                        ../../uiwidgets/jahcalc \
                        ../../uiwidgets/jahfileloader \
                        ../../uiwidgets/keyframes \
                        ../../uiwidgets/nodes \
                        ../../uiwidgets/timeline \
                        ../../Modules/animate \
                        ../../Modules/color \
                        ../../Modules/edit \
                        ../../Modules/effect \
                        ../../Modules/painter \
                        ../../Modules/text \
                        ../../objectlibs/FTGL \
                        ../../objectlibs/glmlib \
                        ../../objectlibs/l3ds \
                        ../../objectlibs/particle \
                        ../../network \
                        ../../player \
                        ../../sqlite \
                        $$FREEDIR


contains( JAHOS,IRIX ) {
INCLUDEPATH +=          $$SGIDIR
}


#os specific tweaks here

##############################
### unix config
##############################
unix:CLEAN_FILES+= *.bck

##############################
### linux config
##############################
linux-g++:TMAKE_CXXFLAGS_RELEASE = -O3 -ffast-math

##############################
### WIN32 config
##############################
win32-msvc:TEMPLATE     =	vclib

##############################
### OsX Darwin config
##############################

contains( JAHOS,DARWIN ) {
HEADERS += macosx_math.h
SOURCES += macosx_math.cpp
}

