/* flip - pageflipper for TIFF animations
 * Copyright (C) 1999 Mark B. Allan (mba@reptilelabour.com)
 *
 * "flip" is free software; you can redistribute it and/or use
 * it and/or modify it under the terms of the "Artistic License"
 */

#ifndef InputLCD_h
#define InputLCD_h

#include <qlcdnumber.h>

/**
 * LCD display
 */
//====================================================================
class InputLCD : public QLCDNumber
{
    Q_OBJECT;
	
public:
    InputLCD (QWidget* parent = NULL, const char* name = NULL, const int theval = 4 );
	inline	int	getMinInt ()	{	return minInt;	}
	inline	int	getMaxInt ()	{	return maxInt;	}

void contextMenuEvent(QContextMenuEvent * e)
{
    //dont want context menus poping up in lcd's
    e->accept();		// Is this the correct way to
}


signals:
	void		valueChanged(int val);
	void		incrementValueChanged(int val);
	
public slots:
	void		setValue	(int);
	void		setMinInt	(int val);	
	void		setMaxInt	(int val);	
	void		setMinMaxInt(int min, int max);	
	void		setActive	(bool status);
	void		setIncrement	(int val);
	
protected:
	bool		LCDactive;
	int			valueType;
	void 		mousePressEvent  (QMouseEvent *msEv);
	void 		mouseDoubleClickEvent  (QMouseEvent *msEv);
	void 		mouseMoveEvent ( QMouseEvent *msEv );
	
	int			lastXPos;
	
	int			val;
	int			minInt;
	int			maxInt;

  int     lcdsize;

  //for the timecode numbers we store the current value here
  int     lcdval;
  
  bool increment;
  int  incrementVal;

};

#endif // InputLCD_h

