/*******************************************************************************
**
** The source file for the Jahshaka jahnodes class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "keyframeeditor.h"

// We use a global variable to save memory - all the brushes and pens in
// the mesh are shared.
//static QBrush *tb = 0;
//static QPen *tp = 0;

//#include <node.h>


KeyframeEditor::KeyframeEditor(	QCanvas* c, QWidget* parent, const char* name, WFlags f) :
    QCanvasView(c,parent,name,f)
{

}

void KeyframeEditor::cleareditor()
{

    QCanvasItemList list = canvas()->allItems();
    QCanvasItemList::Iterator it = list.begin();
    for (; it != list.end(); ++it) {
    if ( *it )
        delete *it;
    }
    
}

void KeyframeEditor::contentsMousePressEvent(QMouseEvent* e)
{
    QPoint p = inverseWorldMatrix().map(e->pos());

    QCanvasItemList l=canvas()->collisions(p);

    for (QCanvasItemList::Iterator it=l.begin(); it!=l.end(); ++it) {
//	if ( (*it)->rtti() == imageRTTI ) {
//	    ImageItem *item= (ImageItem*)(*it);
    // if ( !item->hit( p ) )
//		 continue;
//	}
    moving = *it;
    moving_start = p;
    return;
    }
    moving = 0;
}

void KeyframeEditor::contentsMouseMoveEvent(QMouseEvent* e)
{
    if ( moving ) 
    {
    QPoint p = inverseWorldMatrix().map(e->pos());
    moving->moveBy(p.x() - moving_start.x(),
            p.y() - moving_start.y());
    moving_start = p;
    canvas()->update();
    }

    //if we are moving the last node or first node in
    //a keyframe layout we need to also move the + and -
    //infinity nodes...
    //may be easier to make them unique?
}


//static uint mainCount = 0;




