/*******************************************************************************
**
** The header file for the Jahshaka keyframer jahkeyframes file
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef KEYFRAMER_H
#define KEYFRAMER_H

#include <qcanvas.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <widget.h>
#include <qwmatrix.h>

#include "keyframeritem.h"
#include "keyframeeditor.h"

//libraries
#include "jahkeyframes.h"
#include "jahtracer.h"

///////////////////////////////////////////
// main class

class JahKeyframer : public QWidget {
    Q_OBJECT

public:
    //JahKeyframer(QCanvas&, QWidget* parent=0, const char* name=0, WFlags f=0);
    JahKeyframer(QWidget* theparent=0, QWidget* parent=0, const char* name=0, WFlags f=0);
    ~JahKeyframer();

	void updateKeyframes();
	void updateKeyframes(int numFrames, QPtrList<motionNode> * nodelist);


protected:
    QHBoxLayout* keyframeruiLayout;
    QVBoxLayout* keycontrolsLayout;

public slots:
	//should all be private except for calling routine above
    void clear();
    void buildInterface();

    void buildKeyframes();
	void buildKeyframes(int numFrames, QPtrList<motionNode> * nodelist);

private slots:

    void drawLine(int x1, int y1, int x2, int y2);

    void enlarge();
    void shrink();
    void zoomIn();
    void zoomOut();
    void addLine();

    void emitAddKeyframe(void);
    void emitRemoveKeyframe(void);
    void emitPrevKeyframe(void);
    void emitNextKeyframe(void);

signals:

    void AddKeyframe(void);
    void RemoveKeyframe(void);
    void PrevKeyframe(void);
    void NextKeyframe(void);

protected slots:
    virtual void languageChange();

private:
    QCanvas* canvas;
    KeyframeEditor *keyeditor;

    QPopupMenu* options;

    int dbf_id;
    
    QBrush *tb;
    QPen *tp;


    QFrame* keyframerui;
    QFrame* keyframer;
    QFrame* keycontrols;
    QPushButton* addKeyframe;
    QPushButton* removeKeyframe;
    QPushButton* prevKeyframe;
    QPushButton* nextKeyframe;

};

#endif
