/*******************************************************************************
**
** The header file for the node class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "keyframeritem.h"

///////////////////////////////////////////////
// for the keyframe item

void KeyframeItem::moveBy(double dx, double dy)
{
//	debug("in keyframe moveby");
    QCanvasEllipse::moveBy( dx, dy );

    QPtrListIterator<KeyEdgeItem> it1( inList );
    KeyEdgeItem *edge;

    while (( edge = it1.current() )) 
	{
		++it1;
		edge->setToPoint( int(x()), int(y()) );
    }

    QPtrListIterator<KeyEdgeItem> it2( outList );

    while (( edge = it2.current() )) 
	{
		++it2;
		edge->setFromPoint( int(x()), int(y()) );

    }

}



KeyframeItem::KeyframeItem( QCanvas *canvas )
    : QCanvasEllipse( 6, 6, canvas )
{
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    setZ( 128 );
}

////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////
//

int KeyEdgeItem::c = 0;


void KeyEdgeItem::moveBy(double, double)
{
    //nothing
}

KeyEdgeItem::KeyEdgeItem( KeyframeItem *from, KeyframeItem *to, QCanvas *canvas )
    : QCanvasLine( canvas )
{
    c++;
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    from->addOutEdge( this );
    to->addInEdge( this );
    setPoints( int(from->x()), int(from->y()), int(to->x()), int(to->y()) );
    setZ( 127 );
}




KeyEdgeItem::KeyEdgeItem( int x, int y, KeyframeItem *to, QCanvas *canvas )
    : QCanvasLine( canvas )
{
    c++;
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    //from->addOutEdge( this );
    to->addInEdge( this );
    setPoints( x, y, int(to->x()), int(to->y()) );
    setZ( 127 );
}

KeyEdgeItem::KeyEdgeItem( KeyframeItem *from, int x, int y, QCanvas *canvas )
    : QCanvasLine( canvas )
{
    c++;
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    from->addOutEdge( this );
    //to->addInEdge( this );
    setPoints( int(from->x()), int(from->y()), x, y );
    setZ( 127 );
}
void KeyEdgeItem::setFromPoint( int x, int y )
{
    setPoints( x,y, endPoint().x(), endPoint().y() );
}

void KeyEdgeItem::setToPoint( int x, int y )
{
    setPoints( startPoint().x(), startPoint().y(), x, y );
}
