/*******************************************************************************
**
** The header file for the node class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef JAHKEYFRAMEITEM_H
#define JAHKEYFRAMEITEM_H

#include <qpopupmenu.h>
#include <qmainwindow.h>
#include <qintdict.h>
#include <qcanvas.h>

//#include <nodes.h>
class KeyEdgeItem;
class KeyframeItem;

class KeyEdgeItem: public QCanvasLine
{
public:
    KeyEdgeItem( KeyframeItem*, KeyframeItem*, QCanvas *canvas );

    KeyEdgeItem( int x, int y, KeyframeItem*, QCanvas *canvas ); //null header

    KeyEdgeItem( KeyframeItem*, int x, int y, QCanvas *canvas ); //null header

    void setFromPoint( int x, int y ) ;
    void setToPoint( int x, int y );

    static int count() { return c; }
    void moveBy(double dx, double dy);

private:
    static int c;
};


class KeyframeItem: public QCanvasEllipse
{
public:

    KeyframeItem( QCanvas *canvas );
    ~KeyframeItem() {}

    void addInEdge( KeyEdgeItem *edge ) { inList.append( edge ); }
    void addOutEdge( KeyEdgeItem *edge ) { outList.append( edge ); }
    void moveBy(double dx, double dy);

private:
    QPtrList<KeyEdgeItem> inList;
    QPtrList<KeyEdgeItem> outList;
     
};



#endif

