/*******************************************************************************
**
** The source file for the Jahshaka jahnodes class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include <jahnodes.h>



static uint mainCount = 0;

JahNodes::JahNodes(QWidget* parent, const char* name, WFlags f)
{

	
    canvas = new QCanvas(parent);
    QColor back;
    back.setHsv(35,35,35);
    canvas->setBackgroundColor(back);
    canvas->resize( 980, 506 );

    nodeeditor = new NodeEditor(canvas,parent);
    nodeeditor->resize( 980, 506 );
    nodeeditor->setHScrollBarMode( NodeEditor::AlwaysOff );
    nodeeditor->setVScrollBarMode( NodeEditor::AlwaysOff );

    clear();

    static int r=24;   srand(++r);

    mainCount++;

    buildInterface();

    nodenumber = 0;

    ///////////////////////////////////////////////
    // the linked list is here
    list = new QPtrList<LayerList>;
    list->setAutoDelete( TRUE );     // delete items when they are removed

}


JahNodes::~JahNodes()
{
}

void JahNodes::clear() {   nodeeditor->clear();}

void JahNodes::enlarge()
{    //canvas.resize(canvas.width()*4/3, canvas.height()*4/3);
}

void JahNodes::shrink()
{    //canvas.resize(canvas.width()*3/4, canvas.height()*3/4);
}

void JahNodes::zoomIn()
{    //QWMatrix m = editor->worldMatrix();    m.scale( 2.0, 2.0 );    editor->setWorldMatrix( m );
}

void JahNodes::zoomOut()
{    //QWMatrix m = editor->worldMatrix();    m.scale( 0.5, 0.5 );    editor->setWorldMatrix( m );
}


void JahNodes::buildInterface()
{
}

void JahNodes::drawLine(int x1, int y1, int x2, int y2)
{
    QCanvasLine* i = new QCanvasLine(canvas);
    i->setPoints( x1, y1,	  x2,y2 );
    i->setPen( QPen(Qt::white) );
    i->setZ(128);
    i->show();

}

//initially this will be display only :)
//with zoom and scroll and timeline 

void JahNodes::addNodes(int x, QString name)
{

    //first add to list of effects
    list->append( new LayerList(name, x) );

    //the increment effect number
    nodenumber++;

    //rebuilds the visual representation
    buildNodes(name);
}


////////////////////////////////////////////////////
// we can store position data as well
//and use a signal / slot to update it when changed

void JahNodes::buildNodes(QString name)
{
    //set up tracer
    JahTrace& jtrace = JahTrace::getInstance();
    jtrace.debug( "JahNodes::","building nodes");
    
    //clear the exissting node sout
    //gotta be a better way :)
//    debug("1");
    clear();
    //nodeeditor->clear();
//    debug("2");
    
    int x0 = 100;    int y0 = 100;

    if ( !tb ) tb = new QBrush( Qt::blue );
    if ( !tp ) tp = new QPen( Qt::white );

    int nodecount = 0;

    int w = canvas->width();
    int h = canvas->height();

    const int dist = 100;

    //number of nodes
    int   nodes = nodenumber;

    //use an array is cool
    //as we use an array for nodes right now
    QMemArray<NodeItem*> lastRow(nodes);

    NodeItem *prev = 0;
    //debug(">>> starting loop");
    for ( int i = 0; i < nodes; i++ )
    //for ( int i = nodes; i >= 0; i-- )
    {
        if ( list->at(i) )
        {
            //debug("get node item info");
            QString name =list->at(i)->name();
            int thelayer = list->at(i)->layer();

            //debug("get node item");

            NodeItem *el = new NodeItem( canvas,name,thelayer );
            //debug("got node item");
            nodecount++;

            el->move( y0, x0 + i*dist   );


            if ( prev )
            {
                (new NodesEdgeItem( prev, el, canvas ))->show();
            }

            if ( i > 0 ) lastRow[i-1] = prev;
            prev = el;

            el->show();
        }
    }

    jtrace.debug(">>> built nodes");

    nodeeditor->update();
    canvas->setAllChanged();
    canvas->update();
}

