/*******************************************************************************
**
** The header file for the jahnodes class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#ifndef JAHNODES_H
#define JAHNODES_H

#include <qcanvas.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qcanvas.h>
#include <qwmatrix.h>

#include "jahnodesitem.h"
#include "jahnodeeditor.h"

#include "jahtracer.h"

///////////////////////////////////////////
// main class
class LayerList
{
public:
    LayerList( const QString& name, int layer ) { n=name; l=layer; }
    QString     name()   const                    { return n; }
    int         layer() const                     { return l; }
private:
    QString     n;
    int         l;
};


class JahNodes : public QWidget {
    Q_OBJECT

public:
    JahNodes(QWidget* parent=0, const char* name=0, WFlags f=0);
    ~JahNodes();

public slots:
    void addNodes(int x, QString name);
private slots:

    void clear();

    void drawLine(int x1, int y1, int x2, int y2);
    void buildInterface();
    void buildNodes(QString name);

    void enlarge();
    void shrink();
    void zoomIn();
    void zoomOut();

private:
    QCanvas* canvas;
    NodeEditor *nodeeditor;

    QPtrList<LayerList> *list;

    QBrush *tb;
    QPen *tp;

    int nodenumber;
};

#endif
