/*******************************************************************************
**
** The header file for the node class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/

#include "jahnodesitem.h"

///////////////////////////////////////////////
// for the node item

void NodeItem::moveBy(double dx, double dy)
{
    QCanvasEllipse::moveBy( dx, dy );
    itemtext->moveBy( dx, dy );

    QPtrListIterator<NodesEdgeItem> it1( inList );
    NodesEdgeItem *edge;
    while (( edge = it1.current() )) {
	++it1;
	edge->setToPoint( int(x()), int(y()) );
    }
    QPtrListIterator<NodesEdgeItem> it2( outList );
    while (( edge = it2.current() )) {
	++it2;
	edge->setFromPoint( int(x()), int(y()) );
    }
}



NodeItem::NodeItem( QCanvas *canvas, QString name, int num )
    : QCanvasEllipse( 97, 57, canvas )
{
    nodename = name;
    effectnumber = num;

    //for the ellipse
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    setZ( 128 );


    //for the text label
    itemtext = new QCanvasText( canvas);
    itemtext->setColor( QColor(200,200,200) );
    itemtext->setText(name);
    itemtext->setX(x());
    itemtext->setY(y());
    itemtext->setZ(129);
    itemtext->show();

}

///////////////////////////////////////////////////////

///////////////////////////////////////////////////////
//

int NodesEdgeItem::c = 0;


void NodesEdgeItem::moveBy(double, double)
{
    //nothing
}


NodesEdgeItem::NodesEdgeItem( NodeItem *from, NodeItem *to, QCanvas *canvas )
    : QCanvasLine( canvas )
{
    c++;
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    from->addOutEdge( this );
    to->addInEdge( this );
    setPoints( int(from->x()), int(from->y()), int(to->x()), int(to->y()) );
    setZ( 127 );
}

NodesEdgeItem::NodesEdgeItem( int x, int y, NodeItem *to, QCanvas *canvas )
    : QCanvasLine( canvas )
{
    c++;
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    //from->addOutEdge( this );
    to->addInEdge( this );
    setPoints( x, y, int(to->x()), int(to->y()) );
      //setPen( *tp );
    //setBrush( *tb );  //setZ( 127 );
}

NodesEdgeItem::NodesEdgeItem( NodeItem *from, int x, int y, QCanvas *canvas )
    : QCanvasLine( canvas )
{
    c++;
    setPen( QPen(Qt::white) );
    setBrush( QBrush(Qt::red) );
    from->addOutEdge( this );
    //to->addInEdge( this );
    setPoints( int(from->x()), int(from->y()), x, y );
    setZ( 127 );
}



void NodesEdgeItem::setFromPoint( int x, int y )
{
    setPoints( x,y, endPoint().x(), endPoint().y() );
}

void NodesEdgeItem::setToPoint( int x, int y )
{
    setPoints( startPoint().x(), startPoint().y(), x, y );
}

