/*******************************************************************************
**
** The header file for the node class
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** Released under the GNU General Public License
**
*******************************************************************************/
#ifndef JAHNODESITEM_H
#define JAHNODESITEM_H

#include <qpopupmenu.h>
#include <qmainwindow.h>
#include <qintdict.h>
#include <qcanvas.h>

class NodesEdgeItem;
class NodeItem;


class NodesEdgeItem: public QCanvasLine
{
public:
    NodesEdgeItem( NodeItem*, NodeItem*, QCanvas *canvas );
    NodesEdgeItem( int x, int y, NodeItem*, QCanvas *canvas ); //null header
    NodesEdgeItem( NodeItem*, int x, int y, QCanvas *canvas ); //null header

    void setFromPoint( int x, int y ) ;
    void setToPoint( int x, int y );

    static int count() { return c; }
    void moveBy(double dx, double dy);

private:
    static int c;
};



static const int nodeRTTI = 985376;

class NodeItem: public QCanvasEllipse
{
public:
    NodeItem( QCanvas *canvas, QString name, int effectnum );
    ~NodeItem() {}

    int rtti () const { return nodeRTTI; }
    QString nodename;
    int effectnumber;

    void addInEdge( NodesEdgeItem *edge ) { inList.append( edge ); }
    void addOutEdge( NodesEdgeItem *edge ) { outList.append( edge ); }

    void moveBy(double dx, double dy);

    //    QPoint center() { return boundingRect().center(); }
    QCanvasText*    itemtext;

private:
    QPtrList<NodesEdgeItem> inList;
    QPtrList<NodesEdgeItem> outList;



};


#endif

