###############################################################
#
# Jahshaka 1.9a4 QMake build files
#
###############################################################

message( "Jahplayer 1.9a8 alpha build" )
message( "---------------------------" )
message( "" )
message( "Checking operating system" )
message( "" )

include( Settings.pro )

###############################################################
# Configure subdirectories
message( "Configuring Subdirectories" )

message( "Configuring Core Libraries" )
SUBDIRS +=  jah/Source \
            jah/Core/Objects \
            jah/Core/Render \
            jah/Core/World

message( "Configuring Standard Libraries" )
SUBDIRS +=  jah/libraries/jahtracer \
            jah/libraries/assetobject \
            jah/libraries/imagelibs \
            jah/libraries/jahkeyframes \
            jah/libraries/mediaobject \
            jah/libraries/glew \
            jah/libraries/jahtimer \
            jah/libraries/jahpreferences \
            jah/libraries/jahtranslate \
            jah/libraries/GLCore \
            jah/libraries/jahplayer \
            jah/libraries/jahdatabase

message( "Configuring UI Widgets" )
SUBDIRS +=  jah/uiwidgets/interfaceobjs \
            jah/uiwidgets/jahcalc \
            jah/uiwidgets/jahfileloader


SUBDIRS +=  jah/desktop \
            jah/player

#files for audio support
contains( JAHAUDIO,true ) {
message( "Configuring Audio Support" )
SUBDIRS +=  jah/libraries/jahaudio  jah/libraries/jahaudio/G72x jah/libraries/jahaudio/GSM610
}



#files for sqlite database support
message( "Configuring Sqlite databse Support" )
SUBDIRS +=  jah/sqlite

#files for layer object support
message( "Configuring layer objects Support" )
SUBDIRS +=  jah/objectlibs/FTGL \
            jah/objectlibs/glmlib \
            jah/objectlibs/l3ds \
            jah/objectlibs/particle \
            jah/objectlibs/blur

#files for the main modules
message( "Configuring Jahshaka Modules" )
SUBDIRS +=  jah/Modules/glplayer

message( "Configuring Media Support" )
message( "-------------------------" )


#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
message( "Configuring MPEG decoding Support" )
SUBDIRS += jah/encoders/mpegdec
}

#files for Avi support on linux
contains( LINUXAVISUPPORT,true ) {
message( "Configuring linux Avi Support" )
}

#files for Avi support on linux
contains( JAHTHEMES,true ) {
message( "Using Qt Theme Support" )
}

SUBDIRS += jah


TEMPLATE = subdirs
CONFIG  += release  warn_on  qt  opengl  thread
message( " " )
message( "Make files have been configured" )
message( "type make to build jahshaka" )
message( "" )
message( "Once jahplayer has compiled" )
message( "type ./jahplayer to run" )
message( "" )
message( "please report bugs on www.jahplayer.com" )
message( "forums->bugs" )
message( "" )
message( "known bugs" )
message( "----------" )
message( "" )
message( "Q: If jahshaka crashes on startup its probably the database" )
message( "A: heres a quick fix" )
message( "cd to the jahshaka home directory then" )
message( "cd database" )
message( "then type ./wipedbase to clear it out" )
message( "your assets will still be on disk but you will have to" )
message( "re-import them onto your desktop" )


