###############################################################
#
# Jahshaka 1.9a8 Configuration File
#
###############################################################

###############################################################
# System wide settings here, you can modify these
###############################################################

###Jahplayer Build###
JAHPLAYER       =   true

###System Options###

JAHTHEMES       = true   #some linuxes have trouble with qt themes

###Media Options###

JAHMPEGDECODER  = true   #mpeg decoding using built in encoder
LINUXAVISUPPORT = true   #avi support on linux using avifile
JAHAUDIO        = true   #audio support using built in libsoundfile


###############################################################
# Configuration from here on down
###############################################################

###############################################################
# Sets up the Qt depend path, override if it doesnt work
# should be /usr/lib/qt-3.1/include

QTPATH = $$system(echo $QTDIR)
JAHDEPENDPATH = $$QTPATH/include

###############################################################
# OS specific settings here
###############################################################

OSNAME = $$system(uname -s)
message( Operating System Type  ($$OSNAME)  )

OSDEF = LOST

###############################################################
# System wide settings here, you can modify these
###############################################################

#edit jahshakaConfig.pro for the configuration variables
#include( jahshakaConfig.pro )

###############################################################
# Linux specific settings here

contains( OSNAME,[lL]inux  ) {
    message( "Using linux presets..." )
    OSDEF = FOUND

    #os specific variable
    JAHOS=LINUX
    DEFINES += JAHLINUX
    
    #location of freetype libraries on linux
    FREEDIR = /usr/include/freetype2
    
    #for the audio hack
    #we hack the directories where libaudio is on to freedir
    contains( JAHAUDIO,true ) {
        FREEDIR += /usr/local/include
        FREEDIR += /usr/include
        DEFINES += AUDIOSUPPORT
    }

    #for avi
    contains( LINUXAVISUPPORT,true ) {
        DEFINES += LINUXAVISUPPORT
    }

    #for native mpeg decoder support
    contains( JAHMPEGDECODER,true ) {
        DEFINES += JAHMPEGDECODER
    }

    #for qt theme support
    contains( JAHTHEMES,true ) {
        DEFINES += JAHTHEMES
    }

    #for jahplayer support
    contains( JAHPLAYER,true ) {
        DEFINES += JAHPLAYER
    }

}
###############################################################
# OsX specific settings here

contains( OSNAME,[dD]arwin ) {
    message( "Using Mac OsX presets..." )
    OSDEF = FOUND
    
    #os specific variable
    JAHOS=DARWIN
        DEFINES += JAHDARWIN
        
    #default location of freetype libraries on mac
    FREEDIR = /usr/local/include/freetype2
    
    #for qt theme support
        contains( JAHTHEMES,true ) {
        DEFINES += JAHTHEMES
    }


}

###############################################################
# Sgi Irix specific settings here

    contains( OSNAME,[iI]rix    ) {
    message( "Using Irix presets..." )
    OSDEF = FOUND

    #os specific variable
    JAHOS=IRIX
        DEFINES += JAHIRIX
        
    #location of freetype libraries on irix
    FREEDIR = /usr/freeware/include/freetype2

    SGIDIR  = /usr/freeware/include
        SGIDIR += /usr/freeware/include/GL
        
    #for qt theme support
        contains( JAHTHEMES,true ) {
        DEFINES += JAHTHEMES
    }


}

###############################################################
# Sgi Irix old Qt specific settings here

#this is a hack for sgi systems using the older qt 3.0 libs
#that are distributed with the aug03 freeware
#jahshaka needs at least 3.1 for optimal functionality

exists( /usr/lib/Xm/bindings/sgi ) {

message( "Using Unstable 3.0 Irix presets..." )

    #os specific variable
    JAHOS=IRIX
    OSDEF = FOUND
        DEFINES += JAHIRIX

    #location of freetype libraries on irix
    FREEDIR = /usr/freeware/include/freetype2

    #location of qt libraries on irix
    JAHDEPENDPATH = /usr/freeware/Qt/include

    SGIDIR  = /usr/freeware/include
    SGIDIR += /usr/freeware/include/GL
    
    #for qt theme support
        contains( JAHTHEMES,true ) {
        DEFINES += JAHTHEMES
    }


} else {

###############################################################
# Cant figure out the os use some defaults and hope

contains( OSDEF, LOST  ) {
    message( "Cant figure out OS Using linux defaults..." )

    #os specific variable
    JAHOS=LINUX
    DEFINES += JAHLINUX
        
    QTPATH = /usr/lib/qt-3.1
    JAHDEPENDPATH = /usr/lib/qt-3.1/include

    #location of freetype libraries on linux
    FREEDIR = /usr/include/freetype2

    #for the audio hack
    contains( JAHAUDIO,true ) {
    #we hack the directories where libaudio is on to freedir
    FREEDIR += /usr/local/include
    FREEDIR += /usr/include
    DEFINES += AUDIOSUPPORT
    }

    #for avi
    contains( LINUXAVISUPPORT,true ) {
        DEFINES += LINUXAVISUPPORT
    }

    #for native mpeg support
    contains( JAHMPEGDECODER,true ) {
        DEFINES += JAHMPEGDECODER
    }

    #for qt theme support
        contains( JAHTHEMES,true ) {
        DEFINES += JAHTHEMES
    }
    
    #for jahplayer support
    contains( JAHPLAYER,true ) {
        DEFINES += JAHPLAYER
    }

}

} ###end of file

