###############################################################
#
# Jahshaka 1.9a4 QMake build files
#
###############################################################

message( "Jahshaka 1.9a8 alpha build" )
message( "--------------------------" )
message( "" )
message( "Checking operating system" )
message( "" )

include( Settings.pro )

###############################################################
# Configure subdirectories
message( "Configuring Subdirectories" )

message( "Configuring Core Libraries" )
SUBDIRS +=  jah/Source \
            jah/Core/Objects \
            jah/Core/Render \
            jah/Core/World

message( "Configuring Standard Libraries" )
SUBDIRS +=  jah/libraries/jahtracer \
            jah/libraries/assetobject \
            jah/libraries/imagelibs \
            jah/libraries/jahkeyframes \
            jah/libraries/mediaobject \
            jah/libraries/glew \
            jah/libraries/jahtimer \
            jah/libraries/jahpreferences \
            jah/libraries/jahtranslate \
            jah/libraries/GLCore \
            jah/libraries/gpumathlib \
            jah/libraries/jahplugins \
            jah/libraries/jahplayer \
            jah/libraries/jahdatabase

message( "Configuring UI Widgets" )
SUBDIRS +=  jah/uiwidgets/interfaceobjs \
            jah/uiwidgets/nodes  \
            jah/uiwidgets/jahcalc \
            jah/uiwidgets/jahfileloader \
            jah/uiwidgets/keyframes \
            jah/uiwidgets/timeline

#files for Gift on linux
contains( JAHGIFT,true ) {
message( "Configuring Gift Support" )
SUBDIRS +=  jah/libraries/jahgift \
            jah/network/apollon
}


#files for spaceball on linux
contains( SPACEBALL,true ) {
message( "Configuring Spaceball Support" )
SUBDIRS +=  jah/libraries/spaceball
}

#flag for GPU support on linux
contains( NVIDIA_GPU,true ) {
message( "Configuring GPU Support" )
}

#flag for GPU support on linux
contains( NVIDIA_GPGPU,true ) {
message( "Configuring GPGPU Support" )
}

SUBDIRS +=  jah/desktop \
            jah/network \
            jah/player

#files for audio support
contains( JAHAUDIO,true ) {
message( "Configuring Audio Support" )
SUBDIRS +=  jah/libraries/jahaudio  jah/libraries/jahaudio/G72x jah/libraries/jahaudio/GSM610
}


#flag for clearspeed support on linux
contains( CLEARSPEED,true ) {
message( "Configuring ClearSpeed Support" )
SUBDIRS +=  plugins/csplugins
}

#files for sqlite database support
message( "Configuring Sqlite databse Support" )
SUBDIRS +=  jah/sqlite

#files for layer object support
message( "Configuring layer objects Support" )
SUBDIRS +=  jah/objectlibs/FTGL \
            jah/objectlibs/glmlib \
            jah/objectlibs/l3ds \
            jah/objectlibs/particle \
            jah/objectlibs/blur

#files for the main modules
message( "Configuring Jahshaka Modules" )
SUBDIRS +=  jah/Modules/animate \
            jah/Modules/color \
            jah/Modules/edit \
            jah/Modules/effect \
            jah/Modules/painter \
            jah/Modules/text

message( "Configuring Media Support" )
message( "-------------------------" )

#files for mpeg encoder on linux
contains( JAHMPEGENCODER,true ) {
message( "Configuring MPEG encoding Support" )
SUBDIRS += jah/encoders/mpegenc
}

#files for mpeg decoder on linux
contains( JAHMPEGDECODER,true ) {
message( "Configuring MPEG decoding Support" )
SUBDIRS += jah/encoders/mpegdec
}

#files for Avi support on linux
contains( LINUXAVISUPPORT,true ) {
message( "Configuring linux Avi Support" )
}

#files for Avi support on linux
contains( JAHTHEMES,true ) {
message( "Using Qt Theme Support" )
}

SUBDIRS += jah/Modules/encoder
SUBDIRS += jah

############################################
#options for plugin support
#plugins can always be built manually by
#doing ./configure in the plugins directory

contains(JAHPLUGINBUILD,true) {
message( "Configuring Plugin Support" )
SUBDIRS +=  plugins
}

TEMPLATE = subdirs
CONFIG  += release  warn_on  qt  opengl  thread
message( " " )
message( "Make files have been configured" )
message( "type make to build jahshaka" )
message( "" )
message( "Once jahshaka has compiled" )
message( "type ./jahshaka to run" )
message( "" )
message( "please report bugs on www.jahshaka.com" )
message( "forums->bugs" )
message( "" )
message( "known bugs" )
message( "----------" )
message( "" )
message( "Q: If jahshaka crashes on startup its probably the database" )
message( "A: heres a quick fix" )
message( "cd to the jahshaka home directory then" )
message( "cd database" )
message( "then type ./wipedbase to clear it out" )
message( "your assets will still be on disk but you will have to" )
message( "re-import them onto your desktop" )

contains(JAHPLUGINBUILD,false) {
message( "" )
message( "Dont forget to build the plugins!" )
message( "Just type:" )
message( "cd plugins; ./configure; make" )
}
