/*******************************************************************************
**
** A Jahshaka RasFx Plugin
** The Jahshaka Project
** Copyright (C) 2000-2004 The Jahshaka Project
** This is Open Source Software Released under the LGPL License
**
*******************************************************************************/

#ifndef VFXPLUGIN_H
#define VFXPLUGIN_H


#include "jahplugintemplate.h"
#include <qstring.h>

#include "glew.h"
#include "gpumathlib.h"
#include <qgl.h>

class jahPlugin;

#ifdef Q_WS_WIN
# define MY_EXPORT __declspec(dllexport)
#else
# define MY_EXPORT
#endif

extern "C" { MY_EXPORT jahPlugin* getPluginClass(); }

class MyPlugin : public jahPlugin
{

public:
    MyPlugin()
    {
        initSettings();

        initializePlugin();
    };

    ~MyPlugin()
    {};

    void   initializePlugin();

    void   processImage(void);
    void   processGpuFx(void);
    void   processGpuArbFx(void){}; //not used yet

    //for the turbulence creator
    void  createTurbulenceTextureGPU(int width, int height, float intensity,
                                        int horizontal_mesh_size, int vertical_mesh_size, int number_of_layers);


    //variables for effect
    GLuint      turbulence_texture;
    int*        permutation_table;
    float4*     gradient_table;
};




#endif
